import { AfterViewInit, OnDestroy, OnInit } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { ChrBaseInputComponent } from '../chr-base-input/chr-base-input.component';
import { FileService } from '../../services/files.service';
import { Observable } from 'rxjs';
import { IFile } from '../../models/file';
import { ToastService } from '../../services/toast.service';
import * as i0 from "@angular/core";
export declare class ChrFileInputComponent extends ChrBaseInputComponent implements ControlValueAccessor, OnInit, AfterViewInit, OnDestroy {
    private fileService;
    private toastService;
    /**
     * An array of string that contains each type that should be accepted by the input
     */
    accept: string[];
    /**
     * Whether or not the input should allow multiple file selection
     */
    multiple: boolean;
    valueDisplay: string | null;
    /**
     * Whether or not the progress bar that display a file's conversion progress will be editable by the user
     */
    editable: boolean;
    errors: {
        [index: number]: boolean;
    } | null;
    files: Observable<{
        progress: number;
        file?: IFile;
    }>[];
    constructor(ngControl: NgControl, fileService: FileService, toastService: ToastService);
    writeValue(obj: any | any[]): void;
    ngOnInit(): void;
    protected onFileChange: (event: any) => void;
    protected acceptToString: () => string;
    protected getToAccept: () => string;
    protected changeFileName: (event: any, file?: IFile) => void;
    protected openFile: (index: number, file?: IFile) => void;
    protected removeFile: (index: number, file?: IFile) => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ChrFileInputComponent, [{ optional: true; }, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ChrFileInputComponent, "chr-file-input", never, { "accept": { "alias": "accept"; "required": false; }; "multiple": { "alias": "multiple"; "required": false; }; "editable": { "alias": "editable"; "required": false; }; }, {}, never, never, true, never>;
}
