import { AfterContentChecked, AfterViewInit, ChangeDetectorRef, EventEmitter, OnInit } from '@angular/core';
import { PaginationInstance, PaginationService } from 'ngx-pagination';
import { ChrFormComponent } from '../chr-form/chr-form.component';
import { CookiesService } from '../services/cookie.service';
import { DataService } from '../services/data.service';
import * as i0 from "@angular/core";
export declare class ChrPaginatorComponent implements OnInit, AfterViewInit, AfterContentChecked {
    service: PaginationService;
    private cookieService;
    private dataService;
    private changeDetector;
    private _page;
    private _pageSize;
    get page(): number;
    set page(value: number);
    pageChange: EventEmitter<number>;
    get pageSize(): number;
    set pageSize(value: number);
    get dataSize(): number;
    get currentlyShownSize(): number;
    pageSizeChange: EventEmitter<number>;
    id: string | undefined;
    allowSizeChange: boolean | string;
    pageSizeForm: ChrFormComponent | null;
    instance?: PaginationInstance;
    constructor(service: PaginationService, cookieService: CookiesService, dataService: DataService, changeDetector: ChangeDetectorRef);
    ngAfterContentChecked(): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    previous: () => void;
    next: () => void;
    setPage: (page: number) => void;
    setPageEventHandler: (event: any) => void;
    isFirstPage: () => boolean;
    setPageSize: (pageSize: number) => void;
    setPageSizeEventHandler: (event: any) => void;
    isLastPage: () => boolean;
    lastPage: () => number;
    private emit;
    static ɵfac: i0.ɵɵFactoryDeclaration<ChrPaginatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ChrPaginatorComponent, "app-chr-paginator", never, { "page": { "alias": "page"; "required": false; }; "pageSize": { "alias": "pageSize"; "required": false; }; "id": { "alias": "id"; "required": false; }; "allowSizeChange": { "alias": "allowSizeChange"; "required": false; }; }, { "pageChange": "pageChange"; "pageSizeChange": "pageSizeChange"; }, never, never, true, never>;
}
