import { AfterViewInit, EventEmitter, ChangeDetectorRef, OnInit } from '@angular/core';
import { DatePipe } from '@angular/common';
import { DataService } from '../services/data.service';
import { Color } from '../models/colors';
import * as i0 from "@angular/core";
export type Alignment = 'left' | 'center' | 'right';
export declare const Aligments: {
    [key: string]: string;
};
export interface IChips {
    display: string;
    name: string;
    callback: (entry: any) => string | boolean;
    textColor?: Color;
    backgroundColor?: Color;
}
export interface IColumn {
    display: string;
    alignment?: 'left' | 'center' | 'right';
    chips?: IChips[];
    properties?: string[];
    callback?: Function;
    date?: string;
    isLink?: boolean;
    linkStaticUrl?: string;
}
export interface IComputedRow {
    columns: IComputedColumn[];
}
export interface IComputedColumn {
    label?: string;
    value?: any;
    callback?: Function;
    alignment?: 'left' | 'center' | 'right';
    after?: string;
}
export interface IAction {
    display?: string;
    icon?: string;
    callback: Function;
    disabled?: boolean;
    disabledCallback?: Function;
    color: Color;
}
export declare class ChrTableComponent implements OnInit, AfterViewInit {
    private _date;
    private dataService;
    private changeDetector;
    computedRows?: IComputedRow[];
    columns?: IColumn[];
    private _data;
    get data(): any[] | null;
    set data(value: any[] | null);
    actions?: IAction[];
    isAsc: boolean;
    isAscChange: EventEmitter<boolean>;
    sortBy?: string[];
    sortByChange: EventEmitter<string[]>;
    pageSize: number;
    pageSizeChange: EventEmitter<number>;
    currentPage: number;
    currentPageChange: EventEmitter<number>;
    selectable: boolean;
    selection: any[];
    selectionChange: EventEmitter<any[]>;
    id?: string;
    color: Color;
    textColor: Color;
    private _page;
    currentProperty: any | null;
    currentText: string | null;
    constructor(_date: DatePipe, dataService: DataService, changeDetector: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    protected emitIsAsc(isAsc: any): void;
    protected emitSortBy(sortBy: any): void;
    protected emitPageSize(pageSize: any): void;
    protected emitCurrentPage(currentPage: any): void;
    protected getProperty: (entry: any, properties?: any[]) => any;
    protected getText: (property: any, column: IColumn) => any;
    protected select: (entry: any, event: MouseEvent) => void;
    getSelection: () => any[];
    setSelection: (data: any[]) => void;
    protected contains: (entry: any) => boolean;
    protected getIsAsc: () => boolean;
    protected getSortBy: () => string[] | undefined;
    protected getTextColor: (color?: Color) => string;
    protected getBackgroundColor: (color?: Color) => string;
    protected getContrastTextColor: (color?: Color) => string;
    protected getBorderColor: (color?: Color) => string;
    protected getAlignment: (alignment?: Alignment) => string;
    static ɵfac: i0.ɵɵFactoryDeclaration<ChrTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ChrTableComponent, "app-chr-table, [app-chr-table]", never, { "computedRows": { "alias": "computedRows"; "required": false; }; "columns": { "alias": "columns"; "required": false; }; "data": { "alias": "data"; "required": false; }; "actions": { "alias": "actions"; "required": false; }; "isAsc": { "alias": "isAsc"; "required": false; }; "sortBy": { "alias": "sortBy"; "required": false; }; "pageSize": { "alias": "pageSize"; "required": false; }; "currentPage": { "alias": "currentPage"; "required": false; }; "selectable": { "alias": "selectable"; "required": false; }; "selection": { "alias": "selection"; "required": false; }; "id": { "alias": "id"; "required": false; }; "color": { "alias": "color"; "required": false; }; "textColor": { "alias": "textColor"; "required": false; }; }, { "isAscChange": "isAscChange"; "sortByChange": "sortByChange"; "pageSizeChange": "pageSizeChange"; "currentPageChange": "currentPageChange"; "selectionChange": "selectionChange"; }, never, ["*"], true, never>;
}
