import { OnInit, OnDestroy } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { MatAutocomplete } from '@angular/material/autocomplete';
import { Observable, Subject } from 'rxjs';
import { ChrBaseInputComponent } from '../chr-form/chr-base-input/chr-base-input.component';
import { IInputSearchFilter } from '../chr-search-select/chr-search-select.component';
import * as i0 from "@angular/core";
export declare class ChrTagSelectComponent extends ChrBaseInputComponent implements ControlValueAccessor, OnInit, OnDestroy {
    predicate: boolean;
    autocomplete: MatAutocomplete;
    protected overrideShowResults: boolean;
    filteredModelOptions?: Observable<any>;
    protected textInputValue: string;
    private values;
    placeholder?: string;
    data: any[] | null;
    display?: (entry: any) => string;
    filters?: IInputSearchFilter[];
    /**
     * Callback that will be called on click of a chips. The entry will be passed as parameter.
     * If this callback returns null, the entry will be removed.
     * If this callback returns a different value (by reference (ex: different object)) the entry will be replaced by the new value.
     */
    editCallback?: ((entry: any, subject: Subject<any>) => any | null | void) | null;
    private editSubject;
    /**
     * Callback that will be called BEFORE the value is added with the selected value passed as parameter.
     * If this callback returns null, the entry will NOT be added.
     * This lets you update the value before it's added.
     */
    addCallback?: ((entry: any, subject: Subject<any>) => any | null | void) | null;
    private addSubject;
    /**
     * Callback that will be called during the removal of the value. This will be called with the deleted value passed as parameter.
     */
    removeCallback: ((entry: any) => any | null | void) | null;
    /**
     * Indicate if the input accepts raw text or if the requires the selection to be made from the search list.
     * This defaults to false.
     * If there are neither data nor display function, this defaults to true.
     */
    acceptText: boolean | null;
    constructor(ngControl: NgControl);
    protected filterIndex: number;
    ngOnInit(): void;
    writeValue(obj: any): void;
    protected reset: () => void;
    protected inputChange: (input: string) => void;
    protected getModelDisplay: (model: any) => any;
    protected addFromText: (event: any) => void;
    protected add: (event: any) => void;
    protected edit: (entry: any) => void;
    protected remove(value: any): void;
    protected registerFilters: () => void;
    protected increment: (input: any) => void;
    protected void: () => void;
    protected enableShowPanel: (input: any) => void;
    protected disableShowPanel: () => void;
    protected getTooltip: () => "" | "Appuyez sur 'Enter' pour ajouter la valeur du champs à la liste" | "Entrez un espace pour voir les choix disponibles";
    private _filterModel;
    private _doFilterModelInt;
    private _doFilterModelString;
    private _filterValues;
    static ɵfac: i0.ɵɵFactoryDeclaration<ChrTagSelectComponent, [{ optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ChrTagSelectComponent, "app-chr-tag-select, [app-chr-tag-select]", never, { "placeholder": { "alias": "placeholder"; "required": false; }; "data": { "alias": "data"; "required": false; }; "display": { "alias": "display"; "required": false; }; "filters": { "alias": "filters"; "required": false; }; "editCallback": { "alias": "editCallback"; "required": false; }; "addCallback": { "alias": "addCallback"; "required": false; }; "removeCallback": { "alias": "removeCallback"; "required": false; }; "acceptText": { "alias": "acceptText"; "required": false; }; }, {}, never, ["*"], true, never>;
}
