export interface IMaskConfig {
    mask: string | null;
    showMaskTyped: boolean | null;
    dropSpecialCharacters: boolean | string[] | readonly string[] | null;
    placeHolderCharacter: string | null;
    clearIfNotMatch: boolean | null;
    validation: boolean | null;
    specialCharacters: string[] | readonly string[];
    patterns: {
        [key: string]: {
            pattern: RegExp;
            optional?: boolean;
        };
    };
    prefix: string;
    suffix: string;
    thousandSeparator: string;
    decimalMarker: '.' | ',' | ['.', ','];
    decimalLimit: number | null;
    separatorLimit: string | null;
    hiddenInput: boolean | null;
    leadZeroDateTime: boolean | null;
    allowNegativeNumbers: boolean | null;
}
export declare class MaskConfig implements IMaskConfig {
    mask: string | null;
    showMaskTyped: boolean | null;
    dropSpecialCharacters: boolean | string[] | readonly string[] | null;
    placeHolderCharacter: string | null;
    clearIfNotMatch: boolean | null;
    validation: boolean | null;
    specialCharacters: string[] | readonly string[];
    patterns: {
        [key: string]: {
            pattern: RegExp;
            optional?: boolean;
        };
    };
    prefix: string;
    suffix: string;
    thousandSeparator: string;
    decimalMarker: '.' | ',' | ['.', ','];
    decimalLimit: number | null;
    separatorLimit: string | null;
    hiddenInput: boolean | null;
    leadZeroDateTime: boolean | null;
    allowNegativeNumbers: boolean | null;
    constructor(config?: IMaskConfig | null);
}
