import { Subject } from 'rxjs';
import { IControlValidation } from './chr-validators/base-validator';
export type InputType = 'text' | 'password' | 'textArea' | 'number' | 'date' | 'datetime' | 'searchSelect' | 'tagSelect' | 'color' | 'toggle' | 'file' | 'hidden';
export interface ISearchFilter {
    display: string;
    callback?: Function;
    tooltip?: string;
}
export interface IControl {
    label?: string;
    name: string;
    span?: string;
    width?: 'col' | 'row';
    col?: number;
    row?: number;
    type: InputType;
    accept?: string[];
    debounceTime?: number;
    value?: any;
    data?: any[] | null;
    icon?: string;
    iconCallback?: Function;
    iconCallbackDisabled?: boolean;
    iconTooltip?: string;
    fn?: (object: any) => string;
    filters?: ISearchFilter[];
    validations?: IControlValidation[];
    addCallback?: ((entry: any, subject: Subject<any>) => any | null | void) | null;
    editCallback?: ((entry: any, subject: Subject<any>) => any | null | void) | null;
    removeCallback?: ((entry: any) => any | null | void) | null;
    acceptText?: boolean;
    multiple?: boolean;
    /**
     * Should the file be converted to base64 for sending
     */
    base64?: boolean;
    autofocus?: boolean;
}
