import * as i0 from '@angular/core';
import { Component, Input, Injectable, Directive, EventEmitter, Optional, Output, ViewChild, HostListener, ChangeDetectionStrategy, PLATFORM_ID, Inject, inject, InjectionToken } from '@angular/core';
import { MatButton, MatButtonModule } from '@angular/material/button';
import * as i2 from '@angular/common';
import { CommonModule, AsyncPipe, DatePipe, DATE_PIPE_DEFAULT_OPTIONS, isPlatformBrowser, NgClass } from '@angular/common';
import * as i1$2 from '@angular/router';
import * as i2$1 from '@angular/material/icon';
import { MatIconModule, MatIcon } from '@angular/material/icon';
import * as i3 from '@angular/material/tooltip';
import { MatTooltipModule, MatTooltip } from '@angular/material/tooltip';
import * as i1$1 from '@angular/material/dialog';
import { MatDialogTitle, MatDialogContent, MatDialogActions, MAT_DIALOG_DATA } from '@angular/material/dialog';
export * from '@angular/material/dialog';
import * as i1$3 from '@angular/forms';
import { NG_VALIDATORS, Validators, FormControl, ReactiveFormsModule, FormsModule, FormGroup } from '@angular/forms';
import * as i2$2 from '@angular/material/autocomplete';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { Observable, map, BehaviorSubject, skip, debounceTime, distinctUntilChanged, Subject, startWith, from, mergeMap, toArray, timer, of, catchError, forkJoin, take, skipWhile, tap, finalize as finalize$1 } from 'rxjs';
import { MatOption } from '@angular/material/core';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { MatError } from '@angular/material/form-field';
import moment from 'moment';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import * as i3$2 from '@angular/material/tabs';
import { MatTabsModule } from '@angular/material/tabs';
import * as i3$1 from '@angular/material/chips';
import { MatChipsModule } from '@angular/material/chips';
import { concatMap, takeUntil, finalize, switchMap } from 'rxjs/operators';
import * as i1 from 'ngx-pagination';
import { PaginationService, NgxPaginationModule } from 'ngx-pagination';
export * from 'ngx-pagination';
import { SortPipe } from 'chrv-pipes';
export * from 'chrv-pipes';
import { HubConnectionBuilder, HttpTransportType, LogLevel, HubConnectionState } from '@microsoft/signalr';
import { HttpResponse, provideHttpClient, withInterceptors, withXsrfConfiguration } from '@angular/common/http';
import * as i2$3 from '@angular/platform-browser';
export * from 'ngx-mask';

class BreadcrumbComponent {
    constructor(router) {
        this.router = router;
        this.navigateTo = (uri, data) => {
            this.router.navigate([uri], { state: data });
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: BreadcrumbComponent, deps: [{ token: i1$2.Router }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: BreadcrumbComponent, isStandalone: true, selector: "app-chr-breadcrumb", inputs: { crumbs: "crumbs" }, ngImport: i0, template: "<div class=\"w-full flex flex-row flex-wrap dark:!text-gray-400\">\n  @for (crumb of crumbs; track crumb; let index = $index) {\n  <div class=\"w-fit min-w-fit\">\n    <button class=\"dark:!text-gray-400\" [disabled]=\"!crumb.link && !crumb.callback\" mat-button\n      (click)=\"crumb.callback?.() || crumb.link && navigateTo(crumb.link)\">\n      {{ crumb.display }}\n    </button>\n    <span *ngIf=\"index < (crumbs?.length || 1) - 1\">></span>\n  </div>\n  }\n</div>", styles: ["", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "component", type: MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: BreadcrumbComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-breadcrumb', imports: [MatButton, CommonModule], template: "<div class=\"w-full flex flex-row flex-wrap dark:!text-gray-400\">\n  @for (crumb of crumbs; track crumb; let index = $index) {\n  <div class=\"w-fit min-w-fit\">\n    <button class=\"dark:!text-gray-400\" [disabled]=\"!crumb.link && !crumb.callback\" mat-button\n      (click)=\"crumb.callback?.() || crumb.link && navigateTo(crumb.link)\">\n      {{ crumb.display }}\n    </button>\n    <span *ngIf=\"index < (crumbs?.length || 1) - 1\">></span>\n  </div>\n  }\n</div>", styles: ["*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$2.Router }], propDecorators: { crumbs: [{
                type: Input
            }] } });

const Colors = {
    primary: 'primary',
    'primary-contrast': 'primary-contrast',
    secondary: 'secondary',
    'secondary-contrast': 'secondary-contrast',
    tertiary: 'tertiary',
    'tertiary-contrast': 'tertiary-contrast',
    warn: 'warn',
    'warn-contrast': 'warn-contrast',
    error: 'error',
    'error-contrast': 'error-contrast',
    white: 'white',
    black: 'black',
};
function getTextColor(color = 'none') {
    return `text-${Colors[color] || Colors['black']}`;
}
function getContrastTextColor(color) {
    return getTextColor(`${color}-contrast`);
}
function getBackgroundColor(color = 'none') {
    return `bg-${Colors[color] || Colors['black']}`;
}
function getContrastBackgroundColor(color) {
    return getContrastBackgroundColor(`${color}-contrast`);
}
function getBorderColor(color = 'none') {
    return `border-${Colors[color] || Colors['black']}`;
}
function getContrastBorderColor(color = 'none') {
    return getBorderColor(`${color}-contrast`);
}

class ChrButtonComponent {
    constructor() {
        this.display = '';
        this.icon = '';
        this.color = 'primary';
        this.textColor = 'primary-contrast';
        this.flat = false;
        this.predicate = true;
        this.type = 'none';
        this.disabled = false;
        this.setDisabled = (is) => {
            this.disabled = is;
        };
        this.doClick = () => {
            if (!this.disabled)
                this.click?.();
            else
                this.clickWhileDisabled?.();
        };
        this.getBackgroundColor = (color) => getBackgroundColor(color);
        this.getTextColor = (color) => getContrastTextColor(color);
        this.getWidth = () => {
            switch (this.type) {
                case 'fixed':
                    return 'w-36';
                case 'full':
                    return 'w-full';
                case 'responsive':
                    return 'w-full';
                case 'small':
                    return 'w-9';
                case 'table':
                    return 'w-full';
                default:
                    return 'w-min';
            }
        };
        this.getShadow = () => {
            if (this.flat)
                return '';
            return 'button-shadow';
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.5", type: ChrButtonComponent, isStandalone: true, selector: "app-chr-button", inputs: { display: "display", icon: "icon", click: "click", clickWhileDisabled: "clickWhileDisabled", color: "color", textColor: "textColor", flat: "flat", predicate: "predicate", type: "type", href: "href", target: "target", disabled: "disabled", tooltip: "tooltip", tooltipPosition: "tooltipPosition" }, ngImport: i0, template: "<a class=\"flex flex-row cursor-pointer items-center justify-center align-middle h-9 m-0 p-2 rounded-md\"\n  style=\"--color: {{getBackgroundColor(color)}};\" [ngClass]=\"[getBackgroundColor(color), getWidth(), getShadow()]\"\n  [attr.disabled]=\"disabled || false\" (click)=\"doClick()\" [attr.href]=\"href && href\" [attr.target]=\"target && target\"\n  [matTooltip]=\"tooltip||''\" [matTooltipPosition]=\"tooltipPosition||'above'\">\n  <span *ngIf=\"display\" [ngClass]=\"getTextColor(color)\"\n    class=\"text-nowrap overflow-hidden text-ellipsis\">{{display}}</span>\n  <mat-icon *ngIf=\"icon\" class=\"!m-0\" [ngClass]=\"getTextColor(color)\">{{ icon }}</mat-icon>\n</a>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.icon-button{width:20px!important}.icon-button>*{width:min-content;margin:0!important}.chr-button{color:var(--textcolor)!important}.chr-button.mat-mdc-button-disabled{color:#00000042}@media (min-width: 640px){.small-button{width:2.25rem;height:2.25rem}}.small-button{min-width:38px!important;padding:0!important}a:hover{filter:brightness(120%)}a[disabled=true]{background-color:#00000042!important;cursor:not-allowed}.button-shadow{box-shadow:1px 6px 10px #0003}@media (prefers-color-scheme: dark){a[disabled=true]{background-color:#fafafa42!important}a[disabled=true]>*{color:#c8c8c88a!important}a:hover{filter:brightness(80%)}}a[disabled=true]>*{color:#0000008a!important}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-button', imports: [MatTooltipModule, MatIconModule, MatButtonModule, CommonModule], template: "<a class=\"flex flex-row cursor-pointer items-center justify-center align-middle h-9 m-0 p-2 rounded-md\"\n  style=\"--color: {{getBackgroundColor(color)}};\" [ngClass]=\"[getBackgroundColor(color), getWidth(), getShadow()]\"\n  [attr.disabled]=\"disabled || false\" (click)=\"doClick()\" [attr.href]=\"href && href\" [attr.target]=\"target && target\"\n  [matTooltip]=\"tooltip||''\" [matTooltipPosition]=\"tooltipPosition||'above'\">\n  <span *ngIf=\"display\" [ngClass]=\"getTextColor(color)\"\n    class=\"text-nowrap overflow-hidden text-ellipsis\">{{display}}</span>\n  <mat-icon *ngIf=\"icon\" class=\"!m-0\" [ngClass]=\"getTextColor(color)\">{{ icon }}</mat-icon>\n</a>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.icon-button{width:20px!important}.icon-button>*{width:min-content;margin:0!important}.chr-button{color:var(--textcolor)!important}.chr-button.mat-mdc-button-disabled{color:#00000042}@media (min-width: 640px){.small-button{width:2.25rem;height:2.25rem}}.small-button{min-width:38px!important;padding:0!important}a:hover{filter:brightness(120%)}a[disabled=true]{background-color:#00000042!important;cursor:not-allowed}.button-shadow{box-shadow:1px 6px 10px #0003}@media (prefers-color-scheme: dark){a[disabled=true]{background-color:#fafafa42!important}a[disabled=true]>*{color:#c8c8c88a!important}a:hover{filter:brightness(80%)}}a[disabled=true]>*{color:#0000008a!important}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [], propDecorators: { display: [{
                type: Input
            }], icon: [{
                type: Input
            }], click: [{
                type: Input
            }], clickWhileDisabled: [{
                type: Input
            }], color: [{
                type: Input
            }], textColor: [{
                type: Input
            }], flat: [{
                type: Input
            }], predicate: [{
                type: Input
            }], type: [{
                type: Input
            }], href: [{
                type: Input
            }], target: [{
                type: Input
            }], disabled: [{
                type: Input
            }], tooltip: [{
                type: Input
            }], tooltipPosition: [{
                type: Input
            }] } });

class ChrDeleteModalComponent {
    constructor(dialogRef) {
        this.dialogRef = dialogRef;
        this.valid = false;
        this.cancel = () => {
            this.dialogRef.close();
        };
        this.close = () => {
            this.dialogRef.close(true);
        };
    }
    ngOnInit() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDeleteModalComponent, deps: [{ token: i1$1.MatDialogRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.5", type: ChrDeleteModalComponent, isStandalone: true, selector: "app-chr-delete-modal", ngImport: i0, template: "<div class=\"w-full overflow-auto overflow-x-hidden\" style=\"background-color: var(--background-color);\">\n    <h2 mat-dialog-title class=\"\">Supprimer un \u00E9l\u00E9ment</h2>\n    <mat-dialog-content class=\"mat-typography \">\n        Attention:\n        <br>\n        <br>\n        La suppression d'un \u00E9l\u00E9ment est irr\u00E9versible.\n        <br>\n        <br>\n        Vous allez supprimer un \u00E9l\u00E9ment et sa r\u00E9f\u00E9rence sera effac\u00E9e dans toute l'application.\n        <br>\n        Si d'autres \u00E9l\u00E9ments y sont li\u00E9s, il est possible qu'ils soient supprim\u00E9s en m\u00EAme temps.\n        <br>\n        <br>\n        En effectuant cette action et cliquant sur \"Confirmer\" vous certifiez que vous avez pris connaissance des\n        cons\u00E9quences possibles et souhaitez tout de m\u00EAme poursuivre.\n\n    </mat-dialog-content>\n    <mat-dialog-actions>\n        <div class=\"w-full flex flex-row justify-between\">\n            <app-chr-button display=\"Annuler\" type=\"fixed\" color=\"secondary\" [click]=\"cancel\"></app-chr-button>\n            <app-chr-button display=\"Confirmer\" type=\"fixed\" color=\"error\" [click]=\"close\"\n                [matTooltip]=\"'Attention: cette action est irr\u00E9versible !'\" matTooltipPosition=\"above\"></app-chr-button>\n        </div>\n    </mat-dialog-actions>\n</div>", styles: ["", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "directive", type: MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "component", type: ChrButtonComponent, selector: "app-chr-button", inputs: ["display", "icon", "click", "clickWhileDisabled", "color", "textColor", "flat", "predicate", "type", "href", "target", "disabled", "tooltip", "tooltipPosition"] }, { kind: "directive", type: MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDeleteModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-delete-modal', imports: [
                        MatDialogTitle,
                        MatDialogContent,
                        MatDialogActions,
                        ChrButtonComponent,
                        MatTooltip,
                    ], template: "<div class=\"w-full overflow-auto overflow-x-hidden\" style=\"background-color: var(--background-color);\">\n    <h2 mat-dialog-title class=\"\">Supprimer un \u00E9l\u00E9ment</h2>\n    <mat-dialog-content class=\"mat-typography \">\n        Attention:\n        <br>\n        <br>\n        La suppression d'un \u00E9l\u00E9ment est irr\u00E9versible.\n        <br>\n        <br>\n        Vous allez supprimer un \u00E9l\u00E9ment et sa r\u00E9f\u00E9rence sera effac\u00E9e dans toute l'application.\n        <br>\n        Si d'autres \u00E9l\u00E9ments y sont li\u00E9s, il est possible qu'ils soient supprim\u00E9s en m\u00EAme temps.\n        <br>\n        <br>\n        En effectuant cette action et cliquant sur \"Confirmer\" vous certifiez que vous avez pris connaissance des\n        cons\u00E9quences possibles et souhaitez tout de m\u00EAme poursuivre.\n\n    </mat-dialog-content>\n    <mat-dialog-actions>\n        <div class=\"w-full flex flex-row justify-between\">\n            <app-chr-button display=\"Annuler\" type=\"fixed\" color=\"secondary\" [click]=\"cancel\"></app-chr-button>\n            <app-chr-button display=\"Confirmer\" type=\"fixed\" color=\"error\" [click]=\"close\"\n                [matTooltip]=\"'Attention: cette action est irr\u00E9versible !'\" matTooltipPosition=\"above\"></app-chr-button>\n        </div>\n    </mat-dialog-actions>\n</div>", styles: ["*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$1.MatDialogRef }] });

const rotationAnimation = (initialAngle = 0, endAngle = 360, duration = 500) => trigger('rotationAnimation', [
    state('initial', style({
        transform: `rotate(${initialAngle}deg)`,
    })),
    state('rotated', style({
        transform: `rotate(${endAngle}deg)`,
    })),
    transition('initial => rotated', [
        //style({ opacity: 0 }),
        animate(`${duration}ms ease`),
    ]),
    transition('rotated => initial', [
        //style({ opacity: 1 }),
        animate(`${duration}ms ease`),
    ]),
]);

class RequiredValidatorDirective {
    constructor() {
        this.required = true;
    }
    validate(control) {
        return this.required ? required(this.required)(control) : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: RequiredValidatorDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: RequiredValidatorDirective, isStandalone: true, selector: "[app-required]", inputs: { required: "required" }, providers: [
            {
                provide: NG_VALIDATORS,
                useExisting: RequiredValidatorDirective,
                multi: true,
            },
        ], ngImport: i0 }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: RequiredValidatorDirective, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: RequiredValidatorDirective, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }, {
            type: Directive,
            args: [{
                    selector: '[app-required]',
                    providers: [
                        {
                            provide: NG_VALIDATORS,
                            useExisting: RequiredValidatorDirective,
                            multi: true,
                        },
                    ],
                    standalone: true,
                }]
        }], propDecorators: { required: [{
                type: Input
            }] } });
function required(required = true) {
    return (control) => {
        const value = control.value;
        const isBoolean = typeof value === 'boolean';
        const isValueValidBoolean = value === true || value === false;
        if (isBoolean && isValueValidBoolean)
            return null;
        if (value === 0)
            return null;
        // Technically this should only send the error if the value is null, undefined or if it is a falsy value that isn't handled
        return !control.value
            ? {
                required: true,
            }
            : null;
    };
}

class TypeValidatorDirective {
    validate(control) {
        return this.type ? type(this.type)(control) : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TypeValidatorDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: TypeValidatorDirective, isStandalone: true, selector: "[app-type]", inputs: { type: "type" }, providers: [
            {
                provide: NG_VALIDATORS,
                useExisting: TypeValidatorDirective,
                multi: true,
            },
        ], ngImport: i0 }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TypeValidatorDirective, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TypeValidatorDirective, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }, {
            type: Directive,
            args: [{
                    selector: '[app-type]',
                    providers: [
                        {
                            provide: NG_VALIDATORS,
                            useExisting: TypeValidatorDirective,
                            multi: true,
                        },
                    ],
                    standalone: true,
                }]
        }], propDecorators: { type: [{
                type: Input
            }] } });
function type(type) {
    return (control) => {
        const value = control.value;
        if (!value) {
            return null;
        }
        let isType = typeof value === type;
        if (type === 'array')
            isType =
                typeof value !== 'string' &&
                    value?.length !== undefined &&
                    value?.length !== null;
        return !isType
            ? {
                type: true,
                requiredType: type,
                actualType: typeof value,
            }
            : null;
    };
}

class DecimalValidatorDirective {
    validate(control) {
        return this.amount ? decimal(this.amount)(control) : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: DecimalValidatorDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: DecimalValidatorDirective, isStandalone: true, selector: "[app-decimal]", inputs: { amount: "amount" }, providers: [
            {
                provide: NG_VALIDATORS,
                useExisting: DecimalValidatorDirective,
                multi: true,
            },
        ], ngImport: i0 }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: DecimalValidatorDirective, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: DecimalValidatorDirective, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }, {
            type: Directive,
            args: [{
                    selector: '[app-decimal]',
                    providers: [
                        {
                            provide: NG_VALIDATORS,
                            useExisting: DecimalValidatorDirective,
                            multi: true,
                        },
                    ],
                    standalone: true,
                }]
        }], propDecorators: { amount: [{
                type: Input
            }] } });
function decimal(amount) {
    return (control) => {
        const value = control.value;
        if (!value) {
            return null;
        }
        let isTooLong = false;
        const str = `${value}`;
        isTooLong =
            str.indexOf(',') != -1
                ? (str.split(',')[1] ? str.split(',')[1].length : 0) > amount
                : str.indexOf('.') != -1
                    ? (str.split('.')[1] ? str.split('.')[1].length : 0) > amount
                    : false;
        return isTooLong
            ? {
                decimal: true,
                max: amount,
            }
            : null;
    };
}

class MaxDateValidatorDirective {
    validate(control) {
        return this.date ? maxDate(this.date)(control) : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MaxDateValidatorDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: MaxDateValidatorDirective, isStandalone: true, selector: "[app-max-date]", inputs: { date: "date" }, providers: [
            {
                provide: NG_VALIDATORS,
                useExisting: MaxDateValidatorDirective,
                multi: true,
            },
        ], ngImport: i0 }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MaxDateValidatorDirective, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MaxDateValidatorDirective, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }, {
            type: Directive,
            args: [{
                    selector: '[app-max-date]',
                    providers: [
                        {
                            provide: NG_VALIDATORS,
                            useExisting: MaxDateValidatorDirective,
                            multi: true,
                        },
                    ],
                    standalone: true,
                }]
        }], propDecorators: { date: [{
                type: Input
            }] } });
function maxDate(date) {
    return (control) => {
        const value = control.value;
        if (!value) {
            return null;
        }
        const maxDate = moment(date);
        const inputDate = moment(value);
        return !(inputDate.isValid() && inputDate.isBefore(maxDate))
            ? {
                maxdate: true,
                max: maxDate.toDate(),
                actual: value,
            }
            : null;
    };
}

class MaxFileSizeValidator {
    constructor() {
        this.max = 0;
    }
    validate(control) {
        return this.max ? maxFileSize(this.max)(control) : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MaxFileSizeValidator, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: MaxFileSizeValidator, isStandalone: true, selector: "[app-max-file-size]", inputs: { max: "max" }, providers: [
            {
                provide: NG_VALIDATORS,
                useExisting: MaxFileSizeValidator,
                multi: true,
            },
        ], ngImport: i0 }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MaxFileSizeValidator, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MaxFileSizeValidator, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }, {
            type: Directive,
            args: [{
                    selector: '[app-max-file-size]',
                    providers: [
                        {
                            provide: NG_VALIDATORS,
                            useExisting: MaxFileSizeValidator,
                            multi: true,
                        },
                    ],
                    standalone: true,
                }]
        }], propDecorators: { max: [{
                type: Input
            }] } });
function maxFileSize(maxSize) {
    return (control) => {
        const value = control.value;
        const sizeInBytes = maxSize * 1024 * 1024;
        let isSizeCompliant = true;
        const errors = {};
        let fileSize = null;
        if (value === null)
            return null;
        if (Array.isArray(value)) {
            for (let i = 0; i < value.length; i++) {
                if (!value[i].file)
                    continue;
                if (value[i].file.size > sizeInBytes) {
                    errors[i] = true;
                    isSizeCompliant = false;
                }
            }
        }
        else {
            if (!value.file)
                return null;
            fileSize =
                (value instanceof File ? value.size : value.file?.size) ?? null;
            isSizeCompliant = fileSize !== null && fileSize < sizeInBytes;
        }
        return !isSizeCompliant
            ? {
                maxfilesize: true,
                max: sizeInBytes,
                actual: fileSize,
                indexes: errors,
            }
            : null;
    };
}

class MinFileSizeValidator {
    constructor() {
        this.min = 0;
    }
    validate(control) {
        return this.min ? minFileSize(this.min)(control) : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MinFileSizeValidator, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: MinFileSizeValidator, isStandalone: true, selector: "[app-min-file-size]", inputs: { min: "min" }, providers: [
            {
                provide: NG_VALIDATORS,
                useExisting: MinFileSizeValidator,
                multi: true,
            },
        ], ngImport: i0 }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MinFileSizeValidator, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MinFileSizeValidator, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }, {
            type: Directive,
            args: [{
                    selector: '[app-min-file-size]',
                    providers: [
                        {
                            provide: NG_VALIDATORS,
                            useExisting: MinFileSizeValidator,
                            multi: true,
                        },
                    ],
                    standalone: true,
                }]
        }], propDecorators: { min: [{
                type: Input
            }] } });
function minFileSize(minSize) {
    return (control) => {
        const value = control.value;
        const sizeInBytes = minSize * 1024 * 1024;
        let isSizeCompliant = true;
        const errors = {};
        let fileSize = null;
        //console.log(value);
        if (value === null)
            return null;
        if (Array.isArray(value)) {
            for (let i = 0; i < value.length; i++) {
                if (!value[i].file)
                    continue;
                if (value[i].file.size <= sizeInBytes) {
                    errors[i] = true;
                    isSizeCompliant = false;
                }
            }
        }
        else {
            if (!value.file)
                return null;
            fileSize =
                (value instanceof File ? value.size : value.file?.size) ?? null;
            isSizeCompliant = fileSize !== null && fileSize >= sizeInBytes;
        }
        return !isSizeCompliant
            ? {
                minfilesize: true,
                min: sizeInBytes,
                actual: fileSize,
                indexes: errors,
            }
            : null;
    };
}

class MaxLengthValidatorDirective {
    validate(control) {
        return this.treshold ? maxLength(this.treshold)(control) : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MaxLengthValidatorDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: MaxLengthValidatorDirective, isStandalone: true, selector: "[app-maxlength]", inputs: { treshold: "treshold" }, providers: [
            {
                provide: NG_VALIDATORS,
                useExisting: MaxLengthValidatorDirective,
                multi: true,
            },
        ], ngImport: i0 }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MaxLengthValidatorDirective, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MaxLengthValidatorDirective, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }, {
            type: Directive,
            args: [{
                    selector: '[app-maxlength]',
                    providers: [
                        {
                            provide: NG_VALIDATORS,
                            useExisting: MaxLengthValidatorDirective,
                            multi: true,
                        },
                    ],
                    standalone: true,
                }]
        }], propDecorators: { treshold: [{
                type: Input
            }] } });
function maxLength(treshold) {
    return (control) => {
        const value = control.value;
        if (!value) {
            return null;
        }
        let isTooLong = value.length > treshold;
        return isTooLong
            ? {
                maxlength: true,
                max: treshold,
            }
            : null;
    };
}

class MinLengthValidatorDirective {
    validate(control) {
        return this.treshold ? minLength(this.treshold)(control) : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MinLengthValidatorDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: MinLengthValidatorDirective, isStandalone: true, selector: "[app-minlength]", inputs: { treshold: "treshold" }, providers: [
            {
                provide: NG_VALIDATORS,
                useExisting: MinLengthValidatorDirective,
                multi: true,
            },
        ], ngImport: i0 }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MinLengthValidatorDirective, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: MinLengthValidatorDirective, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }, {
            type: Directive,
            args: [{
                    selector: '[app-minlength]',
                    providers: [
                        {
                            provide: NG_VALIDATORS,
                            useExisting: MinLengthValidatorDirective,
                            multi: true,
                        },
                    ],
                    standalone: true,
                }]
        }], propDecorators: { treshold: [{
                type: Input
            }] } });
function minLength(treshold) {
    return (control) => {
        const value = control.value;
        if (!value) {
            return null;
        }
        let isTooLong = value.length < treshold;
        return isTooLong
            ? {
                minlength: true,
                min: treshold,
            }
            : null;
    };
}

function SyncValidatorToAsync(validator) {
    // COPILOT Generated. Switch to observable and try to replace regular validators.
    return (control) => {
        const obs = new Observable().pipe(map((res) => validator(control)));
        return obs;
    };
}
function getValidators(rules) {
    return getSyncValidators(rules);
}
function getAsyncValidators(rules) {
    return getSyncValidators(rules).map((validator) => SyncValidatorToAsync(validator));
}
function getSyncValidators(rules) {
    const validators = [];
    if (!rules)
        return validators;
    //Switch case breaks the mobile app so we'll do if statements
    for (const validation of rules) {
        if (validation.validator !== undefined) {
            validators.push(validation.validator);
            continue;
        }
        const rule = validation.rule?.toLocaleLowerCase();
        if (rule == 'min') {
            validation.display = `Cette valeur est trop petite (min: ${validation.value})!`;
            validators.push(Validators.min(validation.value));
        }
        if (rule == 'max') {
            validation.display = `Cette valeur est trop grande (max: ${validation.value})!`;
            validators.push(Validators.max(validation.value));
        }
        if (rule == 'required') {
            validation.display = 'Ce champs est requis !';
            validators.push(required());
        }
        if (rule == 'email') {
            validation.display = "Cette adresse email n'est pas valide !";
            validators.push(Validators.email);
        }
        if (rule == 'minlength') {
            validation.display = `Cette valeur est trop petite (min: ${validation.value})!`;
            validators.push(minLength(validation.value));
        }
        if (rule == 'maxlength') {
            validation.display = `Cette valeur est trop grande (max: ${validation.value})!`;
            validators.push(maxLength(validation.value));
        }
        if (rule == 'type') {
            validation.display = "Cette valeur n'est pas valide !";
            validators.push(type(validation.value));
        }
        if (rule == 'decimal') {
            validation.display = `Le nombre de décimal n'est pas valide (max: ${validation.value}) !`;
            validators.push(decimal(validation.value));
        }
        if (rule == 'maxdate') {
            validation.display = `Cette date est trop grande (max: ${validation.value}) !`;
            validators.push(maxDate(validation.value));
        }
        if (rule == 'maxfilesize') {
            validation.display = `Ce fichier est trop grand (max: ${validation.value} Mb) !`;
            validators.push(maxFileSize(validation.value));
        }
        if (rule == 'minfilesize') {
            validation.display = `Ce fichier est trop petit (min: ${validation.value} Mb) !`;
            validators.push(minFileSize(validation.value));
        }
    }
    return validators;
}

class AutofocusDirective {
    constructor(host) {
        this.host = host;
        this.chrAutofocus = false;
    }
    ngAfterViewInit() {
        if (this.chrAutofocus === true)
            this.host.nativeElement.focus();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: AutofocusDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: AutofocusDirective, isStandalone: true, selector: "[chrAutofocus]", inputs: { chrAutofocus: "chrAutofocus" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: AutofocusDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[chrAutofocus]',
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { chrAutofocus: [{
                type: Input
            }] } });

/**
 * BaseInput Component. Gives signature and default funtionnalities required for a basic input with debounce time.
 *
 * Any class inheriting BaseInput and being used outside a ReactiveForm will genereate it's own FormControl for validation's sake.
 * Ensure you are correctly using [form] | [formGroup] | [formControlName] otherwise.
 *
 * Any class inheriting BaseInput should implements, at least, the ControlValueAccessor, OnInit, AfterViewInit and OnDestroy interfaces.
 * Any child class that override the OnInit, AfterViewInit, OnDestroy interfaces should call the assaociated super method.
 */
class ChrBaseInputComponent {
    get value() {
        return this._value;
    }
    set value(value) {
        this._value = value;
    }
    /**
     * Getter and setter that allow the control of the FormControl's state from the template
     */
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = value;
        if (value)
            this.control?.control?.disable();
        else
            this.control?.control?.enable();
    }
    /**
     * Every child should either call super(ngControl) or implement the logic for the input to bind the control to the FormControl.
     * @param ngControl the FormControl binded to this CVA
     */
    constructor(ngControl) {
        /**
         * The label that will be shown to the user for this input.
         */
        this.label = null;
        /**
         * The type of the input. The BaseInput class is designed to be used for the basic text/number/password/hidden types. Any other kind of input would probably benefit of a custom component inheriting BaseInput.
         */
        this.type = 'text';
        /**
         * The id of the input.
         */
        this.id = null;
        /**
         * The name of the input. It's the model's property name or the key that will be set to the value object
         */
        this.name = null;
        this._value = null;
        this.valueSubject = new BehaviorSubject(null);
        this.valueSubscription = null;
        /**
         * The value change event. This will be triggered both by onChange and by onValueChange (they technically should not be fired together as onValueChange ends up calling onChange)
         */
        this.valueChanges = new EventEmitter();
        /**
         * Whether or not the input is required
         */
        this.required = false;
        /**
         * Span that will be shown under the input
         */
        this.span = null;
        /**
         * Name of the material icon that will be displayed
         */
        this.icon = null;
        /**
         * A callback function that will be triggered on the input's icon click with the current value of the input
         */
        this.iconCallback = null;
        /**
         * Whether or not the icon's callback is enabled
         */
        this.iconCallbackDisabled = false;
        /**
         * Tooltip that will be displayed when hovering the input's icon
         */
        this.iconTooltip = null;
        /**
         * Tooltip that will be displayed on hover
         */
        this.tooltip = null;
        /**
         * Validations that will be evaluated for the input. In the case of custom validator function, the return object needs to contain a key with the 'rule' and it's value needs to be 'true'
         */
        this.validations = [];
        /**
         * Indicates whether or not this input is being used outside a ReactiveForm. Default is false. If this is false, the input will create it's own FormControl as to enable it's complex behaviors
         */
        this.standalone = false;
        /**
         * Indicates whether or not this input should try catching the focus on page load
         */
        this.autofocus = false;
        /**
         * Indicates whether or not this input should convert the file to base64 for it to be sent as part of the object.
         * If this is false, the file won't be converted and will be sent as part as the regular form process.
         * Default is true to allow full JS manipulation of files et upload progress report.
         */
        this.base64 = true;
        // @Input() mask: string | null = null;
        this._disabled = false;
        /**
         * Whether or not the input starts as disabled. This can then be changed through the form control.
         */
        this.isDisabled = false;
        /**
         * Array of string representing the input's siblings' FormControl's name. This will be used to trigger the validity of the siblings when this input's value changes
         */
        this.siblings = [];
        this.onChange = () => { };
        this.onTouch = () => { };
        /**
         * Whether or not the input is touched
         */
        this.isTouched = false;
        /**
         * The NgControl associated with this input
         */
        this.control = null;
        /**
         * The validity status of the related FormControl
         */
        this.isValid = this.control ? this.control.valid : null;
        /**
         * A method that returns the input's value. If it's linked to a formcontrol returns the formcontrol's value otherwise the local value
         * @returns value any
         */
        this.getValue = () => {
            return this.control ? this.control.value : this.value;
        };
        /**
         * A method that can be used instead of onChange(value). It will pass the new value to an observable that will in turn add a debounce time then call the onchange function.
         *
         * In short, using this method instead of onChange will add a debounce time.
         * @param value The new value of the input
         * @returns the value observable
         */
        this.onValueChange = (value) => {
            console.log(`[BaseInput] ${this.name} - onValueChange called with value: ${value} of type ${typeof value} for input type: ${this.type} - touched: ${this.isTouched} - error: ${this.getLastError()} - control errors: `, this.control?.errors);
            this.valueSubject.next(value);
            return this.valueSubscription;
        };
        this.updateValueAndValidity = () => {
            this.control?.control?.updateValueAndValidity();
        };
        /**
         * Despite it's name, this method returns a single validation error's display (even if there are multiple). And that is the first error found.
         * @returns display of the last error
         */
        this.getLastError = () => {
            for (const validation of this.validations ?? []) {
                if (this.control?.errors?.[validation.rule.toLowerCase()]) {
                    return validation.display || "Cette valeur n'est pas valide !";
                }
            }
            return null;
        };
        /**
         * Returns a boolean describing whether or not the control is required
         * @returns
         */
        this.isControlRequired = () => {
            return (this.validations?.some((v) => v.rule?.toLowerCase().includes('required')) || false);
        };
        /**
         * Returns the current error status of the input.
         * @returns
         */
        this.hasError = () => {
            return this.control?.errors !== undefined && this.control?.errors !== null;
        };
        // @HostListener('input', ['$event'])
        // onInput(event: Event) {
        //   const input = event.target as HTMLInputElement;
        //   if (this.mask) {
        //     const maskedValue = this.applyMask(input.value, this.mask);
        //     input.value = maskedValue;
        //     this.onValueChange(maskedValue); // envoie avec debounce
        //   } else {
        //     this.onValueChange(input.value);
        //   }
        // }
        // private applyMask(value: string, mask: string): string {
        //   const raw = value.replace(/[^a-zA-Z0-9]/g, '');
        //   let result = '';
        //   let rawIndex = 0;
        //   for (let i = 0; i < mask.length && rawIndex < raw.length; i++) {
        //     const maskChar = mask[i];
        //     const rawChar = raw[rawIndex];
        //     if (maskChar === 'd') {
        //       if (/\d/.test(rawChar)) {
        //         result += rawChar;
        //         rawIndex++;
        //       } else {
        //         rawIndex++;
        //         i--;
        //       }
        //     } else if (maskChar === 'w') {
        //       if (/[a-z]/i.test(rawChar)) {
        //         result += rawChar.toLowerCase();
        //         rawIndex++;
        //       } else {
        //         rawIndex++;
        //         i--;
        //       }
        //     } else if (maskChar === 'W') {
        //       if (/[a-z]/i.test(rawChar)) {
        //         result += rawChar.toUpperCase();
        //         rawIndex++;
        //       } else {
        //         rawIndex++;
        //         i--;
        //       }
        //     } else {
        //       result += maskChar;
        //     }
        //   }
        //   return result;
        // }
        this.configureDebouncing = () => {
            this.valueSubscription = this.valueSubject
                .pipe(
            // The Behavior Subject always has an initial value. Which means that subscribing to it will make it look like the input has a new value (initially null).
            // Which is false, because we're only instanciating the object. This is why we need to skip the first value. Otherwise the form will receive a random null when this
            // observable is subscribed to and set the value to said null.
            skip(1), debounceTime(this.debounceTime ?? 200), distinctUntilChanged())
                .subscribe((res) => {
                // If the value is an empty string, set the value to null to trigger validation and prevent an inconsitent value to be set (ex: for number type input)
                let value = typeof res === 'string' && res.trim() === '' ? null : res;
                // console.log(
                //   `[BaseInput] ${
                //     this.name
                //   } - valueSubject emitted value: ${res} (actual: ${value}) of type ${typeof res} (actual: ${typeof value}) for input type: ${
                //     this.type
                //   }`
                // );
                // If we use the input type numbe, we cast the value to a number because for some reason, it may sometimes be a string.
                if (this.type === 'number' && value !== null)
                    value = Number(value);
                // console.log(
                //   `[BaseInput] ${
                //     this.name
                //   } - value after type casting: ${value} of type ${typeof value}`
                // );
                this.onChange(value);
                this.valueChanges.emit(value);
            });
        };
        this.configureTouchBehavior = () => {
            //We ensure that the control is marked as touched when it's status changes. We could probably limit the onTouch to one or two specifics statuses but I did not test further
            //As it seems to work fine. This is made to work around the fact that trigger the markAsTouched function via the form doesn't trigger the onTouch of the ControlValueAccessor
            this.control?.statusChanges?.subscribe((res) => {
                if (this.control?.touched)
                    this.onTouch();
            });
        };
        this.configureValidityReplication = () => {
            this.control?.valueChanges?.subscribe((value) => {
                for (const sibling of this.siblings) {
                    this.control?.control?.parent?.get(sibling)?.updateValueAndValidity();
                }
            });
        };
        this.configureFormControl = () => {
            if (this.control !== null && this.standalone)
                throw "You should not use 'BaseInput' or it's derivative in standalone mode within a ReactiveForm";
            //If the input is standalone and no control has been injected we create one
            if (this.control === null && this.standalone) {
                this.control = this.buildFormControl();
                //We define this component as the control's value accessor
                this.control.valueAccessor = this;
            }
            // This code allow the correct binding of the standalone input with the FormControl. However it causes unhandleable validation errors
            // This behavior is hacky and should not be supported anyway.
            // if (this.control !== null && this.isStandalone) {
            //   const formControlName = this.control as FormControlName;
            //   const formDirective = formControlName.formDirective as FormGroupDirective;
            //   const form = formDirective.form;
            //   const control = this.buildFormControl();
            //   form.addControl(this.name!, control);
            //   formDirective.addControl(formControlName);
            // }
            //If the input is not standlone, we should have had a NgControl injected in the constructor
            if (!this.standalone) {
                //We add the validators to the input.
                this.control?.control?.setValidators(getValidators(this.validations));
            }
            //The input's validity is evaluated once on HTML and FormControl binding. As we are acting outside this behavior, we trigger the validation once here
            this.updateValueAndValidity();
        };
        this.buildFormControl = () => {
            return new FormControl(null, getSyncValidators(this.validations));
        };
        this.doCallback = () => {
            if (this.iconCallbackDisabled)
                return;
            this.iconCallback?.(this.getValue());
        };
        this.control = ngControl;
        if (this.control != null) {
            this.control.valueAccessor = this;
        }
    }
    /**
     * A callback method that is invoked immediately after the default change detector has checked the directive's data-bound properties for the first time, and before any of the view or content children have been checked. It is invoked only once when the directive is instantiated.
     * In the case of the BaseInput class, this methods also subscribes to the onValueChange's subject as to register the debounce time.
     *
     * To use in any component inheriting the BaseInput Class, please call super.ngOnInit() at any point within the overriden ngOnInit() method.
     */
    ngOnInit() {
        //We start by configuring the control. This will set missing NgControl and validators if required
        this.configureFormControl();
        //Configure the listener that will trigger on OnValueChange call to write value and replicate events
        this.configureDebouncing();
        //Configure the listener that will trigger when OnTouch is called
        this.configureTouchBehavior();
        //Configure the listener that will trigger a validity check for this input's siblings
        this.configureValidityReplication();
        //We compute the required-ness of the input only once
        this.required = this.isControlRequired();
    }
    /**
     * A callback method that is invoked immediately after Angular has completed initialization of a component's view. It is invoked only once when the view is instantiated.
     *
     * To use in any component inheriting the BaseInput Class, please call super.ngAfterViewInit() at any point within the overriden ngAfterViewInit() method.
     */
    ngAfterViewInit() {
        // const ngControl: NgControl | null = this.injector.get(NgControl, null);
        // console.log(ngControl);
    }
    /**
     * A callback method that performs custom clean-up, invoked immediately before a directive, pipe, or service instance is destroyed.
     * In the case of the BaseInput class, this methods also unsubscribe to the onValueChange's subject as to avoid leaving a stray observable.
     *
     * To use in any component inheriting the BaseInput Class, please call super.ngOnDestroy() at any point within the overriden ngOnDestroy() method.
     */
    ngOnDestroy() {
        this.valueSubscription?.unsubscribe();
    }
    writeValue(obj) {
        this.value = obj;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouch = () => {
            this.isTouched = true;
            fn();
        };
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrBaseInputComponent, deps: [{ token: i1$3.NgControl, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrBaseInputComponent, isStandalone: true, selector: "chr-base-input", inputs: { label: "label", type: "type", id: "id", name: "name", span: "span", icon: "icon", iconCallback: "iconCallback", iconCallbackDisabled: "iconCallbackDisabled", iconTooltip: "iconTooltip", tooltip: "tooltip", debounceTime: "debounceTime", validations: "validations", standalone: "standalone", autofocus: "autofocus", base64: "base64", disabled: "disabled", siblings: "siblings" }, outputs: { valueChanges: "valueChanges" }, providers: [
        // REMOVED FROM PROVIDERS TO AVOID A CYCLIC DEPENDENCY. We will manually bind the controlValueAccessor of the NgControl when we receive it from the DI Context.
        // {
        //   provide: NG_VALUE_ACCESSOR,
        //   useExisting: forwardRef(() => ChrBaseInputComponent),
        //   multi: true,
        // },
        ], ngImport: i0, template: "<div style=\"position: relative;\">\r\n    <input class=\"relative\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\" [chrAutofocus]=\"autofocus || false\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" [(ngModel)]=\"value\"\r\n        (ngModelChange)=\"onValueChange($event)\" [type]=\"type\" [id]=\"name\" [name]=\"name ?? ''\"\r\n        [attr.autocomplete]=\"type == 'password' ? 'current-password':''\" placeholder=\" \"\r\n        class=\"block input pt-2 pb-0.5 px-0 w-full height-normalized text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0  peer/inputs\" />\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute\">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':'cursor-pointer'\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\" (click)=\"doCallback()\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError() ? 'text-span text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1$3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrBaseInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'chr-base-input', imports: [
                        ReactiveFormsModule,
                        CommonModule,
                        MatError,
                        FormsModule,
                        MatIcon,
                        MatTooltipModule,
                        AutofocusDirective,
                    ], providers: [
                    // REMOVED FROM PROVIDERS TO AVOID A CYCLIC DEPENDENCY. We will manually bind the controlValueAccessor of the NgControl when we receive it from the DI Context.
                    // {
                    //   provide: NG_VALUE_ACCESSOR,
                    //   useExisting: forwardRef(() => ChrBaseInputComponent),
                    //   multi: true,
                    // },
                    ], template: "<div style=\"position: relative;\">\r\n    <input class=\"relative\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\" [chrAutofocus]=\"autofocus || false\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" [(ngModel)]=\"value\"\r\n        (ngModelChange)=\"onValueChange($event)\" [type]=\"type\" [id]=\"name\" [name]=\"name ?? ''\"\r\n        [attr.autocomplete]=\"type == 'password' ? 'current-password':''\" placeholder=\" \"\r\n        class=\"block input pt-2 pb-0.5 px-0 w-full height-normalized text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0  peer/inputs\" />\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute\">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':'cursor-pointer'\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\" (click)=\"doCallback()\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError() ? 'text-span text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$3.NgControl, decorators: [{
                    type: Optional
                }] }], propDecorators: { label: [{
                type: Input
            }], type: [{
                type: Input
            }], id: [{
                type: Input
            }], name: [{
                type: Input
            }], valueChanges: [{
                type: Output
            }], span: [{
                type: Input
            }], icon: [{
                type: Input
            }], iconCallback: [{
                type: Input
            }], iconCallbackDisabled: [{
                type: Input
            }], iconTooltip: [{
                type: Input
            }], tooltip: [{
                type: Input
            }], debounceTime: [{
                type: Input
            }], validations: [{
                type: Input
            }], standalone: [{
                type: Input
            }], autofocus: [{
                type: Input
            }], base64: [{
                type: Input
            }], disabled: [{
                type: Input
            }], siblings: [{
                type: Input
            }] } });

class ChrSearchSelectComponent extends ChrBaseInputComponent {
    constructor(ngControl) {
        super(ngControl);
        this.predicate = true;
        this.values = new BehaviorSubject('');
        this.data = [];
        /**
         * Callback that will be called BEFORE the value is added with the selected value passed as parameter.
         * If this callback returns null, the entry will NOT be added.
         * This lets you update the value before it's added.
         */
        this.addCallback = null;
        //Subject used in callback methods to update the value when received.
        this.addSubject = new Subject();
        /**
         * Indicate if the input accepts raw text or if the requires the selection to be made from the search list.
         * This defaults to false.
         * If there are neither data nor display function, this defaults to true.
         */
        this.acceptText = null;
        this.filterIndex = 0;
        this.overrideShowResults = false;
        /**
         * Reset the input's text and sets the value to null as to invalidate the input
         */
        this.reset = () => {
            this.value = '';
            this.values.next('');
            this.onValueChange(null);
        };
        /**
         * Set's the input's text's value and set the value to null as to invalidate the input
         * @param input text input
         */
        this.inputChange = (input) => {
            this.value = input;
            this.values.next(input);
            this.onValueChange(null);
        };
        /**
         * Returns the model's textual value using the display function display passed as callback. If there is no display, returns the model's default string value.
         * @param model the data's entry for which we want the textual value
         * */
        this.getModelDisplay = (model) => {
            return this.display ? this.display?.(model) : model;
        };
        /**
         * Start filtering the autocomplete's list based on the input's textual value
         */
        this.registerFilters = () => {
            this.filteredModelOptions = this.values.pipe(startWith(''), map((value) => this._filterModel(value || -1)), map((values) => {
                return this.filters && this.filters[this.filterIndex].callback
                    ? values.filter((r) => this.filters[this.filterIndex].callback(r))
                    : values;
            }));
        };
        /**
         * Increments the filter and focus the filtered input. It also sets the value to null as to force the user to choose a filtered value.
         * @param input the input in which the user should type
         */
        this.increment = (input) => {
            this.onValueChange(null);
            this.value = '';
            input.blur();
            const modulo = this.filters ? this.filters.length : 1;
            this.filterIndex = (this.filterIndex + 1) % modulo;
            setTimeout(() => {
                input.focus();
            }, 1000);
        };
        this.voidd = () => { };
        this.enableShowPanel = (input) => {
            //this.value = ' ';
            this.overrideShowResults = true;
            this.values.next(' ');
            input.focus();
        };
        this.disableShowPanel = () => {
            //this.searchSelect.setValue('', { emitViewToModelChange: false });
            this.overrideShowResults = false;
        };
        this.addFromText = (event) => {
            if (this.acceptText && this.value?.trim()) {
                const value = this.addCallback
                    ? this.addCallback(this.value, this.addSubject)
                    : this.value;
                if (this.addCallback && (value === null || value === undefined)) {
                    this.value = '';
                    return;
                }
                this.addSubject.next(value);
            }
        };
        this._filterModel = (value) => {
            return typeof value == 'string'
                ? this._doFilterModelString(`${value}`)
                : this._doFilterModelInt(value);
        };
        this._doFilterModelInt = (id) => {
            const tmp = this.data?.find((r) => r.id == id);
            return tmp ? tmp : [];
        };
        this._doFilterModelString = (input) => {
            return this.data?.filter((r) => this._filterValues(r, input)) || [];
        };
        this._filterValues = (value, input) => {
            //Si l'utilisateur entre un espace, on renvoie true, afin que tous les résultats s'affichent.
            if (input == ' ')
                return true;
            //Sinon, on ne renvoie true que pour les éléments qui matchent son input
            return `${this.getModelDisplay(value)}`
                .trim()
                .toLowerCase()
                .includes(input.trim().toLowerCase());
        };
        this.type = 'searchSelect';
    }
    ngOnInit() {
        super.ngOnInit();
        this.registerFilters();
        this.addSubject.subscribe((entry) => {
            if (this.value != entry) {
                this.value = entry;
                this.onValueChange(this.value);
            }
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrSearchSelectComponent, deps: [{ token: i1$3.NgControl, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrSearchSelectComponent, isStandalone: true, selector: "app-chr-search-select, [app-chr-search-select]", inputs: { placeholder: "placeholder", data: "data", display: "display", filters: "filters", addCallback: "addCallback", acceptText: "acceptText" }, providers: [
        // {
        //   provide: NG_VALUE_ACCESSOR,
        //   multi: true,
        //   useExisting: ChrSearchSelectComponent,
        // },
        ], viewQueries: [{ propertyName: "autocomplete", first: true, predicate: ["auto"], descendants: true }], usesInheritance: true, ngImport: i0, template: "@if (predicate) {\n<div style=\"position: relative;\">\n  <div style=\"position: relative;\">\n    <input [matTooltip]=\"isDisabled ? '': (tooltip ? tooltip: 'Entrez un espace pour voir les choix disponibles')\"\n      [chrAutofocus]=\"autofocus || false\" matTooltipPosition=\"above\" #input type=\"text\" name=\"{{name}}\"\n      [ngClass]=\"(isTouched && hasError()) ? 'error':''\"\n      class=\"block input pt-2 pb-0.5 px-0 w-full text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0 peer/inputs\"\n      placeholder=\"{{ placeholder || ' ' }}\" (keyup.backspace)=\"reset()\" [ngModel]=\"value\"\n      (keyup.enter)=\"addFromText($event)\" (ngModelChange)=\"inputChange($event)\" [matAutocomplete]=\"auto\"\n      (blur)=\"onTouch()\" (blur)=\"disableShowPanel()\" />\n\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg\">{{\n      label\n      }}\n      @if(label && label.trim() != ''){\n      @if (required) {\n      <span class=\"text-error\">*</span>\n      }\n      :\n      }\n      @if (\n      isTouched && hasError()) {\n      <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\n      }\n    </label>\n    <ng-content></ng-content>\n    <div\n      class=\"absolute top-0.5 right-0 flex flex-row h-[calc(100%_-_2px)] justify-center content-center items-center align-middle overflow-hidden\">\n      <mat-icon [@rotationAnimation]=\"overrideShowResults ? 'rotated' : 'initial'\" matTooltipPosition=\"above\"\n        class=\"cursor-pointer\" (click)=\"enableShowPanel(input)\">\n        arrow_right\n      </mat-icon>\n      @if (filters) {\n      <span [matTooltip]=\"filters[filterIndex].tooltip || ''\" matTooltipPosition=\"above\"\n        style=\"border-color: var(--neutral-color);\" class=\"inner-button cursor-pointer border-l-2 border-b-0 border-t-0 \n      border-r-0 w-fit px-1 text-center opacity-100  bg-opacity-50 flex justify-center \n      align-middle items-center\" (click)=\"filters ? increment(input) : voidd()\">\n        <p class=\"inline-block w-fit h-min overflow-hidden text-nowrap text-ellipsis\">{{ filters[filterIndex].display }}\n        </p>\n      </span>\n      }\n    </div>\n  </div>\n  <mat-autocomplete #auto class=\"rounded-lg no-scrollbar\" id=\"{{id}}-auto\"\n    style=\"::-webkit-scrollbar {display: none !important;}; -ms-overflow-style: none !important; scrollbar-width: none !important;\"\n    [displayWith]=\"getModelDisplay.bind(this)\" (optionSelected)=\"onValueChange($event.option.value)\">\n    @for (model of filteredModelOptions | async; track model) {\n    <mat-option class=\"\" [value]=\"model\" selected>\n      {{ getModelDisplay(model) }}\n    </mat-option>\n    }\n  </mat-autocomplete>\n  @if (span != null) {\n  <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\n    }}\n  </span>\n  }\n</div>\n}", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}::ng-deep .mat-mdc-option-active{background-color:var(--primary-color)!important}::ng-deep .mat-mdc-option:hover{background-color:var(--primary-color)!important}::ng-deep .mat-mdc-option:hover *{color:var(--primary-contrast-color)}::ng-deep .mat-mdc-option-active *{color:var(--primary-contrast-color)}::ng-deep .mat-mdc-autocomplete-panel{background-color:#000;background-color:var(--background-color)!important}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1$3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatAutocompleteModule }, { kind: "component", type: i2$2.MatAutocomplete, selector: "mat-autocomplete", inputs: ["aria-label", "aria-labelledby", "displayWith", "autoActiveFirstOption", "autoSelectActiveOption", "requireSelection", "panelWidth", "disableRipple", "class", "hideSingleSelectionIndicator"], outputs: ["optionSelected", "opened", "closed", "optionActivated"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i2$2.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i2$2.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", inputs: ["matAutocomplete", "matAutocompletePosition", "matAutocompleteConnectedTo", "autocomplete", "matAutocompleteDisabled"], exportAs: ["matAutocompleteTrigger"] }, { kind: "pipe", type: AsyncPipe, name: "async" }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }], animations: [rotationAnimation(180, 90, 200)] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrSearchSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-search-select, [app-chr-search-select]', providers: [
                    // {
                    //   provide: NG_VALUE_ACCESSOR,
                    //   multi: true,
                    //   useExisting: ChrSearchSelectComponent,
                    // },
                    ], imports: [
                        ReactiveFormsModule,
                        FormsModule,
                        MatTooltip,
                        MatAutocompleteModule,
                        MatOption,
                        AsyncPipe,
                        MatIconModule,
                        MatError,
                        CommonModule,
                        MatError,
                        AutofocusDirective,
                    ], animations: [rotationAnimation(180, 90, 200)], template: "@if (predicate) {\n<div style=\"position: relative;\">\n  <div style=\"position: relative;\">\n    <input [matTooltip]=\"isDisabled ? '': (tooltip ? tooltip: 'Entrez un espace pour voir les choix disponibles')\"\n      [chrAutofocus]=\"autofocus || false\" matTooltipPosition=\"above\" #input type=\"text\" name=\"{{name}}\"\n      [ngClass]=\"(isTouched && hasError()) ? 'error':''\"\n      class=\"block input pt-2 pb-0.5 px-0 w-full text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0 peer/inputs\"\n      placeholder=\"{{ placeholder || ' ' }}\" (keyup.backspace)=\"reset()\" [ngModel]=\"value\"\n      (keyup.enter)=\"addFromText($event)\" (ngModelChange)=\"inputChange($event)\" [matAutocomplete]=\"auto\"\n      (blur)=\"onTouch()\" (blur)=\"disableShowPanel()\" />\n\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg\">{{\n      label\n      }}\n      @if(label && label.trim() != ''){\n      @if (required) {\n      <span class=\"text-error\">*</span>\n      }\n      :\n      }\n      @if (\n      isTouched && hasError()) {\n      <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\n      }\n    </label>\n    <ng-content></ng-content>\n    <div\n      class=\"absolute top-0.5 right-0 flex flex-row h-[calc(100%_-_2px)] justify-center content-center items-center align-middle overflow-hidden\">\n      <mat-icon [@rotationAnimation]=\"overrideShowResults ? 'rotated' : 'initial'\" matTooltipPosition=\"above\"\n        class=\"cursor-pointer\" (click)=\"enableShowPanel(input)\">\n        arrow_right\n      </mat-icon>\n      @if (filters) {\n      <span [matTooltip]=\"filters[filterIndex].tooltip || ''\" matTooltipPosition=\"above\"\n        style=\"border-color: var(--neutral-color);\" class=\"inner-button cursor-pointer border-l-2 border-b-0 border-t-0 \n      border-r-0 w-fit px-1 text-center opacity-100  bg-opacity-50 flex justify-center \n      align-middle items-center\" (click)=\"filters ? increment(input) : voidd()\">\n        <p class=\"inline-block w-fit h-min overflow-hidden text-nowrap text-ellipsis\">{{ filters[filterIndex].display }}\n        </p>\n      </span>\n      }\n    </div>\n  </div>\n  <mat-autocomplete #auto class=\"rounded-lg no-scrollbar\" id=\"{{id}}-auto\"\n    style=\"::-webkit-scrollbar {display: none !important;}; -ms-overflow-style: none !important; scrollbar-width: none !important;\"\n    [displayWith]=\"getModelDisplay.bind(this)\" (optionSelected)=\"onValueChange($event.option.value)\">\n    @for (model of filteredModelOptions | async; track model) {\n    <mat-option class=\"\" [value]=\"model\" selected>\n      {{ getModelDisplay(model) }}\n    </mat-option>\n    }\n  </mat-autocomplete>\n  @if (span != null) {\n  <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\n    }}\n  </span>\n  }\n</div>\n}", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}::ng-deep .mat-mdc-option-active{background-color:var(--primary-color)!important}::ng-deep .mat-mdc-option:hover{background-color:var(--primary-color)!important}::ng-deep .mat-mdc-option:hover *{color:var(--primary-contrast-color)}::ng-deep .mat-mdc-option-active *{color:var(--primary-contrast-color)}::ng-deep .mat-mdc-autocomplete-panel{background-color:#000;background-color:var(--background-color)!important}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$3.NgControl, decorators: [{
                    type: Optional
                }] }], propDecorators: { autocomplete: [{
                type: ViewChild,
                args: ['auto']
            }], placeholder: [{
                type: Input
            }], data: [{
                type: Input
            }], display: [{
                type: Input
            }], filters: [{
                type: Input
            }], addCallback: [{
                type: Input
            }], acceptText: [{
                type: Input
            }] } });

class ChrTagSelectComponent extends ChrBaseInputComponent {
    constructor(ngControl) {
        super(ngControl);
        this.predicate = true;
        this.overrideShowResults = false;
        this.textInputValue = '';
        this.values = new BehaviorSubject('');
        this.data = [];
        /**
         * Callback that will be called on click of a chips. The entry will be passed as parameter.
         * If this callback returns null, the entry will be removed.
         * If this callback returns a different value (by reference (ex: different object)) the entry will be replaced by the new value.
         */
        this.editCallback = null;
        //Subject used in callback methods to update the value when received.
        this.editSubject = new Subject();
        /**
         * Callback that will be called BEFORE the value is added with the selected value passed as parameter.
         * If this callback returns null, the entry will NOT be added.
         * This lets you update the value before it's added.
         */
        this.addCallback = null;
        //Subject used in callback methods to update the value when received.
        this.addSubject = new Subject();
        /**
         * Callback that will be called during the removal of the value. This will be called with the deleted value passed as parameter.
         */
        this.removeCallback = null;
        /**
         * Indicate if the input accepts raw text or if the requires the selection to be made from the search list.
         * This defaults to false.
         * If there are neither data nor display function, this defaults to true.
         */
        this.acceptText = null;
        this.filterIndex = 0;
        this.reset = () => {
            this.textInputValue = '';
            this.values.next(' ');
        };
        this.inputChange = (input) => {
            this.textInputValue = input;
            this.values.next(input);
        };
        this.getModelDisplay = (model) => {
            return this.display ? this.display?.(model) : model;
        };
        this.addFromText = (event) => {
            if (this.acceptText && this.textInputValue?.trim()) {
                const value = this.addCallback
                    ? this.addCallback(this.textInputValue, this.addSubject)
                    : this.textInputValue;
                if (this.addCallback && (value === null || value === undefined)) {
                    this.textInputValue = '';
                    return;
                }
                this.addSubject.next(value);
            }
        };
        this.add = (event) => {
            const value = this.addCallback
                ? this.addCallback(event, this.addSubject)
                : event;
            if (this.addCallback && (value === null || value === undefined)) {
                this.textInputValue = '';
                return;
            }
            this.textInputValue = '';
            this.addSubject.next(value);
        };
        this.edit = (entry) => {
            //If no callback, return;
            if (this.editCallback === undefined || this.editCallback === null)
                return;
            //Call the callback and retrive it's return value
            const res = this.editCallback(entry, this.editSubject);
            //If the callback returns null, we remove the value.
            if (res === null && this.value !== null) {
                this.remove(entry);
            }
            //If the callback returns a different value (different by reference (ex: different object)), we replace the edited entry by the returned entry.
            // if (entry != res) {
            return this.editSubject.next(res);
            // }
            // this.value![this.value!.indexOf(entry)] = entry;
            // return this.onValueChange(this.value);
        };
        this.registerFilters = () => {
            this.filteredModelOptions = this.values.pipe(startWith(''), map((value) => this._filterModel(this.textInputValue || -1)), map((values) => {
                return this.filters && this.filters[this.filterIndex].callback
                    ? values.filter((r) => this.filters[this.filterIndex].callback(r))
                    : values;
            }));
        };
        this.increment = (input) => {
            this.textInputValue = '';
            input.blur();
            const modulo = this.filters ? this.filters.length : 1;
            this.filterIndex = (this.filterIndex + 1) % modulo;
            input.focus();
        };
        this.void = () => { };
        this.enableShowPanel = (input) => {
            this.overrideShowResults = true;
            this.textInputValue = ' ';
            this.values.next(' ');
            input.focus();
        };
        this.disableShowPanel = () => {
            this.overrideShowResults = false;
        };
        this.getTooltip = () => {
            if (this.isDisabled)
                return '';
            if (this.display === undefined)
                return "Appuyez sur 'Enter' pour ajouter la valeur du champs à la liste";
            return 'Entrez un espace pour voir les choix disponibles';
        };
        this._filterModel = (value) => {
            return typeof value == 'string'
                ? this._doFilterModelString(`${value}`)
                : this._doFilterModelInt(value);
        };
        this._doFilterModelInt = (id) => {
            const tmp = this.data?.find((r) => r.id == id);
            return tmp ? tmp : [];
        };
        this._doFilterModelString = (input) => {
            return this.data?.filter((r) => this._filterValues(r, input)) || [];
        };
        this._filterValues = (value, input) => {
            //Si l'utilisateur entre un espace, on renvoie true, afin que tous les résultats s'affichent.
            if (input == ' ')
                return true;
            //Sinon, on ne renvoie true que pour les éléments qui matchent son input
            return `${this.getModelDisplay(value)}`
                .trim()
                .toLowerCase()
                .includes(input.trim().toLowerCase());
        };
        this.type = 'tagSelect';
    }
    ngOnInit() {
        super.ngOnInit();
        this.registerFilters();
        if (this.acceptText === null)
            this.acceptText = this.display === null && this.data === null;
        //Register subject listeners
        this.addSubject.subscribe((entry) => {
            if (!this.value?.find((v) => v == entry)) {
                this.value = [...(this.value ?? []), entry];
                this.onValueChange(this.value);
            }
        });
        this.editSubject.subscribe((entry) => {
            const index = this.value?.indexOf(entry);
            this.value[index] = entry;
            this.value = [...(this.value ?? [])];
            return this.onValueChange(this.value);
        });
    }
    writeValue(obj) {
        super.writeValue(obj);
    }
    remove(value) {
        if (this.value !== null)
            this.value = this.value?.filter((v) => v != value);
        if (this.value?.length === 0)
            this.value = null;
        this.onValueChange(this.value);
        this.removeCallback?.(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrTagSelectComponent, deps: [{ token: i1$3.NgControl, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrTagSelectComponent, isStandalone: true, selector: "app-chr-tag-select, [app-chr-tag-select]", inputs: { placeholder: "placeholder", data: "data", display: "display", filters: "filters", editCallback: "editCallback", addCallback: "addCallback", removeCallback: "removeCallback", acceptText: "acceptText" }, providers: [
        // {
        //   provide: NG_VALUE_ACCESSOR,
        //   multi: true,
        //   useExisting: ChrTagSelectComponent,
        // },
        ], viewQueries: [{ propertyName: "autocomplete", first: true, predicate: ["auto"], descendants: true }], usesInheritance: true, ngImport: i0, template: "@if (predicate) {\n<div style=\"position: relative;\">\n  <div style=\"position: relative;\">\n    <input [matTooltip]=\"isDisabled ? '': (tooltip ? tooltip: 'Entrez un espace pour voir les choix disponibles')\"\n      [matChipInputFor]=\"chipGrid\" matTooltipPosition=\"above\" #input type=\"text\" name=\"{{name}}\"\n      [chrAutofocus]=\"autofocus || false\" [ngClass]=\"(isTouched && hasError()) ? 'error':''\"\n      class=\"block input pt-2 pb-0.5 px-0 w-full text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0  peer/inputs\"\n      placeholder=\"{{ placeholder || ' ' }}\" (keyup.backspace)=\"reset()\" (keyup.enter)=\"addFromText($event)\"\n      [ngModel]=\"textInputValue\" (ngModelChange)=\"inputChange($event)\" [matAutocomplete]=\"auto\" (blur)=\"onTouch()\"\n      (blur)=\"disableShowPanel()\" />\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg \">{{\n      label\n      }}\n      @if(label && label.trim() != ''){\n      @if (required) {\n      <span class=\"text-red-500\">*</span>\n      }\n      :\n      }\n      @if (\n      isTouched && hasError()) {\n      <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\n      }\n    </label>\n    <ng-content></ng-content>\n    <div *ngIf=\"data && data.length > 0\"\n      class=\"absolute top-1.5 right-0 flex flex-row justify-center content-center items-center align-middle overflow-hidden\">\n      <mat-icon [@rotationAnimation]=\"overrideShowResults ? 'rotated' : 'initial'\" matTooltipPosition=\"above\"\n        class=\"cursor-pointer\" (click)=\"enableShowPanel(input)\">\n        arrow_right\n      </mat-icon>\n      @if (filters) {\n      <span [matTooltip]=\"filters[filterIndex].tooltip || ''\" matTooltipPosition=\"above\"\n        style=\"border-color: var(--neutral-color);\" class=\"inner-button cursor-pointer border-l-2 border-b-0 border-t-0 \n    border-r-0 w-fit px-1 text-center opacity-100 bg-opacity-50 flex justify-center \n    align-middle items-center\" (click)=\"filters ? increment(input) : void()\">\n        <p class=\"inline-block w-fit h-min overflow-hidden text-nowrap text-ellipsis\">{{ filters[filterIndex].display }}\n        </p>\n      </span>\n      }\n    </div>\n  </div>\n  <mat-chip-grid #chipGrid class=\"w-full margin-0\">\n    @for (entry of value ?? []; track entry) {\n    <mat-chip-row (removed)=\"remove(entry)\">\n      <div (click)=\"edit(entry)\">{{getModelDisplay(entry)}}</div>\n      <button matChipRemove [attr.aria-label]=\"'Supprimer ' + getModelDisplay(entry)\">\n        <mat-icon class=\"mat-chip-icon\">cancel</mat-icon>\n      </button>\n    </mat-chip-row>\n    }\n  </mat-chip-grid>\n  <mat-autocomplete #auto class=\"rounded-lg no-scrollbar\" id=\"{{id}}-auto\"\n    style=\"::-webkit-scrollbar {display: none !important;}; -ms-overflow-style: none !important; scrollbar-width: none !important;\"\n    [displayWith]=\"getModelDisplay.bind(this)\" (optionSelected)=\"add($event.option.value)\">\n    @for (model of filteredModelOptions | async; track model) {\n    <mat-option class=\"\" [value]=\"model\" selected>\n      {{ getModelDisplay(model) }}\n    </mat-option>\n    }\n  </mat-autocomplete>\n  @if (span != null) {\n  <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\n    }}\n  </span>\n  }\n</div>\n}", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}::ng-deep .mat-mdc-option-active{background-color:var(--primary-color)!important}::ng-deep .mat-mdc-option-active *{color:var(--primary-contrast-color)}::ng-deep .mat-mdc-autocomplete-panel{background-color:#000}.mat-mdc-chip{background-color:var(--secondary-color)!important}input.mat-mdc-chip-input{margin-left:0}@media (prefers-color-scheme: dark){.mat-chip-icon{color:var(--primary-color)}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1$3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatAutocompleteModule }, { kind: "component", type: i2$2.MatAutocomplete, selector: "mat-autocomplete", inputs: ["aria-label", "aria-labelledby", "displayWith", "autoActiveFirstOption", "autoSelectActiveOption", "requireSelection", "panelWidth", "disableRipple", "class", "hideSingleSelectionIndicator"], outputs: ["optionSelected", "opened", "closed", "optionActivated"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i2$2.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i2$2.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", inputs: ["matAutocomplete", "matAutocompletePosition", "matAutocompleteConnectedTo", "autocomplete", "matAutocompleteDisabled"], exportAs: ["matAutocompleteTrigger"] }, { kind: "ngmodule", type: MatChipsModule }, { kind: "component", type: i3$1.MatChipGrid, selector: "mat-chip-grid", inputs: ["disabled", "placeholder", "required", "value", "errorStateMatcher"], outputs: ["change", "valueChange"] }, { kind: "directive", type: i3$1.MatChipInput, selector: "input[matChipInputFor]", inputs: ["matChipInputFor", "matChipInputAddOnBlur", "matChipInputSeparatorKeyCodes", "placeholder", "id", "disabled"], outputs: ["matChipInputTokenEnd"], exportAs: ["matChipInput", "matChipInputFor"] }, { kind: "directive", type: i3$1.MatChipRemove, selector: "[matChipRemove]" }, { kind: "component", type: i3$1.MatChipRow, selector: "mat-chip-row, [mat-chip-row], mat-basic-chip-row, [mat-basic-chip-row]", inputs: ["editable"], outputs: ["edited"] }, { kind: "pipe", type: AsyncPipe, name: "async" }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }], animations: [rotationAnimation(180, 90, 200)] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrTagSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-tag-select, [app-chr-tag-select]', providers: [
                    // {
                    //   provide: NG_VALUE_ACCESSOR,
                    //   multi: true,
                    //   useExisting: ChrTagSelectComponent,
                    // },
                    ], imports: [
                        ReactiveFormsModule,
                        FormsModule,
                        MatTooltip,
                        MatAutocompleteModule,
                        MatChipsModule,
                        MatOption,
                        AsyncPipe,
                        MatIconModule,
                        MatError,
                        CommonModule,
                        MatError,
                        AutofocusDirective,
                    ], animations: [rotationAnimation(180, 90, 200)], template: "@if (predicate) {\n<div style=\"position: relative;\">\n  <div style=\"position: relative;\">\n    <input [matTooltip]=\"isDisabled ? '': (tooltip ? tooltip: 'Entrez un espace pour voir les choix disponibles')\"\n      [matChipInputFor]=\"chipGrid\" matTooltipPosition=\"above\" #input type=\"text\" name=\"{{name}}\"\n      [chrAutofocus]=\"autofocus || false\" [ngClass]=\"(isTouched && hasError()) ? 'error':''\"\n      class=\"block input pt-2 pb-0.5 px-0 w-full text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0  peer/inputs\"\n      placeholder=\"{{ placeholder || ' ' }}\" (keyup.backspace)=\"reset()\" (keyup.enter)=\"addFromText($event)\"\n      [ngModel]=\"textInputValue\" (ngModelChange)=\"inputChange($event)\" [matAutocomplete]=\"auto\" (blur)=\"onTouch()\"\n      (blur)=\"disableShowPanel()\" />\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg \">{{\n      label\n      }}\n      @if(label && label.trim() != ''){\n      @if (required) {\n      <span class=\"text-red-500\">*</span>\n      }\n      :\n      }\n      @if (\n      isTouched && hasError()) {\n      <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\n      }\n    </label>\n    <ng-content></ng-content>\n    <div *ngIf=\"data && data.length > 0\"\n      class=\"absolute top-1.5 right-0 flex flex-row justify-center content-center items-center align-middle overflow-hidden\">\n      <mat-icon [@rotationAnimation]=\"overrideShowResults ? 'rotated' : 'initial'\" matTooltipPosition=\"above\"\n        class=\"cursor-pointer\" (click)=\"enableShowPanel(input)\">\n        arrow_right\n      </mat-icon>\n      @if (filters) {\n      <span [matTooltip]=\"filters[filterIndex].tooltip || ''\" matTooltipPosition=\"above\"\n        style=\"border-color: var(--neutral-color);\" class=\"inner-button cursor-pointer border-l-2 border-b-0 border-t-0 \n    border-r-0 w-fit px-1 text-center opacity-100 bg-opacity-50 flex justify-center \n    align-middle items-center\" (click)=\"filters ? increment(input) : void()\">\n        <p class=\"inline-block w-fit h-min overflow-hidden text-nowrap text-ellipsis\">{{ filters[filterIndex].display }}\n        </p>\n      </span>\n      }\n    </div>\n  </div>\n  <mat-chip-grid #chipGrid class=\"w-full margin-0\">\n    @for (entry of value ?? []; track entry) {\n    <mat-chip-row (removed)=\"remove(entry)\">\n      <div (click)=\"edit(entry)\">{{getModelDisplay(entry)}}</div>\n      <button matChipRemove [attr.aria-label]=\"'Supprimer ' + getModelDisplay(entry)\">\n        <mat-icon class=\"mat-chip-icon\">cancel</mat-icon>\n      </button>\n    </mat-chip-row>\n    }\n  </mat-chip-grid>\n  <mat-autocomplete #auto class=\"rounded-lg no-scrollbar\" id=\"{{id}}-auto\"\n    style=\"::-webkit-scrollbar {display: none !important;}; -ms-overflow-style: none !important; scrollbar-width: none !important;\"\n    [displayWith]=\"getModelDisplay.bind(this)\" (optionSelected)=\"add($event.option.value)\">\n    @for (model of filteredModelOptions | async; track model) {\n    <mat-option class=\"\" [value]=\"model\" selected>\n      {{ getModelDisplay(model) }}\n    </mat-option>\n    }\n  </mat-autocomplete>\n  @if (span != null) {\n  <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\n    }}\n  </span>\n  }\n</div>\n}", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}::ng-deep .mat-mdc-option-active{background-color:var(--primary-color)!important}::ng-deep .mat-mdc-option-active *{color:var(--primary-contrast-color)}::ng-deep .mat-mdc-autocomplete-panel{background-color:#000}.mat-mdc-chip{background-color:var(--secondary-color)!important}input.mat-mdc-chip-input{margin-left:0}@media (prefers-color-scheme: dark){.mat-chip-icon{color:var(--primary-color)}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$3.NgControl, decorators: [{
                    type: Optional
                }] }], propDecorators: { autocomplete: [{
                type: ViewChild,
                args: ['auto']
            }], placeholder: [{
                type: Input
            }], data: [{
                type: Input
            }], display: [{
                type: Input
            }], filters: [{
                type: Input
            }], editCallback: [{
                type: Input
            }], addCallback: [{
                type: Input
            }], removeCallback: [{
                type: Input
            }], acceptText: [{
                type: Input
            }] } });

class ChrColorInputComponent extends ChrBaseInputComponent {
    constructor(ngControl) {
        super(ngControl);
        this.parseColor = (event) => {
            // On récupère la valeur de l'input
            this.value = event;
            if (/^#[0-9A-F]{6}$/i.test(event))
                this.onValueChange(event);
            else
                this.onValueChange(null);
        };
        this.type = 'color';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrColorInputComponent, deps: [{ token: i1$3.NgControl, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrColorInputComponent, isStandalone: true, selector: "chr-color-input", usesInheritance: true, ngImport: i0, template: "<div style=\"position: relative;\">\r\n    <input [required]=\"required\" class=\"relative\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" [ngModel]=\"value\"\r\n        (ngModelChange)=\"parseColor($event)\" [type]=\"type\" [id]=\"name\" [name]=\"name ?? ''\" placeholder=\" \"\r\n        [chrAutofocus]=\"autofocus || false\" [value]=\"value || ''\"\r\n        class=\"block input pt-1 pb-0.5 m-0 px-0 w-full height-normalized border-0 border-b-2 focus:outline-none focus:ring-0 peer/inputs\" />\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg \">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    <div class=\"color-text-input-container\">\r\n        <input type=\"text\" max=\"6\" [ngModel]=\"value ?? '#000000'\" (ngModelChange)=\"parseColor($event)\"\r\n            style=\"background-color: var(--background-color); margin-bottom: 1px;\" class=\"focus:outline-none input bg-opacity-90 bg-transparent border-l-2 border-b-0 border-t-0 \r\n    border-r-0 w-20 px-1 text-center opacity-100 flex justify-center align-middle items-center\" />\r\n    </div>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n        }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}.color-text-input-container{display:flex;flex-direction:row;gap:.5rem;position:absolute;top:0;bottom:0;right:0}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$3.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i1$3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrColorInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'chr-color-input', imports: [
                        CommonModule,
                        MatIcon,
                        FormsModule,
                        MatError,
                        MatTooltipModule,
                        AutofocusDirective,
                    ], template: "<div style=\"position: relative;\">\r\n    <input [required]=\"required\" class=\"relative\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" [ngModel]=\"value\"\r\n        (ngModelChange)=\"parseColor($event)\" [type]=\"type\" [id]=\"name\" [name]=\"name ?? ''\" placeholder=\" \"\r\n        [chrAutofocus]=\"autofocus || false\" [value]=\"value || ''\"\r\n        class=\"block input pt-1 pb-0.5 m-0 px-0 w-full height-normalized border-0 border-b-2 focus:outline-none focus:ring-0 peer/inputs\" />\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg \">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    <div class=\"color-text-input-container\">\r\n        <input type=\"text\" max=\"6\" [ngModel]=\"value ?? '#000000'\" (ngModelChange)=\"parseColor($event)\"\r\n            style=\"background-color: var(--background-color); margin-bottom: 1px;\" class=\"focus:outline-none input bg-opacity-90 bg-transparent border-l-2 border-b-0 border-t-0 \r\n    border-r-0 w-20 px-1 text-center opacity-100 flex justify-center align-middle items-center\" />\r\n    </div>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n        }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}.color-text-input-container{display:flex;flex-direction:row;gap:.5rem;position:absolute;top:0;bottom:0;right:0}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$3.NgControl, decorators: [{
                    type: Optional
                }] }] });

class ChrDateInputComponent extends ChrBaseInputComponent {
    constructor(ngControl, datePipe) {
        super(ngControl);
        this.datePipe = datePipe;
        this.onInputChange = (value) => {
            //console.log(`[DateInput] StringDate: `, value);
            const date = this.parseDate(value);
            //console.log(`[DateInput] ParsedDate: `, date);
            if (date != null)
                this.value = this.dateToString(date);
            // Si la date est invalide, on envoie le null, sinon on envoie l'objet date
            this.onValueChange(date);
        };
        this.parseDate = (event) => {
            // On récupère la valeur de l'input
            this.value = event;
            // On essaie de la convertir en date
            const date = new Date(Date.parse(event));
            // Si la date est valide, on retourne la date, sinon null.
            if (date instanceof Date && !isNaN(date))
                return date;
            else
                return null;
        };
        this.dateToString = (value) => {
            return this.datePipe.transform(value, 'yyyy-MM-dd');
        };
        this.type = 'date';
    }
    writeValue(obj) {
        const formatted = this.dateToString(obj);
        this.value = formatted;
    }
    ngOnInit() {
        super.ngOnInit();
        const parsed = this.parseDate(this.value);
        if (parsed !== null)
            this.value = this.dateToString(parsed);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDateInputComponent, deps: [{ token: i1$3.NgControl, optional: true }, { token: i2.DatePipe }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrDateInputComponent, isStandalone: true, selector: "chr-date-input", providers: [
            // {
            //   provide: NG_VALUE_ACCESSOR,
            //   useExisting: forwardRef(() => ChrDateInputComponent),
            //   multi: true,
            // },
            DatePipe,
            {
                provide: DATE_PIPE_DEFAULT_OPTIONS,
                useValue: { dateFormat: 'shortDate' },
            },
        ], usesInheritance: true, ngImport: i0, template: "<div style=\"position: relative;\">\r\n    <input [required]=\"required\" class=\"relative\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" [ngModel]=\"value\"\r\n        [chrAutofocus]=\"autofocus || false\" (ngModelChange)=\"onInputChange($event)\" [type]=\"type\" [id]=\"name\"\r\n        [name]=\"name ?? ''\" placeholder=\" \" [value]=\"value || ''\"\r\n        class=\"block input pt-1.5 px-0 w-full height-normalized text-sm  bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0  peer/inputs\" />\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg \">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n        }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$3.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1$3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDateInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'chr-date-input', imports: [
                        ReactiveFormsModule,
                        MatError,
                        MatIcon,
                        MatTooltipModule,
                        CommonModule,
                        FormsModule,
                        AutofocusDirective,
                    ], providers: [
                        // {
                        //   provide: NG_VALUE_ACCESSOR,
                        //   useExisting: forwardRef(() => ChrDateInputComponent),
                        //   multi: true,
                        // },
                        DatePipe,
                        {
                            provide: DATE_PIPE_DEFAULT_OPTIONS,
                            useValue: { dateFormat: 'shortDate' },
                        },
                    ], template: "<div style=\"position: relative;\">\r\n    <input [required]=\"required\" class=\"relative\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" [ngModel]=\"value\"\r\n        [chrAutofocus]=\"autofocus || false\" (ngModelChange)=\"onInputChange($event)\" [type]=\"type\" [id]=\"name\"\r\n        [name]=\"name ?? ''\" placeholder=\" \" [value]=\"value || ''\"\r\n        class=\"block input pt-1.5 px-0 w-full height-normalized text-sm  bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0  peer/inputs\" />\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg \">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n        }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$3.NgControl, decorators: [{
                    type: Optional
                }] }, { type: i2.DatePipe }] });

class ChrDatetimeInputComponent extends ChrBaseInputComponent {
    constructor(ngControl, datePipe) {
        super(ngControl);
        this.datePipe = datePipe;
        this.onInputChange = (value) => {
            const date = this.parseDate(value);
            if (date != null)
                this.value = this.dateToString(date);
            this.onValueChange(date);
        };
        this.parseDate = (event) => {
            // On récupère la valeur de l'input
            this.value = event;
            // On essaie de la convertir en date
            const date = new Date(Date.parse(event));
            // Si la date est valide, on propage le onChange jusqu'au formulaire
            if (date instanceof Date && !isNaN(date))
                return date;
            else
                return null;
        };
        this.dateToString = (value) => {
            return this.datePipe.transform(value, 'yyyy-MM-ddTHH:mm');
        };
        this.type = 'date';
    }
    writeValue(obj) {
        const formatted = this.dateToString(obj);
        this.value = formatted;
    }
    ngOnInit() {
        super.ngOnInit();
        const parsed = this.parseDate(this.value);
        if (parsed !== null)
            this.value = this.dateToString(parsed);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDatetimeInputComponent, deps: [{ token: i1$3.NgControl, optional: true }, { token: i2.DatePipe }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrDatetimeInputComponent, isStandalone: true, selector: "chr-datetime-input", providers: [
            // {
            //   provide: NG_VALUE_ACCESSOR,
            //   useExisting: forwardRef(() => ChrDatetimeInputComponent),
            //   multi: true,
            // },
            DatePipe,
            {
                provide: DATE_PIPE_DEFAULT_OPTIONS,
                useValue: { dateFormat: 'shortDate' },
            },
        ], usesInheritance: true, ngImport: i0, template: "<div style=\"position: relative;\">\r\n    <input [required]=\"required\" class=\"relative\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" [ngModel]=\"value\"\r\n        [chrAutofocus]=\"autofocus || false\" (ngModelChange)=\"onInputChange($event)\" type=\"datetime-local\" [id]=\"name\"\r\n        [name]=\"name ?? ''\" placeholder=\" \" [value]=\"value || ''\"\r\n        class=\"block input pt-1.5 px-0 w-full height-normalized text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0 peer/inputs\" />\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg\">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error \">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">\r\n        {{ span }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$3.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i1$3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDatetimeInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'chr-datetime-input', imports: [
                        CommonModule,
                        MatIcon,
                        MatError,
                        FormsModule,
                        MatTooltip,
                        AutofocusDirective,
                    ], providers: [
                        // {
                        //   provide: NG_VALUE_ACCESSOR,
                        //   useExisting: forwardRef(() => ChrDatetimeInputComponent),
                        //   multi: true,
                        // },
                        DatePipe,
                        {
                            provide: DATE_PIPE_DEFAULT_OPTIONS,
                            useValue: { dateFormat: 'shortDate' },
                        },
                    ], template: "<div style=\"position: relative;\">\r\n    <input [required]=\"required\" class=\"relative\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" [ngModel]=\"value\"\r\n        [chrAutofocus]=\"autofocus || false\" (ngModelChange)=\"onInputChange($event)\" type=\"datetime-local\" [id]=\"name\"\r\n        [name]=\"name ?? ''\" placeholder=\" \" [value]=\"value || ''\"\r\n        class=\"block input pt-1.5 px-0 w-full height-normalized text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0 peer/inputs\" />\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg\">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error \">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">\r\n        {{ span }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$3.NgControl, decorators: [{
                    type: Optional
                }] }, { type: i2.DatePipe }] });

class ChrToggleInputComponent extends ChrBaseInputComponent {
    constructor(ngControl) {
        super(ngControl);
        this.toggle = (event) => {
            //console.log(event, event.target.checked);
            this.value = event.target.checked;
            this.onValueChange(this.value);
        };
        this.type = 'toggle';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrToggleInputComponent, deps: [{ token: i1$3.NgControl, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrToggleInputComponent, isStandalone: true, selector: "chr-toggle-input", providers: [
        // {
        //   provide: NG_VALUE_ACCESSOR,
        //   useExisting: forwardRef(() => ChrToggleInputComponent),
        //   multi: true,
        // },
        ], usesInheritance: true, ngImport: i0, template: "<div class=\"height-normalized\" style=\"position: relative;\">\r\n    <input #tgl type=\"checkbox\" class=\"hidden checkbox\" placeholder=\" \" [checked]=\"value\" (change)=\"toggle($event)\" />\r\n    <div\r\n        class=\"input pt-1.5 pb-0.5 px-0 w-full height-normalized relative toggle-wrapper flex align-middle input bg-transparent border-0 border-b-2 focus:outline-none focus:ring-0 peer/inputs\">\r\n        <div (click)=\"tgl?.click()\" [chrAutofocus]=\"autofocus || false\" class=\"relative input toggle\">\r\n        </div>\r\n    </div>\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg\">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n        }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}.toggle:after{border-radius:100%;transition:all .25s linear;position:absolute;height:1.25rem;width:1.25rem;top:2px;left:2px;display:flex;align-items:center;justify-items:center;justify-content:center}.checkbox+.toggle-wrapper>.toggle:after{transition:all .25s linear;transform:translate(0);left:2px;font-family:Material Icons;content:\"close\";--tw-bg-opacity: 1;background-color:rgb(156 163 175 / var(--tw-bg-opacity))}.checkbox:checked+.toggle-wrapper>.toggle:after{transition:all .25s linear;transform:translate(calc(-100% - 2px));left:100%;font-family:Material Icons;content:\"check\";background-color:var(--primary-color);color:var(--primary-contrast-color)}.toggle{height:1.5rem;width:2.75rem;cursor:pointer;transition:all .15s linear;border-radius:9999px;background-color:var(--neutral-color);justify-items:center;margin-top:auto;margin-bottom:auto}.toggle-wrapper{padding-top:.5rem;padding-bottom:.5rem}.checkbox:checked+.toggle-wrapper>.toggle{background-color:var(--secondary-color)}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: FormsModule }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrToggleInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'chr-toggle-input', imports: [
                        FormsModule,
                        CommonModule,
                        MatError,
                        MatIcon,
                        MatTooltip,
                        AutofocusDirective,
                    ], providers: [
                    // {
                    //   provide: NG_VALUE_ACCESSOR,
                    //   useExisting: forwardRef(() => ChrToggleInputComponent),
                    //   multi: true,
                    // },
                    ], template: "<div class=\"height-normalized\" style=\"position: relative;\">\r\n    <input #tgl type=\"checkbox\" class=\"hidden checkbox\" placeholder=\" \" [checked]=\"value\" (change)=\"toggle($event)\" />\r\n    <div\r\n        class=\"input pt-1.5 pb-0.5 px-0 w-full height-normalized relative toggle-wrapper flex align-middle input bg-transparent border-0 border-b-2 focus:outline-none focus:ring-0 peer/inputs\">\r\n        <div (click)=\"tgl?.click()\" [chrAutofocus]=\"autofocus || false\" class=\"relative input toggle\">\r\n        </div>\r\n    </div>\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg\">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (\r\n        isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n        }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}.toggle:after{border-radius:100%;transition:all .25s linear;position:absolute;height:1.25rem;width:1.25rem;top:2px;left:2px;display:flex;align-items:center;justify-items:center;justify-content:center}.checkbox+.toggle-wrapper>.toggle:after{transition:all .25s linear;transform:translate(0);left:2px;font-family:Material Icons;content:\"close\";--tw-bg-opacity: 1;background-color:rgb(156 163 175 / var(--tw-bg-opacity))}.checkbox:checked+.toggle-wrapper>.toggle:after{transition:all .25s linear;transform:translate(calc(-100% - 2px));left:100%;font-family:Material Icons;content:\"check\";background-color:var(--primary-color);color:var(--primary-contrast-color)}.toggle{height:1.5rem;width:2.75rem;cursor:pointer;transition:all .15s linear;border-radius:9999px;background-color:var(--neutral-color);justify-items:center;margin-top:auto;margin-bottom:auto}.toggle-wrapper{padding-top:.5rem;padding-bottom:.5rem}.checkbox:checked+.toggle-wrapper>.toggle{background-color:var(--secondary-color)}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$3.NgControl, decorators: [{
                    type: Optional
                }] }] });

class FileService {
    constructor() {
        this.fileToBase64 = (file) => {
            return this.toBase64({
                file: file,
                url: window.URL.createObjectURL(file),
            });
        };
        this.toBase64 = (file) => {
            return new Observable((observer) => {
                const reader = new FileReader();
                const indexOfExtension = file?.file?.name.lastIndexOf('.');
                if (!indexOfExtension || indexOfExtension === -1)
                    throw '[FileInput] Invalid file name: no file extension found.';
                reader.onloadend = () => {
                    var [name, extension] = [
                        ...(file?.file
                            ? [
                                file.file.name.slice(0, indexOfExtension),
                                // +1 As to not include the dot
                                file.file.name.slice(indexOfExtension + 1),
                            ]
                            : [null, null]),
                    ];
                    file = {
                        ...file,
                        name: name ?? undefined,
                        data: reader.result,
                        extension: extension ?? undefined,
                        url: window.URL.createObjectURL(file.file),
                    };
                    observer.next(file);
                    observer.complete();
                };
                reader.onerror = (error) => {
                    observer.error(error);
                };
                if (file.file)
                    reader.readAsDataURL(file.file);
            });
        };
        this.toBase64WithProgress = (file) => {
            return new Observable((observer) => {
                const reader = new FileReader();
                // Taille d'un chunk (90 Ko)
                // DOIT ETRE UN MULTIPLE DE 3
                // pour des raisons d'encodage Base64
                const chunkSize = 1024 * 90;
                const totalSize = file?.file?.size ?? 0;
                // Position
                let offset = 0;
                let base64Data = '';
                const indexOfExtension = file?.file?.name.lastIndexOf('.');
                if (!indexOfExtension || indexOfExtension === -1) {
                    observer.error('[FileService] Invalid file name: no file extension found.');
                    return;
                }
                const [name, extension] = [
                    file.file.name.slice(0, indexOfExtension),
                    file.file.name.slice(indexOfExtension + 1),
                ];
                file = {
                    ...file,
                    name: name ?? undefined,
                    extension: extension ?? undefined,
                    url: window.URL.createObjectURL(file.file),
                };
                const readChunk = () => {
                    const chunk = file.file.slice(offset, offset + chunkSize);
                    reader.readAsDataURL(chunk);
                };
                reader.onload = (event) => {
                    const result = event.target.result;
                    // Retire l'entête qui est rajoutée à chaque lecture
                    const base64Chunk = result.split(',')[1];
                    base64Data += base64Chunk;
                    offset += chunkSize;
                    const progress = Math.min(Math.round((offset / totalSize) * 100), 100);
                    observer.next({ progress, file });
                    if (offset < totalSize) {
                        readChunk();
                    }
                    else {
                        // On termine l'encodage en rajoutant les métadata et en mettant à jour la dataurl
                        file.data = `data:${file.file.type};base64,${base64Data}`;
                        file.url = window.URL.createObjectURL(file.file);
                        observer.next({ progress: 100, file });
                        observer.complete();
                    }
                };
                reader.onerror = (error) => {
                    console.log('[FileService] Error:', error);
                    observer.error(error);
                };
                // Démarrer la lecture des chunks
                if (file.file) {
                    readChunk();
                }
                else {
                    observer.error('[FileService] No file provided.');
                }
            });
        };
        this.batchToBase64 = (files) => {
            return from(files).pipe(mergeMap((file) => this.toBase64(file)), toArray());
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: FileService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: FileService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: FileService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [] });

class ToastService {
    constructor() {
        this.toastQueue = new Subject();
        this.currentToastSubject = new BehaviorSubject(null);
        this.currentToast$ = this.currentToastSubject.asObservable();
        this.toastCloseSubject = new Subject();
        this.default_duration = 5000;
        this.current = () => {
            return this.currentToastSubject;
        };
        this.next = () => {
            this.toastCloseSubject.next();
        };
        this.set = async (type, message, duration) => {
            this.toastQueue.next({
                type: type,
                message: message,
                duration: duration || this.default_duration,
            });
        };
        //We are leveraging the power of RXJS to handle the delay between the
        this.toastQueue
            .pipe(concatMap((toast) => {
            //We reset the click subject to ensure rxjs doesn't beleive it's been clicked
            this.toastCloseSubject = new Subject();
            // We send the next toast
            this.currentToastSubject.next(toast);
            return timer(toast.duration || this.default_duration).pipe(
            //If the user click the next button, we stop the current emission and go to the next one
            takeUntil(this.toastCloseSubject), 
            //After the toast duration, we send a null value. If there is still a toast waiting, this null value will be overriden after the small delay.
            //Otherwise this null value allows us to notify the subscriber that there is no toast waiting.
            finalize(() => {
                this.currentToastSubject.next(null);
            }), 
            //Small delay between toasts
            switchMap(() => timer(500)));
        }))
            .subscribe();
    }
    setSuccess(message, time) {
        this.set("success", message || "", time);
    }
    setError(message, time) {
        this.set("error", message, time);
    }
    setWarning(message, time) {
        this.set("warning", message, time);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ToastService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ToastService, providedIn: "root" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ToastService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: "root",
                }]
        }], ctorParameters: () => [] });

class ChrFileInputComponent extends ChrBaseInputComponent {
    constructor(ngControl, fileService, toastService) {
        super(ngControl);
        this.fileService = fileService;
        this.toastService = toastService;
        /**
         * An array of string that contains each type that should be accepted by the input
         */
        this.accept = [];
        /**
         * Whether or not the input should allow multiple file selection
         */
        this.multiple = false;
        this.valueDisplay = null;
        /**
         * Whether or not the progress bar that display a file's conversion progress will be editable by the user
         */
        this.editable = false;
        this.errors = null;
        this.files = [];
        this.onFileChange = (event) => {
            //console.log(`[FileInput] (change) -> `, event);
            this.files = [];
            const files = event.target.files;
            //console.log(`[FileInput] (change): target -> `, files);
            const filesAsync = [];
            if (files.length <= 0) {
                this.valueDisplay = '';
                this.onValueChange(null);
            }
            let obs;
            for (const file of files) {
                if (this.base64) {
                    // Convert the file to base64 using the fileservice
                    obs = this.fileService.toBase64WithProgress({
                        file: file,
                        url: window.URL.createObjectURL(file),
                    });
                }
                else {
                    const fil = file;
                    const indexOfExtension = file?.file?.name.lastIndexOf('.');
                    const [name, extension] = [
                        fil.name.slice(0, indexOfExtension),
                        fil.name.slice(indexOfExtension + 1),
                    ];
                    obs = of({
                        progress: 100,
                        file: {
                            data: null,
                            extension: extension,
                            name: name,
                            file: fil,
                            url: window.URL.createObjectURL(fil),
                        },
                    });
                }
                // Add to the file list with the progress percentage
                this.files = [...this.files, obs];
                filesAsync.push(obs);
                // Catch conversion error for display
                obs.pipe(catchError((err, source) => {
                    this.toastService.setWarning(`Une erreur s'est produite pendant la conversion du fichier ${file.name} `);
                    return err;
                }));
            }
            forkJoin(filesAsync)
                .pipe(take(1))
                .subscribe((res) => {
                const value = res.map((r) => r.file);
                this.onValueChange(this.multiple ? value : value[0]);
                this.writeValue(res.map((r) => r.file));
            });
        };
        this.acceptToString = () => {
            return this.accept?.map((type) => `.${type}`).join(', ') || '.*';
        };
        this.getToAccept = () => {
            return this.accept?.map((s) => s.toLocaleUpperCase()).join(', ');
        };
        this.changeFileName = (event, file) => {
            if (!file)
                return;
            file.name = event.target.outerText?.trim();
        };
        this.openFile = (index, file) => {
            forkJoin(this.files)
                .pipe(take(1))
                .subscribe((res) => {
                window.open(res[index].file.url, '_blank');
            });
        };
        this.removeFile = (index, file) => {
            this.files.splice(index, 1);
            if (this.files.length <= 0)
                this.onValueChange(null);
            forkJoin(this.files)
                .pipe(take(1))
                .subscribe((files) => {
                const values = files.map((f) => f.file);
                this.onValueChange(this.multiple ? values : values[0]);
            });
        };
    }
    writeValue(obj) {
        if (!obj) {
            this.valueDisplay = '';
            return;
        }
        if (Array.isArray(obj)) {
            const tmp = obj.map((f) => {
                return `${f.name}.${f.extension}`;
            });
            this.valueDisplay = tmp.join(',');
        }
        else
            this.valueDisplay = `${obj.name}.${obj.extension}`;
    }
    ngOnInit() {
        super.ngOnInit();
        this.valueChanges
            .pipe(skipWhile((res) => res === null))
            .subscribe((res) => this.writeValue(res));
        this.control?.statusChanges?.subscribe((status) => {
            this.errors = this.control?.errors
                ? { ...this.control.errors['indexes'] }
                : null;
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrFileInputComponent, deps: [{ token: i1$3.NgControl, optional: true }, { token: FileService }, { token: ToastService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrFileInputComponent, isStandalone: true, selector: "chr-file-input", inputs: { accept: "accept", multiple: "multiple", editable: "editable" }, providers: [
        // {
        //   provide: NG_VALUE_ACCESSOR,
        //   useExisting: forwardRef(() => ChrFileInputComponent),
        //   multi: true,
        // },
        ], usesInheritance: true, ngImport: i0, template: "<div class=\"\">\r\n    <div style=\"position: relative;\" class=\"cursor-pointer\" (click)=\"finput.click()\" (click)=\"onTouch($event)\">\r\n        <div class=\"absolute top-1 right-0 flex flex-row justify-center content-center items-center align-middle overflow-hidden opacity-100 bg-opacity-100\"\r\n            style=\"background-color: inherit; opacity: 1;\">\r\n            <mat-icon class=\"cursor-pointer rounded-full\"\r\n                *ngIf=\"!errors && (files[0] | async)?.progress != 100\">add</mat-icon>\r\n            <mat-icon class=\"cursor-pointer rounded-full\" style=\"color:var(--primary-color)\"\r\n                *ngIf=\"!errors && (files[0] | async)?.progress == 100\">check</mat-icon>\r\n            <mat-icon class=\"cursor-pointer rounded-full\" style=\"color:var(--error-color)\"\r\n                *ngIf=\"errors !== null\">close</mat-icon>\r\n            <div class=\"border-l-2 border-b-0 border-t-0 \r\n                border-r-0 w-fit  px-1 text-center opacity-100 bg-opacity-100 flex justify-center \r\n                align-middle items-center\" style=\"border-color: var(--neutral-color);\">\r\n                {{getToAccept()}}\r\n            </div>\r\n        </div>\r\n        <input class=\"relative input\" type=\"file\" class=\"hidden\" [attr.multiple]=\"multiple\" #finput\r\n            [chrAutofocus]=\"autofocus || false\" [accept]=\"acceptToString()\" (change)=\"onFileChange($event)\" />\r\n        <input class=\"relative input height-normalized\" [ngClass]=\"(isTouched && hasError()) ? 'error':''\" [id]=\"id\"\r\n            [name]=\"name!\" placeholder=\" \" [ngModel]=\"valueDisplay\" disabled\r\n            class=\"block input pt-1.5 m-0 mr-4 px-0 w-full overflow-hidden text-ellipsis bg-transparent border-0 border-b-2 focus:outline-none focus:ring-0 peer/inputs file:hidden\" />\r\n        <label *ngIf=\"label !== null\" class=\"label absolute text-lg \">{{\r\n            label\r\n            }}\r\n            @if(label && label.trim() != ''){\r\n            @if (required) {\r\n            <span class=\"text-error\">*</span>\r\n            }\r\n            :\r\n            }\r\n            @if (\r\n            isTouched && hasError()) {\r\n            <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n            }\r\n        </label>\r\n        <div *ngIf=\"files[0] | async as conversion\" class=\"progress-border border-t-2\"\r\n            [style.width]=\"conversion.progress + '%'\" [ngClass]=\"{\r\n                                                        'border-ongoing': conversion.progress > 0 && conversion.progress < 100,\r\n                                                        'border-finished': conversion.progress === 100,\r\n                                                        'border-error': errors !== null && errors[0] !== undefined\r\n                                                    }\">\r\n            <span *ngIf=\"!multiple && (conversion.progress < 100)\">{{conversion.progress}}%</span>\r\n        </div>\r\n        @if (icon && !isDisabled) {\r\n        <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n            [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n            (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n                class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n        </span>\r\n        }\r\n        @if (span != null) {\r\n        <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n            }}\r\n        </span>\r\n        }\r\n    </div>\r\n    <div *ngIf=\"multiple === true && files.length > 0\" class=\"shadow-lg drop-shadow-lg pt-2 border-x-2 border-b-2\">\r\n        @for(file of files; track file; let index = $index){\r\n        <ng-container *ngIf=\"file | async as conversion \">\r\n            <div class=\"progress-bar shadow-lg drop-shadow-lg\">\r\n                <div class=\"progress\" [style.width]=\"conversion.progress + '%'\" [ngClass]=\"{\r\n                                                        'ongoing': conversion.progress > 0 && conversion.progress < 100,\r\n                                                        'finished': !errors?.[index] && conversion.progress === 100,\r\n                                                        'error': errors?.[index] === true\r\n                                                    }\"></div>\r\n                <div class=\"progress-text-wrapper\">\r\n                    <span class=\"progress-text\" (input)=\"changeFileName($event, conversion.file)\"\r\n                        [attr.contenteditable]=\"editable\">{{conversion.file?.name}}</span>\r\n                    <div class=\"progress-icon-wrapper\">\r\n                        <span class=\"progress-bar-progress\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\">{{conversion.progress}}%</span>\r\n                        <mat-icon class=\"progress-bar-delete cursor-pointer\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\"\r\n                            (click)=\"openFile(index, conversion.file)\">visibility</mat-icon>\r\n                        <mat-icon class=\"progress-bar-delete cursor-pointer\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\"\r\n                            (click)=\"removeFile(index, conversion.file)\">delete</mat-icon>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </ng-container>\r\n        }\r\n    </div>\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:1.25rem}.text-contrast{color:var(--primary-contrast-color)}input[disabled]{pointer-events:none}.progress-bar{width:100%;height:1.5rem;background-color:#e0e0e0;border-radius:5px;overflow:hidden;position:relative}.progress-bar:not(:last-child){margin-bottom:.25rem}.progress{position:absolute;top:0;bottom:0;left:0;height:100%;transition:width .2s ease}.percentage{position:absolute;bottom:0;top:0;display:flex;justify-content:center;align-items:center;right:.25rem}.ongoing{background-color:var(--secondary-color)}.finished{background-color:var(--primary-color)}.finished+.progress-text-wrapper>*{color:var(--primary-contrast-color)}.error{background-color:var(--error-color)}.error+.progress-text-wrapper>*{color:var(--error-contrast-color)}.border-ongoing{border-color:var(--secondary-color)}.border-finished{border-color:var(--primary-color)}.border-error{border-color:var(--error-color)}.filename{position:absolute;bottom:0;top:0;left:.25rem}.progress-text-wrapper{position:absolute;inset:1;display:flex;width:100%;flex-direction:row;justify-content:space-between;align-items:center;padding-left:.25rem;padding-right:.25rem}.progress-bar:hover .progress-bar-delete{visibility:visible;transform:translate(0);opacity:1;transition:all 125ms ease-in-out}.progress-bar-delete{visibility:hidden;transform:translate(3rem);opacity:0;transition:all 125ms ease-in-out}.progress-bar-delete:hover{filter:brightness(80%)}.progress-icon-wrapper{display:flex;flex-direction:row;align-items:center;justify-content:center;gap:.5rem}.progress-text{overflow:hidden;text-overflow:ellipsis;text-wrap:nowrap}.progress-bar-progress{transform:translate(3.75rem);transition:all 125ms ease-in-out}.progress-bar:hover .progress-bar-progress{transform:translate(0);transition:all 125ms ease-in-out}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrFileInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'chr-file-input', imports: [
                        MatIcon,
                        CommonModule,
                        FormsModule,
                        MatError,
                        MatTooltipModule,
                        AutofocusDirective,
                    ], providers: [
                    // {
                    //   provide: NG_VALUE_ACCESSOR,
                    //   useExisting: forwardRef(() => ChrFileInputComponent),
                    //   multi: true,
                    // },
                    ], template: "<div class=\"\">\r\n    <div style=\"position: relative;\" class=\"cursor-pointer\" (click)=\"finput.click()\" (click)=\"onTouch($event)\">\r\n        <div class=\"absolute top-1 right-0 flex flex-row justify-center content-center items-center align-middle overflow-hidden opacity-100 bg-opacity-100\"\r\n            style=\"background-color: inherit; opacity: 1;\">\r\n            <mat-icon class=\"cursor-pointer rounded-full\"\r\n                *ngIf=\"!errors && (files[0] | async)?.progress != 100\">add</mat-icon>\r\n            <mat-icon class=\"cursor-pointer rounded-full\" style=\"color:var(--primary-color)\"\r\n                *ngIf=\"!errors && (files[0] | async)?.progress == 100\">check</mat-icon>\r\n            <mat-icon class=\"cursor-pointer rounded-full\" style=\"color:var(--error-color)\"\r\n                *ngIf=\"errors !== null\">close</mat-icon>\r\n            <div class=\"border-l-2 border-b-0 border-t-0 \r\n                border-r-0 w-fit  px-1 text-center opacity-100 bg-opacity-100 flex justify-center \r\n                align-middle items-center\" style=\"border-color: var(--neutral-color);\">\r\n                {{getToAccept()}}\r\n            </div>\r\n        </div>\r\n        <input class=\"relative input\" type=\"file\" class=\"hidden\" [attr.multiple]=\"multiple\" #finput\r\n            [chrAutofocus]=\"autofocus || false\" [accept]=\"acceptToString()\" (change)=\"onFileChange($event)\" />\r\n        <input class=\"relative input height-normalized\" [ngClass]=\"(isTouched && hasError()) ? 'error':''\" [id]=\"id\"\r\n            [name]=\"name!\" placeholder=\" \" [ngModel]=\"valueDisplay\" disabled\r\n            class=\"block input pt-1.5 m-0 mr-4 px-0 w-full overflow-hidden text-ellipsis bg-transparent border-0 border-b-2 focus:outline-none focus:ring-0 peer/inputs file:hidden\" />\r\n        <label *ngIf=\"label !== null\" class=\"label absolute text-lg \">{{\r\n            label\r\n            }}\r\n            @if(label && label.trim() != ''){\r\n            @if (required) {\r\n            <span class=\"text-error\">*</span>\r\n            }\r\n            :\r\n            }\r\n            @if (\r\n            isTouched && hasError()) {\r\n            <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n            }\r\n        </label>\r\n        <div *ngIf=\"files[0] | async as conversion\" class=\"progress-border border-t-2\"\r\n            [style.width]=\"conversion.progress + '%'\" [ngClass]=\"{\r\n                                                        'border-ongoing': conversion.progress > 0 && conversion.progress < 100,\r\n                                                        'border-finished': conversion.progress === 100,\r\n                                                        'border-error': errors !== null && errors[0] !== undefined\r\n                                                    }\">\r\n            <span *ngIf=\"!multiple && (conversion.progress < 100)\">{{conversion.progress}}%</span>\r\n        </div>\r\n        @if (icon && !isDisabled) {\r\n        <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n            [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n            (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n                class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n        </span>\r\n        }\r\n        @if (span != null) {\r\n        <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n            }}\r\n        </span>\r\n        }\r\n    </div>\r\n    <div *ngIf=\"multiple === true && files.length > 0\" class=\"shadow-lg drop-shadow-lg pt-2 border-x-2 border-b-2\">\r\n        @for(file of files; track file; let index = $index){\r\n        <ng-container *ngIf=\"file | async as conversion \">\r\n            <div class=\"progress-bar shadow-lg drop-shadow-lg\">\r\n                <div class=\"progress\" [style.width]=\"conversion.progress + '%'\" [ngClass]=\"{\r\n                                                        'ongoing': conversion.progress > 0 && conversion.progress < 100,\r\n                                                        'finished': !errors?.[index] && conversion.progress === 100,\r\n                                                        'error': errors?.[index] === true\r\n                                                    }\"></div>\r\n                <div class=\"progress-text-wrapper\">\r\n                    <span class=\"progress-text\" (input)=\"changeFileName($event, conversion.file)\"\r\n                        [attr.contenteditable]=\"editable\">{{conversion.file?.name}}</span>\r\n                    <div class=\"progress-icon-wrapper\">\r\n                        <span class=\"progress-bar-progress\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\">{{conversion.progress}}%</span>\r\n                        <mat-icon class=\"progress-bar-delete cursor-pointer\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\"\r\n                            (click)=\"openFile(index, conversion.file)\">visibility</mat-icon>\r\n                        <mat-icon class=\"progress-bar-delete cursor-pointer\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\"\r\n                            (click)=\"removeFile(index, conversion.file)\">delete</mat-icon>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </ng-container>\r\n        }\r\n    </div>\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:1.25rem}.text-contrast{color:var(--primary-contrast-color)}input[disabled]{pointer-events:none}.progress-bar{width:100%;height:1.5rem;background-color:#e0e0e0;border-radius:5px;overflow:hidden;position:relative}.progress-bar:not(:last-child){margin-bottom:.25rem}.progress{position:absolute;top:0;bottom:0;left:0;height:100%;transition:width .2s ease}.percentage{position:absolute;bottom:0;top:0;display:flex;justify-content:center;align-items:center;right:.25rem}.ongoing{background-color:var(--secondary-color)}.finished{background-color:var(--primary-color)}.finished+.progress-text-wrapper>*{color:var(--primary-contrast-color)}.error{background-color:var(--error-color)}.error+.progress-text-wrapper>*{color:var(--error-contrast-color)}.border-ongoing{border-color:var(--secondary-color)}.border-finished{border-color:var(--primary-color)}.border-error{border-color:var(--error-color)}.filename{position:absolute;bottom:0;top:0;left:.25rem}.progress-text-wrapper{position:absolute;inset:1;display:flex;width:100%;flex-direction:row;justify-content:space-between;align-items:center;padding-left:.25rem;padding-right:.25rem}.progress-bar:hover .progress-bar-delete{visibility:visible;transform:translate(0);opacity:1;transition:all 125ms ease-in-out}.progress-bar-delete{visibility:hidden;transform:translate(3rem);opacity:0;transition:all 125ms ease-in-out}.progress-bar-delete:hover{filter:brightness(80%)}.progress-icon-wrapper{display:flex;flex-direction:row;align-items:center;justify-content:center;gap:.5rem}.progress-text{overflow:hidden;text-overflow:ellipsis;text-wrap:nowrap}.progress-bar-progress{transform:translate(3.75rem);transition:all 125ms ease-in-out}.progress-bar:hover .progress-bar-progress{transform:translate(0);transition:all 125ms ease-in-out}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$3.NgControl, decorators: [{
                    type: Optional
                }] }, { type: FileService }, { type: ToastService }], propDecorators: { accept: [{
                type: Input
            }], multiple: [{
                type: Input
            }], editable: [{
                type: Input
            }] } });

class ChrTextareaInputComponent extends ChrBaseInputComponent {
    constructor(ngControl) {
        super(ngControl);
        this.input = null;
        //On input, we resize the textarea so that it's always readable
        this.resize = (textArea) => {
            if (textArea === undefined)
                return;
            // For some reason, it needs to have 2px more than the intended height.
            textArea.style.height = '34px';
            textArea.style.height = `${textArea.scrollHeight}px`;
        };
        this.preventSubmit = (event) => {
            event.stopPropagation();
        };
        this.type = 'textArea';
    }
    ngAfterViewInit() {
        super.ngAfterViewInit();
        // console.log('AfterViewInit', this.input);
        // this.resize(this.input?.nativeElement as HTMLTextAreaElement | undefined);
    }
    ngAfterContentChecked() {
        // console.log('AfterContentChecked', this.input);
        this.resize(this.input?.nativeElement);
        // this.resize(this.input as any);
    }
    ngAfterViewChecked() {
        // console.log('AfterViewChecked', this.input);
        //this.resize(this.input as any);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrTextareaInputComponent, deps: [{ token: i1$3.NgControl, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrTextareaInputComponent, isStandalone: true, selector: "chr-textarea-input", providers: [
        // {
        //   provide: NG_VALUE_ACCESSOR,
        //   useExisting: forwardRef(() => ChrTextareaInputComponent),
        //   multi: true,
        // },
        ], viewQueries: [{ propertyName: "input", first: true, predicate: ["input"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<div style=\"position: relative;\" (keyup.enter)=\"preventSubmit($event)\">\r\n    <textarea #input [required]=\"required\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\" required=\"true\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" (input)=\"resize(input)\"\r\n        [(ngModel)]=\"value\" (ngModelChange)=\"onValueChange($event)\" [chrAutofocus]=\"autofocus || false\"\r\n        class=\"no-scrollbar input !resize-none height-normalized block pt-1.5 px-0 w-full text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0 peer/inputs\"></textarea>\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg\">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n        }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}.color-text-input-container{display:flex;flex-direction:row;gap:.5rem;position:absolute;top:0;bottom:0;right:0}input[type=textarea]::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$3.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i1$3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrTextareaInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'chr-textarea-input', imports: [
                        CommonModule,
                        MatIcon,
                        FormsModule,
                        MatError,
                        MatTooltipModule,
                        AutofocusDirective,
                    ], providers: [
                    // {
                    //   provide: NG_VALUE_ACCESSOR,
                    //   useExisting: forwardRef(() => ChrTextareaInputComponent),
                    //   multi: true,
                    // },
                    ], template: "<div style=\"position: relative;\" (keyup.enter)=\"preventSubmit($event)\">\r\n    <textarea #input [required]=\"required\" [matTooltip]=\"tooltip || ''\" matTooltipPosition=\"above\" required=\"true\"\r\n        [ngClass]=\"(isTouched && hasError()) ? 'error':''\" (blur)=\"onTouch()\" (input)=\"resize(input)\"\r\n        [(ngModel)]=\"value\" (ngModelChange)=\"onValueChange($event)\" [chrAutofocus]=\"autofocus || false\"\r\n        class=\"no-scrollbar input !resize-none height-normalized block pt-1.5 px-0 w-full text-sm bg-transparent border-0 border-b-2 appearance-none focus:outline-none focus:ring-0 peer/inputs\"></textarea>\r\n\r\n    <label *ngIf=\"label !== null\" class=\"label absolute text-lg\">{{\r\n        label\r\n        }}\r\n        @if(label && label.trim() != ''){\r\n        @if (required) {\r\n        <span class=\"text-error\">*</span>\r\n        }\r\n        :\r\n        }\r\n        @if (isTouched && hasError()) {\r\n        <mat-error class=\"text-error\">{{ getLastError() }}</mat-error>\r\n        }\r\n    </label>\r\n\r\n    @if (icon && !isDisabled) {\r\n    <span [ngClass]=\"iconCallbackDisabled ? '':''\" class=\"absolute p-2.5 bottom-0 right-0\"\r\n        [matTooltip]=\"iconTooltip || ''\" matTooltipPosition=\"above\"\r\n        (click)=\"!iconCallbackDisabled && iconCallback?.(value)\"><mat-icon\r\n            class=\"flex input justify-center align-middle items-center content-center text-lg\">{{icon}}</mat-icon>\r\n    </span>\r\n    }\r\n    @if (span != null) {\r\n    <span [ngClass]=\"isTouched && hasError()? 'text-error' : ''\" class=\"h-0 text-xs text-span\">{{ span\r\n        }}\r\n    </span>\r\n    }\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:2rem}.color-text-input-container{display:flex;flex-direction:row;gap:.5rem;position:absolute;top:0;bottom:0;right:0}input[type=textarea]::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$3.NgControl, decorators: [{
                    type: Optional
                }] }], propDecorators: { input: [{
                type: ViewChild,
                args: ['input']
            }] } });

class TabToInputHandlerDirective {
    constructor(el) {
        this.el = el;
    }
    handleTab(event) {
        if (event.key === 'Tab') {
            event.preventDefault();
            const inputs = Array.from(document.querySelectorAll('input:not([type="checkbox"]), textarea'));
            const currentIndex = inputs.indexOf(event.target);
            if (currentIndex !== -1) {
                const nextElement = inputs[currentIndex + (event.shiftKey ? -1 : 1)];
                if (nextElement) {
                    nextElement.focus();
                }
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TabToInputHandlerDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: TabToInputHandlerDirective, isStandalone: true, selector: "[tab-input-only]", host: { listeners: { "keydown": "handleTab($event)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TabToInputHandlerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tab-input-only]',
                    standalone: true,
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { handleTab: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }] } });

class ChrFormComponent {
    constructor(builder, changeDetector, element) {
        this.builder = builder;
        this.changeDetector = changeDetector;
        this.element = element;
        this.validators = null;
        this.validChange = new EventEmitter();
        this.model = null;
        this.modelChange = new EventEmitter();
        this.formDataChange = new EventEmitter();
        this.valuesChanges = new EventEmitter();
        this.compact = false;
        this.debounceTime = null;
        this.formChange = new EventEmitter();
        this.valueChanges = new EventEmitter();
        this.tabDisplay = false;
        this.formControls = {};
        /**
         * The related ReactiveForm of the form group. This is exposed to allow form extension and usage of custom form controls while still maintaining centralised validation and validity
         */
        this.form = this.builder.group({});
        this.formChanges = new EventEmitter();
        this.values = {};
        this.controlTypes = {};
        this.flattenedControls = {};
        this.flattenedShownControl = {};
        this.flattenedHiddenControls = {};
        this.initialized = false;
        this.initModel = () => {
            if (this.model === null)
                this.model = {};
            for (const key in this.flattenedControls) {
                const control = this.flattenedControls[key];
                if (this.model[key] === null || this.model[key] === undefined)
                    this.model[key] = control.value;
            }
        };
        this.initValues = () => {
            for (const key in this.flattenedControls) {
                if (this.values[key] === null || this.values[key] === undefined)
                    this.values[key] = this.model[key];
            }
        };
        this.initControls = () => {
            for (const key in this.flattenedShownControl) {
                const control = this.flattenedShownControl[key];
                const validators = getValidators(control.validations);
                this.initializeControl(control, new FormControl(this.values[key], validators));
            }
            this.valid = this.form.valid;
        };
        this.initListeners = () => {
            this.form.valueChanges.subscribe((values) => {
                this.form.updateValueAndValidity({ onlySelf: true, emitEvent: false });
                this.valid = this.form.valid;
                this.validChange.emit(this.valid);
            });
        };
        this.hasRegularFile = () => {
            for (const key in this.flattenedControls) {
                if (this.flattenedControls[key].type === 'file' &&
                    this.flattenedControls[key].base64 === false)
                    return true;
            }
            return false;
        };
        this.getEncType = () => {
            return this.hasRegularFile()
                ? 'multipart/form-data'
                : 'application/x-www-form-urlencoded';
        };
        /**
         * Methods that returns the FormControl for the given input. If no FormControl is found, return null.
         * @param name input's name
         * @returns the FormControl whose name matches the parameter
         */
        this.getControl = (name) => {
            if (name)
                return this.form.controls[name];
            return null;
        };
        /**
         * Focus the input for the user to start typing in.
         * @param name input's name
         */
        this.focus = (name) => {
            const el = this.element.nativeElement.querySelector(`input[name="${name}"]`);
            this.getControl(name)?.markAsTouched();
            this.changeDetector.detectChanges();
            setTimeout(() => {
                el?.focus();
            }, 10);
        };
        /**
         * Returns the value of the input whose name matches the parameter input.
         * If no input name is provided, returns the value of the form.
         * @param input name of the input
         * @returns the value of the input
         */
        this.value = (input) => this.getValue(input);
        /**
         * Returns the value of the input whose name matches the parameter input.
         * If no input name is provided, returns the value of the form.
         * @param input name of the input
         * @returns the value of the input
         */
        this.getValue = (input) => {
            if (input)
                return this.form.controls[input]?.value;
            return this.form.value;
        };
        /**
         * Returns the validity of the input.
         * If no input is provided, returns the validity of the form.
         * @param input name of the input
         * @returns
         */
        this.isValid = (input) => {
            if (input)
                return this.form.get(input)?.valid;
            return this.valid;
        };
        /**
         * Update the value of a control WITHOUT triggering the modelChange event
         * @param key input key (control name)
         * @param value value to set
         */
        this.setValue = (key, value) => {
            if (this.formControls[key] === undefined) {
                //console.log('[Form] Could not find control with the following name: ', key);
                return;
            }
            this.formControls[key].setValue(value, {
                emitEvent: false,
                emitModelToViewChange: true,
            });
            this.formControls[key].markAsTouched();
            this.model[key] = value;
        };
        /**
         * Update the value of the form's model WITHOUT triggering the modelChange event
         * @param model the model to set
         */
        this.set = (model) => {
            for (const key in this.flattenedControls) {
                this.setValue(key, model[key]);
            }
        };
        /**
         * Updates the value of a control. This WILL trigger the modelChange event
         * @param key input key (control name)
         * @param value value to set
         */
        this.patchValue = (key, value) => {
            this.setValue$(key, value);
            this.setModel$(key, value);
        };
        /**
         * Updates the value of the form's model. This WILL trigger the modelChange event once for each input
         * @param model model to set
         */
        this.patch = (model) => {
            for (const key in this.flattenedControls) {
                this.patchValue(key, model[key]);
            }
        };
        /**
         * Methods that checks the validity of each input of the form and updates their status. If the markAsTouched parameter si set to true, it will also mark the inputs as touched
         * so that the validation errors may be displayed to the user.
         * @param markAsTouched Boolean that describes whether or not the inputs of the form will be marked as touched.
         */
        this.checkValidity = (markAsTouched = true) => {
            for (const key in this.flattenedControls) {
                if (markAsTouched) {
                    this.formControls[key]?.markAsTouched({
                        onlySelf: false,
                        emitEvent: true,
                    });
                }
                this.formControls[key]?.updateValueAndValidity({
                    onlySelf: false,
                    emitEvent: true,
                });
            }
            this.form.updateValueAndValidity({ onlySelf: false, emitEvent: true });
            this.valid = this.form.valid;
        };
        /**
         * Here for compatibility. Same thing as checkValidity.
         */
        this.updateValueAndValidity = this.checkValidity;
        /**
         * Resets the form.
         */
        this.reset = () => {
            this.form.reset();
            this.form.setErrors(null);
            this.form.markAsUntouched();
            this.form.markAsPristine();
            for (const key in this.flattenedControls) {
                this.values[key] = this.formControls[key].value;
            }
        };
        this.toFormData = () => {
            const data = new FormData();
            for (const key in this.model) {
                if (this.flattenedControls[key].type === 'file' &&
                    this.flattenedControls[key].base64 === false) {
                    if (this.flattenedControls[key].multiple === true) {
                        for (const file of (this.model[key] ?? []))
                            data.append(key, file?.file ?? '');
                    }
                    else
                        data.append(key, this.model[key]?.file ?? '');
                }
                else
                    data.append(key, this.model[key] ?? '');
            }
            return data;
        };
        this.get = (control) => {
            return this.form.get([control.name]);
        };
        this.setValue$ = (key, value) => {
            if (this.formControls[key] === undefined) {
                //console.log('[Form] Could not find control with the following name: ', key);
                return;
            }
            this.formControls[key].patchValue(value);
            this.formControls[key].markAsTouched();
            this.values[key] = value;
        };
        this.setModel$ = (key, value) => {
            this.model[key] = value;
        };
        /**
         * Triggers the submit method and pass the local values as its parameters. The local values will contain the values of every input. Not just those that match de model's property (ex: like those provided by the modelChanges event).
         */
        this.doSubmit = () => {
            this.checkValidity();
            if (this.valid && this.form.valid)
                this.submit?.(this.values);
        };
        this.log = (el) => {
            console.log(el);
        };
        this.initializeControl = (control, formControl) => {
            // Add the control to the internal map
            this.formControls[control.name] = formControl;
            //Register the onChange listener that will emit the events associated with the input's update
            this.formControls[control.name].valueChanges.subscribe((value) => {
                //We dispatch the single value change event with the value
                this.valueChanges.emit({ [control.name]: value });
                //We update the local values
                this.values[control.name] = value;
                //If the model has a property, we update it with the value
                if (Object.hasOwn(this.model, control.name)) {
                    this.model[control.name] = value;
                    //Dispatch the whole model change event
                    this.modelChange.emit(this.model);
                }
                // Whether or not there is a matching property in the model, we update the local values
                this.values[control.name] = value;
            });
            this.controlTypes[control.name] = control.type;
            // Add the control to the formgroup
            this.form.addControl(control.name, formControl);
        };
        this.alert = (s) => {
            alert(s);
        };
        if (this.controls != null && this.sections != null)
            throw new Error("You can't use both controls and sections in the same form");
    }
    ngOnInit() {
        this.sections
            ?.map((s) => s.controls)
            .flat()
            .concat(this.controls ?? [])
            .forEach((s) => (this.flattenedControls[s.name] = s));
        for (const key in this.flattenedControls) {
            const control = this.flattenedControls[key];
            if (control.type === 'hidden')
                this.flattenedHiddenControls[key] = control;
            else
                this.flattenedShownControl[key] = control;
        }
        this.form = new FormGroup({}, { validators: this.validators });
        this.initModel();
        this.initValues();
        this.initControls();
        this.initListeners();
        this.initialized = true;
        this.formChanges.emit(this.form);
        this.modelChange.pipe(tap((r) => this.formDataChange.emit(this.toFormData())));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrFormComponent, deps: [{ token: i1$3.FormBuilder }, { token: i0.ChangeDetectorRef }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrFormComponent, isStandalone: true, selector: "app-chr-form", inputs: { sections: "sections", controls: "controls", validators: "validators", valid: "valid", model: "model", disabled: "disabled", submit: "submit", compact: "compact", debounceTime: "debounceTime", tabDisplay: "tabDisplay", form: "form" }, outputs: { validChange: "validChange", modelChange: "modelChange", formDataChange: "formDataChange", valuesChanges: "valuesChanges", formChange: "formChange", valueChanges: "valueChanges", formChanges: "formChanges" }, providers: [
            DatePipe,
            {
                provide: DATE_PIPE_DEFAULT_OPTIONS,
                useValue: { dateFormat: 'shortDate' },
            },
        ], ngImport: i0, template: "<div class=\"flex flex-col justify-center min-h-5/6 mt-2 w-full\">\n  <form [formGroup]=\"form\" *ngIf=\"initialized\" tab-input-only [attr.enctype]=\"getEncType()\">\n    <ng-container *ngIf=\"!tabDisplay || !sections\" [ngTemplateOutlet]=\"singleTemplate\"\n      [ngTemplateOutletContext]=\"{controls: controls}\">\n    </ng-container>\n    <ng-container *ngIf=\"!tabDisplay && sections\" [ngTemplateOutlet]=\"sectionTemplate\"\n      [ngTemplateOutletContext]=\"{sections: sections}\">\n    </ng-container>\n    <ng-container *ngIf=\"tabDisplay && sections\" [ngTemplateOutlet]=\"tabsTemplate\"\n      [ngTemplateOutletContext]=\"{sects: sections}\">\n    </ng-container>\n  </form>\n</div>\n\n<ng-template #tabsTemplate let-sections='sects'>\n  <fieldset [disabled]=\"disabled\">\n    <mat-tab-group>\n      @for (section of sections; track section; let index = $index) {\n      <mat-tab [label]=\"section.title || '\u00C9tape ' + (index + 1)\" class=\"custom-tab\">\n        <div *ngIf=\"initialized\" class=\"mt-4\"\n          [ngClass]=\"compact ? 'grid gap-y-2 gap-x-6 sm:grid-cols-4':'grid gap-y-2 gap-x-6 sm:grid-cols-2'\">\n          @for (ctrl of section.controls; track index; let index = $index; let\n          last =\n          $last)\n          {\n          <!-- <p class=\"bg-purple-600\">{{ctrl.name}} ({{formControls[ctrl.name].touched}}) ->\n            {{formControls[ctrl.name].valid}} :\n            {{formControls[ctrl.name].errors?.['required']}}\n          </p> -->\n          <ng-container [ngTemplateOutlet]=\"controlTemplate\"\n            [ngTemplateOutletContext]=\"{control: ctrl, index: index, last: $last}\">\n          </ng-container>\n          }\n        </div>\n      </mat-tab>\n      }\n    </mat-tab-group>\n  </fieldset>\n</ng-template>\n\n<ng-template #singleTemplate let-controls=\"controls\">\n  <fieldset [disabled]=\"disabled\">\n    <div *ngIf=\"initialized\"\n      [ngClass]=\"compact ? 'grid gap-y-2 gap-x-6 sm:grid-cols-4':'grid gap-y-2 gap-x-6 sm:grid-cols-2'\">\n      @for (control of controls; track control; let index = $index; let last = $last) {\n      <ng-container [ngTemplateOutlet]=\"controlTemplate\"\n        [ngTemplateOutletContext]=\"{control: control, index: index, last: last}\">\n      </ng-container>\n      }\n    </div>\n\n  </fieldset>\n</ng-template>\n\n<ng-template #sectionTemplate let-sections='sections'>\n  <fieldset [disabled]=\"disabled\">\n    @for (section of sections; track section; let index = $index) {\n    <div>\n      @if (section.title) {\n      <h2 class=\"mb-2 font-bold text-xl text-gray-900 dark:text-white\">\n        {{ section.title }}\n      </h2>\n      }\n      <div *ngIf=\"initialized\"\n        [ngClass]=\"compact ? 'grid gap-y-2 gap-x-6 sm:grid-cols-4':'grid gap-y-2 gap-x-6 sm:grid-cols-2'\">\n        @for (control of section.controls; track index; let index = $index; let\n        last =\n        $last)\n        {\n        <ng-container [ngTemplateOutlet]=\"controlTemplate\"\n          [ngTemplateOutletContext]=\"{control: control, index: index, last: $last}\">\n        </ng-container>\n        }\n      </div>\n      @if (index != (sections||[]).length - 1 && !compact) {\n      <div class=\"py-4\">\n        <hr class=\"\" />\n      </div>\n      }\n    </div>\n    }\n  </fieldset>\n</ng-template>\n\n<ng-template #controlTemplate let-control='control' let-last='last' let-index='index'>\n  <div class=\"relative h-min mt-2\" [formGroup]=\"form\" [ngClass]=\"{\n    'sm:col-span-2': (control.width == 'row' && !compact) || control.type=='textArea' && compact && control.width != 'row',\n    'sm:row-span-2': control.type == 'file' && control.multiple===true,\n    'sm:col-span-4': control.width =='row' && compact,\n    }\" (keyup.enter)=\"last && this.doSubmit()\">\n    @if (control.type=='searchSelect') {\n    <app-chr-search-select [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n      [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n      [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n      [iconTooltip]=\"control.iconTooltip\" [display]=\"control.fn!\" [filters]=\"control.filters\"\n      [debounceTime]=\"debounceTime\" [data]=\"control.data || []\" [addCallback]=\"control.addCallback\"\n      [autofocus]=\"control?.autofocus\" [acceptText]=\"control.acceptText\"\n      [validations]=\"control.validations\"></app-chr-search-select>\n    }\n    @if (control.type=='tagSelect') {\n    <app-chr-tag-select [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n      [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n      [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n      [editCallback]=\"control.editCallback\" [iconTooltip]=\"control.iconTooltip\" [display]=\"control.fn!\"\n      [debounceTime]=\"debounceTime\" [filters]=\"control.filters\" [data]=\"control.data || []\"\n      [editCallback]=\"control.editCallback\" [addCallback]=\"control.addCallback\"\n      [removeCallback]=\"control.removeCallback\" [validations]=\"control.validations\" [autofocus]=\"control?.autofocus\"\n      [acceptText]=\"control.acceptText\"></app-chr-tag-select>\n    }\n    <div class=\"relative z-0 w-full group/inputs content\">\n      <!-- Here we will *ngIf each type of input cause it's the cleanest way I can imagine-->\n      <!--TEXT, PASSWORD AND NUMBER-->\n      @if (control.type == 'text' || control.type == 'number' || control.type == 'password') {\n      <chr-base-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-base-input>\n      }\n      <!--TEXT AREA-->\n      @if (control.type == 'textArea') {\n      <chr-textarea-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-textarea-input>\n      }\n      <!--DATE-->\n      @if (control.type == 'date') {\n      <chr-date-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-date-input>\n      }\n      @if (control.type == 'datetime') {\n      <chr-datetime-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-datetime-input>\n      }\n      <!--COLOR-->\n      @if (control.type == 'color') {\n      <chr-color-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-color-input>\n      }\n      @if (control.type == 'toggle'){\n      <chr-toggle-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-toggle-input>\n      }\n      @if (control.type == 'file'){\n      <chr-file-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [iconTooltip]=\"control.iconTooltip\" [accept]=\"control.accept\" [debounceTime]=\"debounceTime\"\n        [autofocus]=\"control?.autofocus\" [multiple]=\"control.multiple\" [base64]=\"control.base64\"\n        [validations]=\"control.validations\"></chr-file-input>\n      }\n    </div>\n  </div>\n</ng-template>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}table{width:100%}::ng-deep .mat-mdc-tab *{color:var(--text-neutral-color)}::ng-deep .mat-mdc-tab-label-container{border:transparent!important}::ng-deep .arrow-color .mat-sort-header-arrow{color:#000}::ng-deep .mat-mdc-tab *{border-color:var(--primary-color)!important}@media (prefers-color-scheme: dark){::ng-deep .mat-mdc-tab *{border-color:var(--secondary-color)!important;color:var(--text-neutral-color)!important}}::ng-deep .mat-mdc-tab.mdc-tab--active *{color:var(--primary-color)!important}@media (prefers-color-scheme: dark){::ng-deep .mat-mdc-tab.mdc-tab--active *{color:var(--secondary-color)!important}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n", "*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}table{width:100%}::ng-deep .mat-mdc-tab *{color:var(--text-neutral-color)}::ng-deep .mat-mdc-tab-label-container{border:transparent!important}::ng-deep .arrow-color .mat-sort-header-arrow{color:#000}::ng-deep .mat-mdc-tab *{border-color:var(--primary-color)!important}@media (prefers-color-scheme: dark){::ng-deep .mat-mdc-tab *{border-color:var(--secondary-color)!important;color:var(--text-neutral-color)!important}}::ng-deep .mat-mdc-tab.mdc-tab--active *{color:var(--primary-color)!important}@media (prefers-color-scheme: dark){::ng-deep .mat-mdc-tab.mdc-tab--active *{color:var(--secondary-color)!important}}\n"], dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$3.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$3.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1$3.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i1$3.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "ngmodule", type: FormsModule }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "ngmodule", type: MatIconModule }, { kind: "ngmodule", type: MatSlideToggleModule }, { kind: "component", type: ChrTagSelectComponent, selector: "app-chr-tag-select, [app-chr-tag-select]", inputs: ["placeholder", "data", "display", "filters", "editCallback", "addCallback", "removeCallback", "acceptText"] }, { kind: "ngmodule", type: MatAutocompleteModule }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: MatTabsModule }, { kind: "component", type: i3$2.MatTab, selector: "mat-tab", inputs: ["disabled", "label", "aria-label", "aria-labelledby", "labelClass", "bodyClass", "id"], exportAs: ["matTab"] }, { kind: "component", type: i3$2.MatTabGroup, selector: "mat-tab-group", inputs: ["color", "fitInkBarToContent", "mat-stretch-tabs", "mat-align-tabs", "dynamicHeight", "selectedIndex", "headerPosition", "animationDuration", "contentTabIndex", "disablePagination", "disableRipple", "preserveContent", "backgroundColor", "aria-label", "aria-labelledby"], outputs: ["selectedIndexChange", "focusChange", "animationDone", "selectedTabChange"], exportAs: ["matTabGroup"] }, { kind: "component", type: ChrBaseInputComponent, selector: "chr-base-input", inputs: ["label", "type", "id", "name", "span", "icon", "iconCallback", "iconCallbackDisabled", "iconTooltip", "tooltip", "debounceTime", "validations", "standalone", "autofocus", "base64", "disabled", "siblings"], outputs: ["valueChanges"] }, { kind: "component", type: ChrColorInputComponent, selector: "chr-color-input" }, { kind: "component", type: ChrDateInputComponent, selector: "chr-date-input" }, { kind: "component", type: ChrDatetimeInputComponent, selector: "chr-datetime-input" }, { kind: "component", type: ChrToggleInputComponent, selector: "chr-toggle-input" }, { kind: "component", type: ChrFileInputComponent, selector: "chr-file-input", inputs: ["accept", "multiple", "editable"] }, { kind: "component", type: ChrSearchSelectComponent, selector: "app-chr-search-select, [app-chr-search-select]", inputs: ["placeholder", "data", "display", "filters", "addCallback", "acceptText"] }, { kind: "component", type: ChrTextareaInputComponent, selector: "chr-textarea-input" }, { kind: "directive", type: TabToInputHandlerDirective, selector: "[tab-input-only]" }], changeDetection: i0.ChangeDetectionStrategy.Default }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrFormComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-form', imports: [
                        ReactiveFormsModule,
                        FormsModule,
                        MatTooltipModule,
                        MatIconModule,
                        MatSlideToggleModule,
                        ChrTagSelectComponent,
                        MatAutocompleteModule,
                        CommonModule,
                        MatTabsModule,
                        ChrBaseInputComponent,
                        ChrColorInputComponent,
                        ChrDateInputComponent,
                        ChrDatetimeInputComponent,
                        ChrToggleInputComponent,
                        ChrFileInputComponent,
                        ChrSearchSelectComponent,
                        ChrTextareaInputComponent,
                        TabToInputHandlerDirective,
                    ], providers: [
                        DatePipe,
                        {
                            provide: DATE_PIPE_DEFAULT_OPTIONS,
                            useValue: { dateFormat: 'shortDate' },
                        },
                    ], changeDetection: ChangeDetectionStrategy.Default, template: "<div class=\"flex flex-col justify-center min-h-5/6 mt-2 w-full\">\n  <form [formGroup]=\"form\" *ngIf=\"initialized\" tab-input-only [attr.enctype]=\"getEncType()\">\n    <ng-container *ngIf=\"!tabDisplay || !sections\" [ngTemplateOutlet]=\"singleTemplate\"\n      [ngTemplateOutletContext]=\"{controls: controls}\">\n    </ng-container>\n    <ng-container *ngIf=\"!tabDisplay && sections\" [ngTemplateOutlet]=\"sectionTemplate\"\n      [ngTemplateOutletContext]=\"{sections: sections}\">\n    </ng-container>\n    <ng-container *ngIf=\"tabDisplay && sections\" [ngTemplateOutlet]=\"tabsTemplate\"\n      [ngTemplateOutletContext]=\"{sects: sections}\">\n    </ng-container>\n  </form>\n</div>\n\n<ng-template #tabsTemplate let-sections='sects'>\n  <fieldset [disabled]=\"disabled\">\n    <mat-tab-group>\n      @for (section of sections; track section; let index = $index) {\n      <mat-tab [label]=\"section.title || '\u00C9tape ' + (index + 1)\" class=\"custom-tab\">\n        <div *ngIf=\"initialized\" class=\"mt-4\"\n          [ngClass]=\"compact ? 'grid gap-y-2 gap-x-6 sm:grid-cols-4':'grid gap-y-2 gap-x-6 sm:grid-cols-2'\">\n          @for (ctrl of section.controls; track index; let index = $index; let\n          last =\n          $last)\n          {\n          <!-- <p class=\"bg-purple-600\">{{ctrl.name}} ({{formControls[ctrl.name].touched}}) ->\n            {{formControls[ctrl.name].valid}} :\n            {{formControls[ctrl.name].errors?.['required']}}\n          </p> -->\n          <ng-container [ngTemplateOutlet]=\"controlTemplate\"\n            [ngTemplateOutletContext]=\"{control: ctrl, index: index, last: $last}\">\n          </ng-container>\n          }\n        </div>\n      </mat-tab>\n      }\n    </mat-tab-group>\n  </fieldset>\n</ng-template>\n\n<ng-template #singleTemplate let-controls=\"controls\">\n  <fieldset [disabled]=\"disabled\">\n    <div *ngIf=\"initialized\"\n      [ngClass]=\"compact ? 'grid gap-y-2 gap-x-6 sm:grid-cols-4':'grid gap-y-2 gap-x-6 sm:grid-cols-2'\">\n      @for (control of controls; track control; let index = $index; let last = $last) {\n      <ng-container [ngTemplateOutlet]=\"controlTemplate\"\n        [ngTemplateOutletContext]=\"{control: control, index: index, last: last}\">\n      </ng-container>\n      }\n    </div>\n\n  </fieldset>\n</ng-template>\n\n<ng-template #sectionTemplate let-sections='sections'>\n  <fieldset [disabled]=\"disabled\">\n    @for (section of sections; track section; let index = $index) {\n    <div>\n      @if (section.title) {\n      <h2 class=\"mb-2 font-bold text-xl text-gray-900 dark:text-white\">\n        {{ section.title }}\n      </h2>\n      }\n      <div *ngIf=\"initialized\"\n        [ngClass]=\"compact ? 'grid gap-y-2 gap-x-6 sm:grid-cols-4':'grid gap-y-2 gap-x-6 sm:grid-cols-2'\">\n        @for (control of section.controls; track index; let index = $index; let\n        last =\n        $last)\n        {\n        <ng-container [ngTemplateOutlet]=\"controlTemplate\"\n          [ngTemplateOutletContext]=\"{control: control, index: index, last: $last}\">\n        </ng-container>\n        }\n      </div>\n      @if (index != (sections||[]).length - 1 && !compact) {\n      <div class=\"py-4\">\n        <hr class=\"\" />\n      </div>\n      }\n    </div>\n    }\n  </fieldset>\n</ng-template>\n\n<ng-template #controlTemplate let-control='control' let-last='last' let-index='index'>\n  <div class=\"relative h-min mt-2\" [formGroup]=\"form\" [ngClass]=\"{\n    'sm:col-span-2': (control.width == 'row' && !compact) || control.type=='textArea' && compact && control.width != 'row',\n    'sm:row-span-2': control.type == 'file' && control.multiple===true,\n    'sm:col-span-4': control.width =='row' && compact,\n    }\" (keyup.enter)=\"last && this.doSubmit()\">\n    @if (control.type=='searchSelect') {\n    <app-chr-search-select [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n      [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n      [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n      [iconTooltip]=\"control.iconTooltip\" [display]=\"control.fn!\" [filters]=\"control.filters\"\n      [debounceTime]=\"debounceTime\" [data]=\"control.data || []\" [addCallback]=\"control.addCallback\"\n      [autofocus]=\"control?.autofocus\" [acceptText]=\"control.acceptText\"\n      [validations]=\"control.validations\"></app-chr-search-select>\n    }\n    @if (control.type=='tagSelect') {\n    <app-chr-tag-select [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n      [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n      [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n      [editCallback]=\"control.editCallback\" [iconTooltip]=\"control.iconTooltip\" [display]=\"control.fn!\"\n      [debounceTime]=\"debounceTime\" [filters]=\"control.filters\" [data]=\"control.data || []\"\n      [editCallback]=\"control.editCallback\" [addCallback]=\"control.addCallback\"\n      [removeCallback]=\"control.removeCallback\" [validations]=\"control.validations\" [autofocus]=\"control?.autofocus\"\n      [acceptText]=\"control.acceptText\"></app-chr-tag-select>\n    }\n    <div class=\"relative z-0 w-full group/inputs content\">\n      <!-- Here we will *ngIf each type of input cause it's the cleanest way I can imagine-->\n      <!--TEXT, PASSWORD AND NUMBER-->\n      @if (control.type == 'text' || control.type == 'number' || control.type == 'password') {\n      <chr-base-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-base-input>\n      }\n      <!--TEXT AREA-->\n      @if (control.type == 'textArea') {\n      <chr-textarea-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-textarea-input>\n      }\n      <!--DATE-->\n      @if (control.type == 'date') {\n      <chr-date-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-date-input>\n      }\n      @if (control.type == 'datetime') {\n      <chr-datetime-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-datetime-input>\n      }\n      <!--COLOR-->\n      @if (control.type == 'color') {\n      <chr-color-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-color-input>\n      }\n      @if (control.type == 'toggle'){\n      <chr-toggle-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [debounceTime]=\"debounceTime\" [iconTooltip]=\"control.iconTooltip\" [autofocus]=\"control?.autofocus\"\n        [validations]=\"control.validations\"></chr-toggle-input>\n      }\n      @if (control.type == 'file'){\n      <chr-file-input [name]=\"control.name\" [label]=\"control.label\" [type]=\"control.type\" [id]=\"control\"\n        [formControlName]=\"control.name\" [span]=\"control.span\" [tooltip]=\"control.tooltip\" [icon]=\"control.icon\"\n        [iconCallback]=\"control.iconCallback\" [iconCallbackDisabled]=\"control.iconCallbackDisabled\"\n        [iconTooltip]=\"control.iconTooltip\" [accept]=\"control.accept\" [debounceTime]=\"debounceTime\"\n        [autofocus]=\"control?.autofocus\" [multiple]=\"control.multiple\" [base64]=\"control.base64\"\n        [validations]=\"control.validations\"></chr-file-input>\n      }\n    </div>\n  </div>\n</ng-template>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}table{width:100%}::ng-deep .mat-mdc-tab *{color:var(--text-neutral-color)}::ng-deep .mat-mdc-tab-label-container{border:transparent!important}::ng-deep .arrow-color .mat-sort-header-arrow{color:#000}::ng-deep .mat-mdc-tab *{border-color:var(--primary-color)!important}@media (prefers-color-scheme: dark){::ng-deep .mat-mdc-tab *{border-color:var(--secondary-color)!important;color:var(--text-neutral-color)!important}}::ng-deep .mat-mdc-tab.mdc-tab--active *{color:var(--primary-color)!important}@media (prefers-color-scheme: dark){::ng-deep .mat-mdc-tab.mdc-tab--active *{color:var(--secondary-color)!important}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n", "*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}table{width:100%}::ng-deep .mat-mdc-tab *{color:var(--text-neutral-color)}::ng-deep .mat-mdc-tab-label-container{border:transparent!important}::ng-deep .arrow-color .mat-sort-header-arrow{color:#000}::ng-deep .mat-mdc-tab *{border-color:var(--primary-color)!important}@media (prefers-color-scheme: dark){::ng-deep .mat-mdc-tab *{border-color:var(--secondary-color)!important;color:var(--text-neutral-color)!important}}::ng-deep .mat-mdc-tab.mdc-tab--active *{color:var(--primary-color)!important}@media (prefers-color-scheme: dark){::ng-deep .mat-mdc-tab.mdc-tab--active *{color:var(--secondary-color)!important}}\n"] }]
        }], ctorParameters: () => [{ type: i1$3.FormBuilder }, { type: i0.ChangeDetectorRef }, { type: i0.ElementRef }], propDecorators: { sections: [{
                type: Input
            }], controls: [{
                type: Input
            }], validators: [{
                type: Input
            }], valid: [{
                type: Input
            }], validChange: [{
                type: Output
            }], model: [{
                type: Input
            }], modelChange: [{
                type: Output
            }], formDataChange: [{
                type: Output
            }], disabled: [{
                type: Input
            }], valuesChanges: [{
                type: Output
            }], submit: [{
                type: Input
            }], compact: [{
                type: Input
            }], debounceTime: [{
                type: Input
            }], formChange: [{
                type: Output
            }], valueChanges: [{
                type: Output
            }], tabDisplay: [{
                type: Input
            }], form: [{
                type: Input
            }], formChanges: [{
                type: Output
            }] } });

class CookiesService {
    constructor() { }
    /**
     * delete cookie
     * @param name
     */
    deleteCookie(name) {
        this.setCookie(name, "", -1);
    }
    /**
     * get cookie
     * @param {string} name
     * @returns {string}
     */
    getCookie(name) {
        const ca = decodeURIComponent(document.cookie).split(";");
        const caLen = ca.length;
        const cookieName = `${name}=`;
        let c;
        for (let i = 0; i < caLen; i += 1) {
            c = ca[i].replace(/^\s+/g, "");
            if (c.indexOf(cookieName) === 0) {
                return c.substring(cookieName.length, c.length);
            }
        }
        return "";
    }
    /**
     * set cookie
     * @param {string} name
     * @param {string} value
     * @param {number} expireDays
     * @param {string} path
     */
    setCookie(name, value, expireDays, path = "") {
        const d = new Date();
        d.setTime(d.getTime() + expireDays * 24 * 60 * 60 * 1000);
        const expires = `expires=${d.toUTCString()}`;
        const cpath = path ? `; path=${path}` : "";
        document.cookie = `${name}=${value}; ${expires}${cpath}; SameSite=Lax`;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: CookiesService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: CookiesService, providedIn: "root" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: CookiesService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: "root",
                }]
        }], ctorParameters: () => [] });

class DataService {
    constructor(platformId) {
        this.platformId = platformId;
        this.data = new Map();
        this.persistData = {};
        this.syncData = {};
        this.set = (key, value, persist = false) => {
            const data = this.data.get(key);
            if (data === null || data === undefined)
                this.data.set(key, new BehaviorSubject(value));
            else
                data.next(value);
            this.syncData[key] = value;
            this.persistData[key] = persist;
            this.persist().subscribe();
        };
        this.get = (key) => {
            const data = this.data.get(key);
            if (!data)
                this.data.set(key, new BehaviorSubject(null));
            return this.data.get(key);
        };
        this.getSync = (key) => {
            return this.syncData[key];
        };
        this.clear = (key) => {
            return this.data.get(key)?.next(null);
        };
        this.remove = (key) => {
            return this.data.delete(key);
        };
        this.persist = () => {
            return new Observable((observer) => {
                const toPersist = {};
                this.data.forEach((value, key) => {
                    if (this.persistData[key])
                        value.subscribe((r) => (toPersist[key] = r));
                });
                if (isPlatformBrowser(this.platformId)) {
                    localStorage.setItem('_chr_data', JSON.stringify(toPersist));
                }
                observer.next('Opération terminée');
                observer.complete();
            });
        };
        this.load = () => {
            if (isPlatformBrowser(this.platformId)) {
                const data = localStorage.getItem('_chr_data');
                if (data) {
                    const value = JSON.parse(data);
                    Object.keys(value).forEach((key) => {
                        const subject = this.data.get(key);
                        if (subject === undefined || subject === null) {
                            this.data.set(key, new BehaviorSubject(value[key]));
                            this.persistData[key] = true;
                        }
                        else {
                            subject.next(value[key]);
                        }
                    });
                }
            }
        };
        this.load();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: DataService, deps: [{ token: PLATFORM_ID }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: DataService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: DataService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: Object, decorators: [{
                    type: Inject,
                    args: [PLATFORM_ID]
                }] }] });

class ChrPaginatorComponent {
    get page() {
        return this._page || 1;
    }
    set page(value) {
        this._page = value;
        this.pageChange.emit(value);
        this.changeDetector.markForCheck();
        this.changeDetector.detectChanges();
    }
    get pageSize() {
        return this._pageSize || 20;
    }
    set pageSize(value) {
        this._pageSize = value;
        this.pageSizeChange.emit(value);
        this.changeDetector.markForCheck();
        this.changeDetector.detectChanges();
    }
    get dataSize() {
        return this.instance?.totalItems ?? 0;
    }
    get currentlyShownSize() {
        const mult = this.page * this.pageSize;
        return mult > this.dataSize ? this.dataSize : mult;
    }
    constructor(service, cookieService, dataService, changeDetector) {
        this.service = service;
        this.cookieService = cookieService;
        this.dataService = dataService;
        this.changeDetector = changeDetector;
        this._page = null;
        this._pageSize = null;
        this.pageChange = new EventEmitter();
        this.pageSizeChange = new EventEmitter();
        this.id = 'chr_base-data-table';
        this.allowSizeChange = 'true';
        this.pageSizeForm = null;
        this.previous = () => {
            if (this.isFirstPage())
                return;
            this.page--;
            this.pageChange.emit(this.page);
            this.dataService.set(`${this.id}_page`, this.page);
        };
        this.next = () => {
            if (this.isLastPage())
                return;
            this.page += 1;
            this.pageChange.emit(this.page);
            this.dataService.set(`${this.id}_page`, this.page);
        };
        this.setPage = (page) => {
            if (page < 1 || page > this.lastPage())
                return;
            this.page = page;
            this.dataService.set(`${this.id}_page`, page);
            this.emit();
        };
        this.setPageEventHandler = (event) => {
            return this.setPage(event.target.value);
        };
        this.isFirstPage = () => {
            return this.page == 1;
        };
        this.setPageSize = (pageSize) => {
            this.setPage(1);
            if (this.instance)
                this.instance.itemsPerPage = pageSize;
            this.dataService.set(`${this.id}_pagesize`, pageSize);
            this.pageSizeChange.emit(pageSize);
        };
        this.setPageSizeEventHandler = (event) => {
            return this.setPageSize(event.target.value);
        };
        this.isLastPage = () => {
            if (!this.instance?.totalItems)
                return false;
            return (this.page >=
                Math.ceil(this.instance.totalItems / this.instance.itemsPerPage));
        };
        // public pageSize = () => this.instance.itemsPerPage;
        this.lastPage = () => this.instance?.totalItems
            ? Math.ceil(this.instance.totalItems / this.instance.itemsPerPage)
            : 1;
        this.emit = (page = undefined) => {
            if (!page)
                this.pageChange.emit(this.page);
            else
                this.pageChange.emit(page);
        };
    }
    ngAfterContentChecked() {
        this.instance = this.service.getInstance(`${this.id}`);
    }
    ngOnInit() {
        this.dataService.get(`${this.id}_pagesize`).subscribe((res) => {
            if (res) {
                this.pageSize = res;
                this.pageSizeChange.emit(res);
            }
        });
        this.dataService.get(`${this.id}_page`).subscribe((res) => {
            if (res) {
                this.page = res;
                this.pageChange.emit(res);
            }
        });
    }
    ngAfterViewInit() {
        this.pageSizeForm?.patchValue('pageSize', this.pageSize);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrPaginatorComponent, deps: [{ token: i1.PaginationService }, { token: CookiesService }, { token: DataService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrPaginatorComponent, isStandalone: true, selector: "app-chr-paginator", inputs: { page: "page", pageSize: "pageSize", id: "id", allowSizeChange: "allowSizeChange" }, outputs: { pageChange: "pageChange", pageSizeChange: "pageSizeChange" }, viewQueries: [{ propertyName: "pageSizeForm", first: true, predicate: ["pageSizeForm"], descendants: true }], ngImport: i0, template: "<div class=\"flex flex-row justify-between dark:text-gray-400\">\n    <div class=\"flex flex-row justify-start py-2 items-center content-center\">\n        @if (allowSizeChange === true || allowSizeChange == 'true') {\n        <div class=\"w-40\">\n            <app-chr-form #pageSizeForm id=\"table-paginator-form\" (keyup.enter)=\"setPageSizeEventHandler($event)\"\n                [sections]=\"[\n            { \n                controls: [\n                {\n                    label:'\u00C9l\u00E9ments par page',\n                    type: 'number',\n                    name: 'pageSize',\n                    value: pageSize,\n                    width: 'row',\n                    icon: 'check',\n                    iconCallback: setPageSize,\n                    iconTooltip: 'Cliquez ici pour mettre \u00E0 jour le nombre d\\'\u00E9l\u00E9ments affich\u00E9s'\n                }]\n            }]\">\n            </app-chr-form>\n        </div>\n        }\n    </div>\n    <div class=\"flex flex-row justify-end py-2 items-center content-center \">\n        <span class=\"entry-indicator\">{{currentlyShownSize}} \u00E9l\u00E9ments sur\n            {{dataSize}}</span>\n\n        <button type=\"button\" (click)=\"previous()\" [ngClass]=\"isFirstPage() ? 'cursor-not-allowed':'cursor-pointer'\"\n            class=\"w-fit flex justify-center align-middle items-center\"><mat-icon>arrow_left</mat-icon></button>\n        <div class=\"flex flex-row items-center content-center mx-2 w-fit\">\n            {{page}} / {{lastPage()}}\n        </div>\n        <button type=\"button\" [ngClass]=\"!isLastPage() ? 'cursor-pointer' : 'cursor-not-allowed'\"\n            (click)=\"!isLastPage() && next()\"\n            class=\"w-fit flex justify-center align-middle items-center\"><mat-icon>arrow_right</mat-icon></button>\n    </div>\n</div>", styles: [".entry-indicator{color:var(--text-neutral-color)}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "component", type: ChrFormComponent, selector: "app-chr-form", inputs: ["sections", "controls", "validators", "valid", "model", "disabled", "submit", "compact", "debounceTime", "tabDisplay", "form"], outputs: ["validChange", "modelChange", "formDataChange", "valuesChanges", "formChange", "valueChanges", "formChanges"] }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrPaginatorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-paginator', imports: [ChrFormComponent, CommonModule, MatIconModule], template: "<div class=\"flex flex-row justify-between dark:text-gray-400\">\n    <div class=\"flex flex-row justify-start py-2 items-center content-center\">\n        @if (allowSizeChange === true || allowSizeChange == 'true') {\n        <div class=\"w-40\">\n            <app-chr-form #pageSizeForm id=\"table-paginator-form\" (keyup.enter)=\"setPageSizeEventHandler($event)\"\n                [sections]=\"[\n            { \n                controls: [\n                {\n                    label:'\u00C9l\u00E9ments par page',\n                    type: 'number',\n                    name: 'pageSize',\n                    value: pageSize,\n                    width: 'row',\n                    icon: 'check',\n                    iconCallback: setPageSize,\n                    iconTooltip: 'Cliquez ici pour mettre \u00E0 jour le nombre d\\'\u00E9l\u00E9ments affich\u00E9s'\n                }]\n            }]\">\n            </app-chr-form>\n        </div>\n        }\n    </div>\n    <div class=\"flex flex-row justify-end py-2 items-center content-center \">\n        <span class=\"entry-indicator\">{{currentlyShownSize}} \u00E9l\u00E9ments sur\n            {{dataSize}}</span>\n\n        <button type=\"button\" (click)=\"previous()\" [ngClass]=\"isFirstPage() ? 'cursor-not-allowed':'cursor-pointer'\"\n            class=\"w-fit flex justify-center align-middle items-center\"><mat-icon>arrow_left</mat-icon></button>\n        <div class=\"flex flex-row items-center content-center mx-2 w-fit\">\n            {{page}} / {{lastPage()}}\n        </div>\n        <button type=\"button\" [ngClass]=\"!isLastPage() ? 'cursor-pointer' : 'cursor-not-allowed'\"\n            (click)=\"!isLastPage() && next()\"\n            class=\"w-fit flex justify-center align-middle items-center\"><mat-icon>arrow_right</mat-icon></button>\n    </div>\n</div>", styles: [".entry-indicator{color:var(--text-neutral-color)}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1.PaginationService }, { type: CookiesService }, { type: DataService }, { type: i0.ChangeDetectorRef }], propDecorators: { page: [{
                type: Input
            }], pageChange: [{
                type: Output
            }], pageSize: [{
                type: Input
            }], pageSizeChange: [{
                type: Output
            }], id: [{
                type: Input
            }], allowSizeChange: [{
                type: Input
            }], pageSizeForm: [{
                type: ViewChild,
                args: ['pageSizeForm']
            }] } });

class ChrDataTable {
    /**
     * Data to display.
     * @see If it's piped with | Async, please note that the input column may not work as expected
     */
    get data() {
        return this._data;
    }
    set data(value) {
        this._data = value || [];
        this.currentPage = 1;
    }
    constructor(dataService, changeDetector) {
        this.dataService = dataService;
        this.changeDetector = changeDetector;
        this._data = [];
        /**
         * Whether or not the table will show a column with a checkbox to select entries. Default is false
         */
        this.selectable = false;
        /**
         * The selected entries
         */
        this.selection = [];
        /**
         * The selected entries change event. This will be triggered on each selection and contain the full array of selected entries
         */
        this.selectionChange = new EventEmitter();
        /**
         * Wheter or not the current sort is ascendant. Default is true
         */
        this.isAsc = true;
        this.isAscChange = new EventEmitter();
        this.sortByChange = new EventEmitter();
        /**
         * The page size for the table. Default is 20
         */
        this.pageSize = 20;
        this.pageSizeChange = new EventEmitter();
        /**
         * The current page of the table. Default is 1
         */
        this.currentPage = 1;
        this.currentPageChange = new EventEmitter();
        /**
         * The ID of the table. It's used to persist page size and currentpage when the user change pages
         */
        this.id = 'chr_base-data-table';
        /**
         * The color to use for the table's header
         */
        this.color = 'primary';
        /**
         * The table's columns definitions
         */
        this.columns = [];
        this.select = (entry, event) => {
            const pointer = event;
            const target = pointer.target;
            if (target.checked) {
                this.selection = [
                    ...this.selection,
                    ...(Array.isArray(entry) ? entry : [entry]),
                ];
            }
            else {
                this.selection = [
                    ...(Array.isArray(entry)
                        ? this.selection.filter((x) => !entry.includes(x))
                        : this.selection.filter((x) => x !== entry)),
                ];
            }
            this.selectionChange.emit(this.selection);
        };
        this.getSelection = () => {
            return this.selection;
        };
        this.setSelection = (data) => {
            this.selection = data;
            this.selectionChange.emit(this.selection);
            this.changeDetector.markForCheck();
        };
        this.contains = (entry) => {
            return this.selection.includes(entry);
        };
        this.updateModel = (entry, properties, value) => {
            var pList = properties.split('.');
            var len = pList.length;
            for (var i = 0; i < len - 1; i++) {
                var elem = pList[i];
                if (!entry[elem])
                    entry[elem] = {};
                entry = entry[elem];
            }
            entry[pList[len - 1]] = value.key;
        };
        this.getTextColor = (color = 'none') => {
            return getTextColor(color);
        };
        this.getBackgroundColor = (color = 'none') => {
            return getBackgroundColor(color);
        };
        this.getContrastTextColor = (color = 'black') => {
            return getContrastTextColor(color);
        };
        this.getBorderColor = (color = 'none') => {
            return getBorderColor(color);
        };
        this.sort = (properties) => {
            if (properties === null || properties === undefined)
                return;
            const alreadySorted = this.sortBy == properties;
            if (alreadySorted) {
                this.isAsc = !this.isAsc;
                this.isAscChange.emit(this.isAsc);
            }
            else {
                this.sortBy = properties;
                this.sortByChange.emit(this.sortBy);
                this.isAsc = true;
                this.isAscChange.emit(true);
            }
        };
    }
    ngOnInit() {
        this.dataService.get(`${this.id}_sortBy`).subscribe((res) => {
            if (res)
                this.sortBy = res;
            this.changeDetector.markForCheck();
        });
        this.dataService.get(`${this.id}_isAsc`).subscribe((res) => {
            if (res)
                this.isAsc = res;
            this.changeDetector.markForCheck();
        });
    }
    emitIsAsc(isAsc) {
        this.dataService.set(`${this.id}_isAsc`, isAsc);
        this.isAscChange.emit(isAsc);
        this.changeDetector.markForCheck();
    }
    emitSortBy(sortBy) {
        this.dataService.set(`${this.id}_sortBy`, sortBy);
        this.sortByChange.emit(sortBy);
        this.changeDetector.markForCheck();
    }
    emitPageSize(pageSize) {
        this.pageSize = pageSize;
        this.pageSizeChange.emit(pageSize);
        this.changeDetector.markForCheck();
    }
    emitCurrentPage(currentPage) {
        this.currentPage = currentPage;
        this.currentPageChange.emit(currentPage);
        this.changeDetector.markForCheck();
    }
    getNestedProperty(obj, path) {
        if (path === null || path === undefined)
            return obj;
        const value = path.split('.').reduce((acc, key) => acc && acc[key], obj);
        return value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDataTable, deps: [{ token: DataService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.5", type: ChrDataTable, isStandalone: true, selector: "chr-table", inputs: { data: "data", selectable: "selectable", selection: "selection", actions: "actions", isAsc: "isAsc", sortBy: "sortBy", pageSize: "pageSize", currentPage: "currentPage", id: "id", color: "color", columns: "columns" }, outputs: { selectionChange: "selectionChange", isAscChange: "isAscChange", sortByChange: "sortByChange", pageSizeChange: "pageSizeChange", currentPageChange: "currentPageChange" }, providers: [PaginationService], ngImport: i0, template: "<table class=\"hidden md:!table chr-table\">\r\n    <thead>\r\n        <tr>\r\n            <th *ngIf=\"selectable\" [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\" class=\"w-min\"\r\n                (click)=\"checkbox.click()\">\r\n                <input #checkbox type=\"checkbox\" class=\"pointer-events-none\" (click)=\"select(data, $event)\" />\r\n            </th>\r\n            <th *ngFor=\"let column of columns || []\" class=\"header-cell\"\r\n                [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\" (click)=\"sort(column.properties)\">\r\n                <div class=\"header-cell-content-wrapper\">\r\n                    <span class=\"header-cell-content\">{{column.display}}</span>\r\n                    <mat-icon class=\"header-cell-content\"\r\n                        *ngIf=\"column.properties && sortBy == column.properties && isAsc\">arrow_upward</mat-icon>\r\n                    <!-- \uD83E\uDC71 \uD83E\uDC73 -->\r\n                    <mat-icon class=\"header-cell-content\"\r\n                        *ngIf=\"column.properties && sortBy == column.properties && !isAsc\">arrow_downward</mat-icon>\r\n                </div>\r\n            </th>\r\n            <th *ngIf=\"actions\" class=\"actions-header-cell\"\r\n                [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\">Actions</th>\r\n        </tr>\r\n    </thead>\r\n    <tbody>\r\n        <tr *ngIf=\"data === null || data === undefined || data.length <= 0\">\r\n            <td *ngIf=\"selectable\"></td>\r\n            <td>Pas de donn\u00E9es</td>\r\n        </tr>\r\n        <tr [ngClass]=\"getBorderColor(color)\"\r\n            *ngFor=\"let entry of (data || []) | sort:isAsc:sortBy | paginate: {itemsPerPage: pageSize, currentPage: currentPage, id: this.id};\">\r\n            <td *ngIf=\"selectable\" class=\"w-min\" (click)=\"checkbox.click()\">\r\n                <input #checkbox type=\"checkbox\" class=\"pointer-events-none\" (click)=\"select(entry, $event)\"\r\n                    [checked]=\"contains(entry)\" />\r\n            </td>\r\n            <td *ngFor=\"let column of columns || []\" [ngSwitch]=\"column.type\" tab-input-only>\r\n                <ng-container *ngSwitchDefault [ngTemplateOutlet]=\"default\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'date'\" [ngTemplateOutlet]=\"date\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'input'\" [ngTemplateOutlet]=\"input\" class=\"form-wrapper\"\r\n                    [ngTemplateOutletContext]=\"{entry: entry, value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'chips'\" [ngTemplateOutlet]=\"chip\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n            </td>\r\n            <td *ngIf=\"actions\">\r\n                <div class=\"actions-cell\">\r\n                    <app-chr-button *ngFor=\"let action of actions\" [display]=\"action.display\" [icon]=\"action.icon\"\r\n                        [click]=\"action.callback.bind(null, entry)\" [color]=\"action.color\" [disabled]=\"\r\n                                            action.disabledCallback\r\n                                                ? action.disabledCallback(entry)\r\n                                                : action.disabled || false\">\r\n                    </app-chr-button>\r\n                </div>\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n    <tfoot></tfoot>\r\n</table>\r\n\r\n<div class=\"md:!hidden chr-mobile-table\">\r\n    <div class=\"entry\"\r\n        *ngFor=\"let entry of (data || []) | sort:isAsc:sortBy | paginate: {itemsPerPage: pageSize, currentPage: currentPage, id: this.id};\">\r\n        <div class=\"entry-row\" [ngClass]=\"getBorderColor(color)\">\r\n            <div class=\"entry-header\" *ngIf=\"selectable\"\r\n                [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\">\r\n\r\n            </div>\r\n            <div *ngIf=\"selectable\" class=\"entry-content flex flex-row justify-center\" (click)=\"checkbox.click()\">\r\n                <input #checkbox type=\"checkbox\" class=\"pointer-events-none\" (click)=\"select(entry, $event)\"\r\n                    [checked]=\"contains(entry)\" />\r\n            </div>\r\n        </div>\r\n        <div class=\"entry-row\" *ngFor=\"let column of columns || []\" [ngClass]=\"getBorderColor(color)\">\r\n            <div class=\"entry-header\" [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\">\r\n                {{column.display}}\r\n            </div>\r\n            <div class=\"entry-content\" [ngSwitch]=\"column.type\" tab-input-only>\r\n                <ng-container *ngSwitchDefault [ngTemplateOutlet]=\"default\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'date'\" [ngTemplateOutlet]=\"date\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'input'\" [ngTemplateOutlet]=\"input\" class=\"form-wrapper\"\r\n                    [ngTemplateOutletContext]=\"{entry: entry, value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'chips'\" [ngTemplateOutlet]=\"chip\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n            </div>\r\n        </div>\r\n        <div class=\"entry-row\">\r\n            <div class=\"entry-header\" *ngIf=\"actions\"\r\n                [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\">\r\n                Actions\r\n            </div>\r\n            <div *ngIf=\"actions\" class=\"entry-content actions-cell\">\r\n                <app-chr-button class=\"w-full\" *ngFor=\"let action of actions\" [display]=\"action.display\"\r\n                    [icon]=\"action.icon\" type=\"full\" [click]=\"action.callback.bind(null, entry)\" [color]=\"action.color\"\r\n                    [disabled]=\"\r\n                                                            action.disabledCallback\r\n                                                                ? action.disabledCallback(entry)\r\n                                                                : action.disabled || false\">\r\n                </app-chr-button>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n<app-chr-paginator [id]=\"this.id\" [(pageSize)]=\"pageSize\" [(page)]=\"currentPage\" (pageSizeChange)=\"emitPageSize($event)\"\r\n    (pageChange)=\"emitCurrentPage($event)\"></app-chr-paginator>\r\n\r\n<!-- CELL TEMPLATES -->\r\n<ng-template #default let-column='column' let-value=\"value\">\r\n    <span *ngIf=\"column.callback? column.callback(value) : value as val\">{{val}}</span>\r\n</ng-template>\r\n<ng-template #date let-column='column' let-value=\"value\">\r\n    <span *ngIf=\"column.callback? column.callback(value) : value as val\">{{val | date: column.format}}</span>\r\n</ng-template>\r\n<ng-template #link let-column='column' let-value=\"value\">\r\n    <a *ngIf=\"column.callback? column.callback(value) : value as val\" target=\"_blank\"\r\n        [href]=\"column.url + '/'+ val\">{{val}}</a>\r\n</ng-template>\r\n<ng-template #input let-entry=\"entry\" let-column='column' let-value=\"value\" class=\"w-full\">\r\n    <app-chr-form class=\"form-wrapper w-full\" [model]=\"{key: value}\"\r\n        (modelChange)=\"updateModel(entry, column.properties, $event)\" [sections]=\"[\r\n                {\r\n                    controls:[\r\n                        {\r\n                            name: 'key',\r\n                            type: column.inputType || 'text',\r\n                            validations: column.validations,\r\n                            width: 'row'\r\n                        }\r\n                    ]\r\n                }\r\n                ]\">\r\n    </app-chr-form>\r\n</ng-template>\r\n<ng-template #chip let-column='column' let-value=\"value\">\r\n    <div *ngIf=\"column.callback? column.callback(value) : value as val\"\r\n        class=\"w-full h-full flex flex-row items-center align-middle\">\r\n        <span *ngIf=\"(column.chips?.[val] || column.chips?.[column.chipsCallback(val)]) as chip\"\r\n            class=\"w-full md:max-w-36 flex text-center content-center align-middle items-center justify-center text-xs font-medium py-0.5 rounded-full\"\r\n            [ngClass]=\"[getBackgroundColor(chip.color), getContrastTextColor(chip.color)]\">\r\n            {{ chip.display }}\r\n        </span>\r\n    </div>\r\n</ng-template>", styles: ["table{table-layout:auto;width:100%;box-shadow:1px 6px 10px #0003;border-radius:.5rem}td>*{text-wrap:pretty}th{height:3rem;padding:.5rem .25rem;text-align:left}th:is(:first-child){border-top-left-radius:.25rem}th:is(:last-child){border-top-right-radius:.25rem}td{color:var(--text-color)}td:is(:first-child){border-top-left-radius:.5rem;border-bottom-left-radius:.5rem}td:is(:last-child){border-top-right-radius:.5rem;border-bottom-right-radius:.5rem}tr{border-radius:.5rem}tr{border-bottom-width:2px}tr:is(:last-child){border:0}td{height:3rem;padding:.25rem .125rem}tr:nth-child(2n){background-color:var(--neutral-color)}.header-cell{cursor:pointer}.header-cell-content-wrapper{color:inherit;display:flex;flex-direction:row;width:100%;height:100%;justify-content:space-between;align-items:center}.header-cell-content{color:inherit}.actions-cell{display:flex;flex-direction:row;gap:.5rem;justify-content:flex-end}.actions-header-cell{text-align:center;width:min-content}::ng-deep .form-wrapper *{padding:0!important;margin:0!important}::ng-deep .form-wrapper{display:flex;flex-direction:row;align-items:center;align-content:center;justify-items:center;width:100%!important}.chr-mobile-table{display:flex;flex-direction:column;gap:1rem}.entry{display:flex;flex-direction:column;text-wrap:pretty;color:var(--text-color)}.entry-row{display:grid;flex-direction:row;grid-template-columns:8rem 1fr}.entry-row:not(:last-child){border-bottom-width:2px}.entry-header{display:flex;align-items:center;padding:1rem 1rem 1rem .5rem;border-radius:inherit}.entry-row:is(:first-child){border-top-left-radius:.5rem}.entry-row:is(:last-child){border-bottom-left-radius:.5rem}.entry-content{display:flex;align-items:center;width:100%;padding:1rem .5rem 1rem 1rem}.hidden{display:none}@media (min-width: 768px){.md\\:\\!table{display:table!important}}@media (min-width: 768px){.md\\:\\!hidden{display:none!important}}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i2.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i2.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { kind: "pipe", type: i2.DatePipe, name: "date" }, { kind: "component", type: ChrPaginatorComponent, selector: "app-chr-paginator", inputs: ["page", "pageSize", "id", "allowSizeChange"], outputs: ["pageChange", "pageSizeChange"] }, { kind: "ngmodule", type: NgxPaginationModule }, { kind: "pipe", type: i1.PaginatePipe, name: "paginate" }, { kind: "component", type: ChrButtonComponent, selector: "app-chr-button", inputs: ["display", "icon", "click", "clickWhileDisabled", "color", "textColor", "flat", "predicate", "type", "href", "target", "disabled", "tooltip", "tooltipPosition"] }, { kind: "component", type: ChrFormComponent, selector: "app-chr-form", inputs: ["sections", "controls", "validators", "valid", "model", "disabled", "submit", "compact", "debounceTime", "tabDisplay", "form"], outputs: ["validChange", "modelChange", "formDataChange", "valuesChanges", "formChange", "valueChanges", "formChanges"] }, { kind: "pipe", type: SortPipe, name: "sort" }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: TabToInputHandlerDirective, selector: "[tab-input-only]" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDataTable, decorators: [{
            type: Component,
            args: [{ selector: 'chr-table', imports: [
                        CommonModule,
                        ChrPaginatorComponent,
                        NgxPaginationModule,
                        ChrButtonComponent,
                        ChrFormComponent,
                        SortPipe,
                        MatIcon,
                        TabToInputHandlerDirective,
                    ], providers: [PaginationService], template: "<table class=\"hidden md:!table chr-table\">\r\n    <thead>\r\n        <tr>\r\n            <th *ngIf=\"selectable\" [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\" class=\"w-min\"\r\n                (click)=\"checkbox.click()\">\r\n                <input #checkbox type=\"checkbox\" class=\"pointer-events-none\" (click)=\"select(data, $event)\" />\r\n            </th>\r\n            <th *ngFor=\"let column of columns || []\" class=\"header-cell\"\r\n                [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\" (click)=\"sort(column.properties)\">\r\n                <div class=\"header-cell-content-wrapper\">\r\n                    <span class=\"header-cell-content\">{{column.display}}</span>\r\n                    <mat-icon class=\"header-cell-content\"\r\n                        *ngIf=\"column.properties && sortBy == column.properties && isAsc\">arrow_upward</mat-icon>\r\n                    <!-- \uD83E\uDC71 \uD83E\uDC73 -->\r\n                    <mat-icon class=\"header-cell-content\"\r\n                        *ngIf=\"column.properties && sortBy == column.properties && !isAsc\">arrow_downward</mat-icon>\r\n                </div>\r\n            </th>\r\n            <th *ngIf=\"actions\" class=\"actions-header-cell\"\r\n                [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\">Actions</th>\r\n        </tr>\r\n    </thead>\r\n    <tbody>\r\n        <tr *ngIf=\"data === null || data === undefined || data.length <= 0\">\r\n            <td *ngIf=\"selectable\"></td>\r\n            <td>Pas de donn\u00E9es</td>\r\n        </tr>\r\n        <tr [ngClass]=\"getBorderColor(color)\"\r\n            *ngFor=\"let entry of (data || []) | sort:isAsc:sortBy | paginate: {itemsPerPage: pageSize, currentPage: currentPage, id: this.id};\">\r\n            <td *ngIf=\"selectable\" class=\"w-min\" (click)=\"checkbox.click()\">\r\n                <input #checkbox type=\"checkbox\" class=\"pointer-events-none\" (click)=\"select(entry, $event)\"\r\n                    [checked]=\"contains(entry)\" />\r\n            </td>\r\n            <td *ngFor=\"let column of columns || []\" [ngSwitch]=\"column.type\" tab-input-only>\r\n                <ng-container *ngSwitchDefault [ngTemplateOutlet]=\"default\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'date'\" [ngTemplateOutlet]=\"date\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'input'\" [ngTemplateOutlet]=\"input\" class=\"form-wrapper\"\r\n                    [ngTemplateOutletContext]=\"{entry: entry, value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'chips'\" [ngTemplateOutlet]=\"chip\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n            </td>\r\n            <td *ngIf=\"actions\">\r\n                <div class=\"actions-cell\">\r\n                    <app-chr-button *ngFor=\"let action of actions\" [display]=\"action.display\" [icon]=\"action.icon\"\r\n                        [click]=\"action.callback.bind(null, entry)\" [color]=\"action.color\" [disabled]=\"\r\n                                            action.disabledCallback\r\n                                                ? action.disabledCallback(entry)\r\n                                                : action.disabled || false\">\r\n                    </app-chr-button>\r\n                </div>\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n    <tfoot></tfoot>\r\n</table>\r\n\r\n<div class=\"md:!hidden chr-mobile-table\">\r\n    <div class=\"entry\"\r\n        *ngFor=\"let entry of (data || []) | sort:isAsc:sortBy | paginate: {itemsPerPage: pageSize, currentPage: currentPage, id: this.id};\">\r\n        <div class=\"entry-row\" [ngClass]=\"getBorderColor(color)\">\r\n            <div class=\"entry-header\" *ngIf=\"selectable\"\r\n                [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\">\r\n\r\n            </div>\r\n            <div *ngIf=\"selectable\" class=\"entry-content flex flex-row justify-center\" (click)=\"checkbox.click()\">\r\n                <input #checkbox type=\"checkbox\" class=\"pointer-events-none\" (click)=\"select(entry, $event)\"\r\n                    [checked]=\"contains(entry)\" />\r\n            </div>\r\n        </div>\r\n        <div class=\"entry-row\" *ngFor=\"let column of columns || []\" [ngClass]=\"getBorderColor(color)\">\r\n            <div class=\"entry-header\" [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\">\r\n                {{column.display}}\r\n            </div>\r\n            <div class=\"entry-content\" [ngSwitch]=\"column.type\" tab-input-only>\r\n                <ng-container *ngSwitchDefault [ngTemplateOutlet]=\"default\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'date'\" [ngTemplateOutlet]=\"date\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'input'\" [ngTemplateOutlet]=\"input\" class=\"form-wrapper\"\r\n                    [ngTemplateOutletContext]=\"{entry: entry, value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n                <ng-container *ngSwitchCase=\"'chips'\" [ngTemplateOutlet]=\"chip\"\r\n                    [ngTemplateOutletContext]=\"{value: getNestedProperty(entry, column.properties), column: column}\">\r\n                </ng-container>\r\n            </div>\r\n        </div>\r\n        <div class=\"entry-row\">\r\n            <div class=\"entry-header\" *ngIf=\"actions\"\r\n                [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(color)]\">\r\n                Actions\r\n            </div>\r\n            <div *ngIf=\"actions\" class=\"entry-content actions-cell\">\r\n                <app-chr-button class=\"w-full\" *ngFor=\"let action of actions\" [display]=\"action.display\"\r\n                    [icon]=\"action.icon\" type=\"full\" [click]=\"action.callback.bind(null, entry)\" [color]=\"action.color\"\r\n                    [disabled]=\"\r\n                                                            action.disabledCallback\r\n                                                                ? action.disabledCallback(entry)\r\n                                                                : action.disabled || false\">\r\n                </app-chr-button>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n<app-chr-paginator [id]=\"this.id\" [(pageSize)]=\"pageSize\" [(page)]=\"currentPage\" (pageSizeChange)=\"emitPageSize($event)\"\r\n    (pageChange)=\"emitCurrentPage($event)\"></app-chr-paginator>\r\n\r\n<!-- CELL TEMPLATES -->\r\n<ng-template #default let-column='column' let-value=\"value\">\r\n    <span *ngIf=\"column.callback? column.callback(value) : value as val\">{{val}}</span>\r\n</ng-template>\r\n<ng-template #date let-column='column' let-value=\"value\">\r\n    <span *ngIf=\"column.callback? column.callback(value) : value as val\">{{val | date: column.format}}</span>\r\n</ng-template>\r\n<ng-template #link let-column='column' let-value=\"value\">\r\n    <a *ngIf=\"column.callback? column.callback(value) : value as val\" target=\"_blank\"\r\n        [href]=\"column.url + '/'+ val\">{{val}}</a>\r\n</ng-template>\r\n<ng-template #input let-entry=\"entry\" let-column='column' let-value=\"value\" class=\"w-full\">\r\n    <app-chr-form class=\"form-wrapper w-full\" [model]=\"{key: value}\"\r\n        (modelChange)=\"updateModel(entry, column.properties, $event)\" [sections]=\"[\r\n                {\r\n                    controls:[\r\n                        {\r\n                            name: 'key',\r\n                            type: column.inputType || 'text',\r\n                            validations: column.validations,\r\n                            width: 'row'\r\n                        }\r\n                    ]\r\n                }\r\n                ]\">\r\n    </app-chr-form>\r\n</ng-template>\r\n<ng-template #chip let-column='column' let-value=\"value\">\r\n    <div *ngIf=\"column.callback? column.callback(value) : value as val\"\r\n        class=\"w-full h-full flex flex-row items-center align-middle\">\r\n        <span *ngIf=\"(column.chips?.[val] || column.chips?.[column.chipsCallback(val)]) as chip\"\r\n            class=\"w-full md:max-w-36 flex text-center content-center align-middle items-center justify-center text-xs font-medium py-0.5 rounded-full\"\r\n            [ngClass]=\"[getBackgroundColor(chip.color), getContrastTextColor(chip.color)]\">\r\n            {{ chip.display }}\r\n        </span>\r\n    </div>\r\n</ng-template>", styles: ["table{table-layout:auto;width:100%;box-shadow:1px 6px 10px #0003;border-radius:.5rem}td>*{text-wrap:pretty}th{height:3rem;padding:.5rem .25rem;text-align:left}th:is(:first-child){border-top-left-radius:.25rem}th:is(:last-child){border-top-right-radius:.25rem}td{color:var(--text-color)}td:is(:first-child){border-top-left-radius:.5rem;border-bottom-left-radius:.5rem}td:is(:last-child){border-top-right-radius:.5rem;border-bottom-right-radius:.5rem}tr{border-radius:.5rem}tr{border-bottom-width:2px}tr:is(:last-child){border:0}td{height:3rem;padding:.25rem .125rem}tr:nth-child(2n){background-color:var(--neutral-color)}.header-cell{cursor:pointer}.header-cell-content-wrapper{color:inherit;display:flex;flex-direction:row;width:100%;height:100%;justify-content:space-between;align-items:center}.header-cell-content{color:inherit}.actions-cell{display:flex;flex-direction:row;gap:.5rem;justify-content:flex-end}.actions-header-cell{text-align:center;width:min-content}::ng-deep .form-wrapper *{padding:0!important;margin:0!important}::ng-deep .form-wrapper{display:flex;flex-direction:row;align-items:center;align-content:center;justify-items:center;width:100%!important}.chr-mobile-table{display:flex;flex-direction:column;gap:1rem}.entry{display:flex;flex-direction:column;text-wrap:pretty;color:var(--text-color)}.entry-row{display:grid;flex-direction:row;grid-template-columns:8rem 1fr}.entry-row:not(:last-child){border-bottom-width:2px}.entry-header{display:flex;align-items:center;padding:1rem 1rem 1rem .5rem;border-radius:inherit}.entry-row:is(:first-child){border-top-left-radius:.5rem}.entry-row:is(:last-child){border-bottom-left-radius:.5rem}.entry-content{display:flex;align-items:center;width:100%;padding:1rem .5rem 1rem 1rem}.hidden{display:none}@media (min-width: 768px){.md\\:\\!table{display:table!important}}@media (min-width: 768px){.md\\:\\!hidden{display:none!important}}\n"] }]
        }], ctorParameters: () => [{ type: DataService }, { type: i0.ChangeDetectorRef }], propDecorators: { data: [{
                type: Input
            }], selectable: [{
                type: Input
            }], selection: [{
                type: Input
            }], selectionChange: [{
                type: Output
            }], actions: [{
                type: Input
            }], isAsc: [{
                type: Input
            }], isAscChange: [{
                type: Output
            }], sortBy: [{
                type: Input
            }], sortByChange: [{
                type: Output
            }], pageSize: [{
                type: Input
            }], pageSizeChange: [{
                type: Output
            }], currentPage: [{
                type: Input
            }], currentPageChange: [{
                type: Output
            }], id: [{
                type: Input
            }], color: [{
                type: Input
            }], columns: [{
                type: Input
            }] } });

class ChrNiceFileInputComponent extends ChrFileInputComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrNiceFileInputComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrNiceFileInputComponent, isStandalone: true, selector: "chr-nice-file-input", usesInheritance: true, ngImport: i0, template: "<div class=\"flex flex-col items-center justify-center w-full h-full\">\r\n    <div class=\"flex flex-col items-center justify-center w-full h-full border-2 border-dashed rounded-lg cursor-pointer dropzone p-4\"\r\n        [ngClass]=\"{\r\n            'border-error': hasError() && isTouched\r\n        }\" (click)=\"f.click()\" (click)=\"onTouch($event)\">\r\n        <!-- Zone de drop / clic fichier -->\r\n        <div class=\"flex flex-col items-center justify-center pt-5 pb-2\">\r\n            <svg class=\"w-8 h-8\" aria-hidden=\"true\" xmlns=\"http://www.w3.org/2000/svg\" fill=\"none\" viewBox=\"0 0 20 16\">\r\n                <path stroke=\"currentColor\" stroke-linecap=\"round\" stroke-linejoin=\"round\" stroke-width=\"2\"\r\n                    d=\"M13 13h3a3 3 0 0 0 0-6h-.025A5.56 5.56 0 0 0 16 6.5 5.5 5.5 0 0 0 5.207 5.021C5.137 5.017 5.071 5 5 5a4 4 0 0 0 0 8h2.167M10 15V6m0 0L8 8m2-2 2 2\" />\r\n            </svg>\r\n            <p *ngIf=\"files.length <= 0\" class=\"text-sm text-color\">\r\n                <span class=\"font-semibold\">{{label ?? 'Cliquez pour ajouter'}}</span> <span *ngIf=\"isControlRequired()\"\r\n                    class=\"text-error\">*</span>\r\n            </p>\r\n            <p class=\"text-error font-bold\" *ngIf=\"hasError() && isTouched\">{{ getLastError() }}</p>\r\n            <p class=\"text-xs text-neutral font-semibold mt-2\">Format(s) accept\u00E9(s):</p>\r\n            <p class=\"text-xs text-neutral\">{{ getToAccept() }}</p>\r\n            <input #f type=\"file\" [attr.multiple]=\"multiple\" class=\"hidden\" [chrAutofocus]=\"autofocus || false\"\r\n                [accept]=\"acceptToString()\" (change)=\"onFileChange($event)\" />\r\n        </div>\r\n    </div>\r\n    <div class=\"w-full\">\r\n        @for(file of files; track file; let index = $index){\r\n        <ng-container *ngIf=\"file | async as conversion\">\r\n            <div class=\"progress-bar\">\r\n                <div class=\"progress\" [style.width]=\"conversion.progress + '%'\" [ngClass]=\"{\r\n                'ongoing': conversion.progress > 0 && conversion.progress < 100,\r\n                'finished': !errors?.[index] && conversion.progress === 100,\r\n                'error': errors?.[index] === true\r\n              }\"></div>\r\n                <div class=\"progress-text-wrapper\">\r\n                    <span class=\"progress-text\" (input)=\"changeFileName($event, conversion.file)\"\r\n                        [attr.contenteditable]=\"editable\">{{conversion.file?.name}}</span>\r\n                    <div class=\"progress-icon-wrapper\">\r\n                        <span class=\"progress-bar-progress\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\">\r\n                            {{conversion.progress}}%\r\n                        </span>\r\n                        <mat-icon class=\"progress-bar-delete cursor-pointer\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\"\r\n                            (click)=\"openFile(index, conversion.file)\">visibility</mat-icon>\r\n                        <mat-icon class=\"progress-bar-delete cursor-pointer\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\"\r\n                            (click)=\"removeFile(index, conversion.file)\">delete</mat-icon>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </ng-container>\r\n        }\r\n    </div>\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:1.25rem}.text-contrast{color:var(--primary-contrast-color)}input[disabled]{pointer-events:none}.progress-bar{width:100%;height:1.5rem;background-color:#e0e0e0;border-radius:5px;overflow:hidden;position:relative}.progress-bar:not(:last-child){margin-bottom:.25rem}.progress{position:absolute;top:0;bottom:0;left:0;height:100%;transition:width .2s ease}.percentage{position:absolute;bottom:0;top:0;display:flex;justify-content:center;align-items:center;right:.25rem}.ongoing{background-color:var(--secondary-color)}.finished{background-color:var(--primary-color)}.finished+.progress-text-wrapper>*{color:var(--primary-contrast-color)}.error{background-color:var(--error-color)}.error+.progress-text-wrapper>*{color:var(--error-contrast-color)}.border-ongoing{border-color:var(--secondary-color)}.border-finished{border-color:var(--primary-color)}.filename{position:absolute;bottom:0;top:0;left:.25rem}.progress-text-wrapper{position:absolute;inset:1;display:flex;width:100%;flex-direction:row;justify-content:space-between;align-items:center;padding-left:.25rem;padding-right:.25rem}.progress-bar:hover .progress-bar-delete{visibility:visible;transform:translate(0);opacity:1;transition:all 125ms ease-in-out}.progress-bar-delete{visibility:hidden;transform:translate(3rem);opacity:0;transition:all 125ms ease-in-out}.progress-bar-delete:hover{filter:brightness(80%)}.progress-icon-wrapper{display:flex;flex-direction:row;align-items:center;justify-content:center;gap:.5rem}.progress-text{overflow:hidden;text-overflow:ellipsis;text-wrap:nowrap}.progress-bar-progress{transform:translate(3.75rem);transition:all 125ms ease-in-out}.progress-bar:hover .progress-bar-progress{transform:translate(0);transition:all 125ms ease-in-out}.text-neutral{color:var(--text-neutral-color)}.dropzone{transition:all .25s;background-color:var(--primary-contrast-color)}.dropzone:hover{transition:all .25s;background-color:var(--neutral-color)}.border-error{border-color:var(--error-color)}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: AutofocusDirective, selector: "[chrAutofocus]", inputs: ["chrAutofocus"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrNiceFileInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'chr-nice-file-input', imports: [CommonModule, MatIconModule, AutofocusDirective], template: "<div class=\"flex flex-col items-center justify-center w-full h-full\">\r\n    <div class=\"flex flex-col items-center justify-center w-full h-full border-2 border-dashed rounded-lg cursor-pointer dropzone p-4\"\r\n        [ngClass]=\"{\r\n            'border-error': hasError() && isTouched\r\n        }\" (click)=\"f.click()\" (click)=\"onTouch($event)\">\r\n        <!-- Zone de drop / clic fichier -->\r\n        <div class=\"flex flex-col items-center justify-center pt-5 pb-2\">\r\n            <svg class=\"w-8 h-8\" aria-hidden=\"true\" xmlns=\"http://www.w3.org/2000/svg\" fill=\"none\" viewBox=\"0 0 20 16\">\r\n                <path stroke=\"currentColor\" stroke-linecap=\"round\" stroke-linejoin=\"round\" stroke-width=\"2\"\r\n                    d=\"M13 13h3a3 3 0 0 0 0-6h-.025A5.56 5.56 0 0 0 16 6.5 5.5 5.5 0 0 0 5.207 5.021C5.137 5.017 5.071 5 5 5a4 4 0 0 0 0 8h2.167M10 15V6m0 0L8 8m2-2 2 2\" />\r\n            </svg>\r\n            <p *ngIf=\"files.length <= 0\" class=\"text-sm text-color\">\r\n                <span class=\"font-semibold\">{{label ?? 'Cliquez pour ajouter'}}</span> <span *ngIf=\"isControlRequired()\"\r\n                    class=\"text-error\">*</span>\r\n            </p>\r\n            <p class=\"text-error font-bold\" *ngIf=\"hasError() && isTouched\">{{ getLastError() }}</p>\r\n            <p class=\"text-xs text-neutral font-semibold mt-2\">Format(s) accept\u00E9(s):</p>\r\n            <p class=\"text-xs text-neutral\">{{ getToAccept() }}</p>\r\n            <input #f type=\"file\" [attr.multiple]=\"multiple\" class=\"hidden\" [chrAutofocus]=\"autofocus || false\"\r\n                [accept]=\"acceptToString()\" (change)=\"onFileChange($event)\" />\r\n        </div>\r\n    </div>\r\n    <div class=\"w-full\">\r\n        @for(file of files; track file; let index = $index){\r\n        <ng-container *ngIf=\"file | async as conversion\">\r\n            <div class=\"progress-bar\">\r\n                <div class=\"progress\" [style.width]=\"conversion.progress + '%'\" [ngClass]=\"{\r\n                'ongoing': conversion.progress > 0 && conversion.progress < 100,\r\n                'finished': !errors?.[index] && conversion.progress === 100,\r\n                'error': errors?.[index] === true\r\n              }\"></div>\r\n                <div class=\"progress-text-wrapper\">\r\n                    <span class=\"progress-text\" (input)=\"changeFileName($event, conversion.file)\"\r\n                        [attr.contenteditable]=\"editable\">{{conversion.file?.name}}</span>\r\n                    <div class=\"progress-icon-wrapper\">\r\n                        <span class=\"progress-bar-progress\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\">\r\n                            {{conversion.progress}}%\r\n                        </span>\r\n                        <mat-icon class=\"progress-bar-delete cursor-pointer\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\"\r\n                            (click)=\"openFile(index, conversion.file)\">visibility</mat-icon>\r\n                        <mat-icon class=\"progress-bar-delete cursor-pointer\"\r\n                            [ngClass]=\"{'text-contrast': conversion.progress === 100 || errors?.[index]}\"\r\n                            (click)=\"removeFile(index, conversion.file)\">delete</mat-icon>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </ng-container>\r\n        }\r\n    </div>\r\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.label{font-weight:700!important}.input:focus+.label{color:var(--primary-color)}input.error{border-color:var(--error-color)}.text-span{color:var(--text-neutral-color)}.text-error{color:var(--error-color)!important}.input:placeholder-shown:not(:focus)+.label{transition:all .15s linear;font-size:.875rem;line-height:1.25rem;top:.5rem;left:0}.input+.label{transition:all .15s linear;--tw-scale-x: 1;--tw-scale-y: 1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));font-size:.75rem;line-height:1rem;top:-.5rem;left:0;z-index:-10}.input{z-index:1!important;background-color:transparent;border-color:var(--neutral-color)}.input:focus{border-color:var(--primary-color)}.label{z-index:2!important;font-weight:600;pointer-events:none}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{-webkit-appearance:none!important;margin:0!important}.no-scrollbar::-webkit-scrollbar{display:none!important}.no-scrollbar{-ms-overflow-style:none!important;scrollbar-width:none!important}.height-normalized{height:2rem}.mat-mdc-autocomplete-panel{-ms-overflow-style:none!important;scrollbar-width:none!important}.mat-mdc-autocomplete-panel::-webkit-scrollbar{display:none}::ng-deep mat-option{background-color:var(--background-color)!important}@media (prefers-color-scheme: dark){.input:focus{border-color:var(--secondary-color)}.input:focus+.label{color:var(--secondary-color)}}.height-normalized{height:1.25rem}.text-contrast{color:var(--primary-contrast-color)}input[disabled]{pointer-events:none}.progress-bar{width:100%;height:1.5rem;background-color:#e0e0e0;border-radius:5px;overflow:hidden;position:relative}.progress-bar:not(:last-child){margin-bottom:.25rem}.progress{position:absolute;top:0;bottom:0;left:0;height:100%;transition:width .2s ease}.percentage{position:absolute;bottom:0;top:0;display:flex;justify-content:center;align-items:center;right:.25rem}.ongoing{background-color:var(--secondary-color)}.finished{background-color:var(--primary-color)}.finished+.progress-text-wrapper>*{color:var(--primary-contrast-color)}.error{background-color:var(--error-color)}.error+.progress-text-wrapper>*{color:var(--error-contrast-color)}.border-ongoing{border-color:var(--secondary-color)}.border-finished{border-color:var(--primary-color)}.filename{position:absolute;bottom:0;top:0;left:.25rem}.progress-text-wrapper{position:absolute;inset:1;display:flex;width:100%;flex-direction:row;justify-content:space-between;align-items:center;padding-left:.25rem;padding-right:.25rem}.progress-bar:hover .progress-bar-delete{visibility:visible;transform:translate(0);opacity:1;transition:all 125ms ease-in-out}.progress-bar-delete{visibility:hidden;transform:translate(3rem);opacity:0;transition:all 125ms ease-in-out}.progress-bar-delete:hover{filter:brightness(80%)}.progress-icon-wrapper{display:flex;flex-direction:row;align-items:center;justify-content:center;gap:.5rem}.progress-text{overflow:hidden;text-overflow:ellipsis;text-wrap:nowrap}.progress-bar-progress{transform:translate(3.75rem);transition:all 125ms ease-in-out}.progress-bar:hover .progress-bar-progress{transform:translate(0);transition:all 125ms ease-in-out}.text-neutral{color:var(--text-neutral-color)}.dropzone{transition:all .25s;background-color:var(--primary-contrast-color)}.dropzone:hover{transition:all .25s;background-color:var(--neutral-color)}.border-error{border-color:var(--error-color)}\n"] }]
        }] });

class ChrSearchbarComponent {
    constructor() {
        this.modelChange = new EventEmitter();
        this.searchBy = new FormControl('');
        this.searchBy.valueChanges.subscribe((value) => this.emit(value));
    }
    emit(event) {
        this.modelChange.emit(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrSearchbarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.5", type: ChrSearchbarComponent, isStandalone: true, selector: "app-chr-searchbar", inputs: { model: "model", placeholder: "placeholder", label: "label" }, outputs: { modelChange: "modelChange" }, ngImport: i0, template: "<div class=\"w-full relative z-0 group/inputs\">\n  <input matInput [formControl]=\"searchBy\" placeholder=\" \" type=\"text\"\n    class=\"block py-2.5 px-0 w-full text-sm text-gray-900 dark:text-white bg-transparent border-0 border-b-2 border-gray-300 appearance-none dark:border-gray-600 dark:focus:border-chrlblue focus:outline-none focus:ring-0 focus:border-chrdblue peer/inputs\" />\n  <label\n    class=\"peer/inputs-focus:font-medium absolute text-sm text-gray-500 dark:text-gray-400 duration-300 transform -translate-y-6 scale-75 top-3 -z-10 origin-[0] peer-focus/inputs:start-0 rtl:peer-focus/inputs:translate-x-1/4 rtl:peer-focus/inputs:left-auto peer-focus/inputs:text-chrdblue peer-focus/inputs:dark:text-chrlblue 0 peer-placeholder-shown/inputs:scale-100 peer-placeholder-shown/inputs:translate-y-0 peer-focus/inputs:scale-75 peer-focus/inputs:-translate-y-6\">{{\n    label\n    }}\n    <!--\n    @for (validation of control.validations; track validation) {\n    @if (\n    control?.touched &&\n    form.hasError(validation.rule.toLowerCase(), name)\n    ) {\n    <mat-error class=\"text-red-500 dark:text-red-800\">{{ validation.display }}</mat-error>\n    }\n    }\n    -->\n  </label>\n</div>", styles: ["", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$3.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrSearchbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-searchbar', imports: [ReactiveFormsModule], template: "<div class=\"w-full relative z-0 group/inputs\">\n  <input matInput [formControl]=\"searchBy\" placeholder=\" \" type=\"text\"\n    class=\"block py-2.5 px-0 w-full text-sm text-gray-900 dark:text-white bg-transparent border-0 border-b-2 border-gray-300 appearance-none dark:border-gray-600 dark:focus:border-chrlblue focus:outline-none focus:ring-0 focus:border-chrdblue peer/inputs\" />\n  <label\n    class=\"peer/inputs-focus:font-medium absolute text-sm text-gray-500 dark:text-gray-400 duration-300 transform -translate-y-6 scale-75 top-3 -z-10 origin-[0] peer-focus/inputs:start-0 rtl:peer-focus/inputs:translate-x-1/4 rtl:peer-focus/inputs:left-auto peer-focus/inputs:text-chrdblue peer-focus/inputs:dark:text-chrlblue 0 peer-placeholder-shown/inputs:scale-100 peer-placeholder-shown/inputs:translate-y-0 peer-focus/inputs:scale-75 peer-focus/inputs:-translate-y-6\">{{\n    label\n    }}\n    <!--\n    @for (validation of control.validations; track validation) {\n    @if (\n    control?.touched &&\n    form.hasError(validation.rule.toLowerCase(), name)\n    ) {\n    <mat-error class=\"text-red-500 dark:text-red-800\">{{ validation.display }}</mat-error>\n    }\n    }\n    -->\n  </label>\n</div>", styles: ["*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [], propDecorators: { model: [{
                type: Input
            }], modelChange: [{
                type: Output
            }], placeholder: [{
                type: Input
            }], label: [{
                type: Input
            }] } });

/**
 * This should only be used as a directive
 */
class ChrTableHeaderCellComponent {
    constructor(changeDetector) {
        this.changeDetector = changeDetector;
        this.isAsc = true;
        this.isAscChange = new EventEmitter();
        this.sortByChange = new EventEmitter();
        this.orderBy = (column) => {
            if (!this.sortBy)
                this.sortBy = column;
            if (this.sortBy == column) {
                this.isAsc = !this.isAsc;
                this.sortBy = column;
                this.isAscChange.emit(this.isAsc);
                this.sortByChange.emit(this.sortBy);
            }
            else {
                this.isAsc = true;
                this.sortBy = column;
                this.isAscChange.emit(this.isAsc);
                this.sortByChange.emit(this.sortBy);
            }
            this.changeDetector.markForCheck();
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrTableHeaderCellComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrTableHeaderCellComponent, isStandalone: true, selector: "app-chr-table-header-cell, [app-chr-table-header-cell]", inputs: { display: "display", column: "column", alignment: "alignment", isAsc: "isAsc", sortBy: "sortBy" }, outputs: { isAscChange: "isAscChange", sortByChange: "sortByChange" }, ngImport: i0, template: "<div class=\"relative w-full cursor-pointer flex flex-row align-middle self-center\" [ngClass]=\"\n              alignment == 'left' ? 'justify-start' : \n              alignment == 'center' ? 'justify-center' : \n              alignment == 'right' ? 'justify-end' : \n              'justify-left'\" (click)=\"orderBy(column)\">\n  <p>{{ display }}</p>\n  @if (sortBy) {\n  <div class=\"absolute right-3 top-0 h-0 w-0\">\n    @if (sortBy == column && isAsc) {\n    <mat-icon>arrow_upward</mat-icon>\n    }\n    @if (sortBy == column && !isAsc) {\n    <mat-icon>arrow_downward</mat-icon>\n    }\n  </div>\n  }\n</div>\n<ng-content></ng-content>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)}@media (min-width: 640px){table{display:inline-table!important}thead tr:not(:first-child){display:none}.border-primary{border-width:2px;--tw-border-opacity: 1;border-color:var(--secondary-color)}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrTableHeaderCellComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-table-header-cell, [app-chr-table-header-cell]', imports: [NgClass, MatIcon], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"relative w-full cursor-pointer flex flex-row align-middle self-center\" [ngClass]=\"\n              alignment == 'left' ? 'justify-start' : \n              alignment == 'center' ? 'justify-center' : \n              alignment == 'right' ? 'justify-end' : \n              'justify-left'\" (click)=\"orderBy(column)\">\n  <p>{{ display }}</p>\n  @if (sortBy) {\n  <div class=\"absolute right-3 top-0 h-0 w-0\">\n    @if (sortBy == column && isAsc) {\n    <mat-icon>arrow_upward</mat-icon>\n    }\n    @if (sortBy == column && !isAsc) {\n    <mat-icon>arrow_downward</mat-icon>\n    }\n  </div>\n  }\n</div>\n<ng-content></ng-content>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)}@media (min-width: 640px){table{display:inline-table!important}thead tr:not(:first-child){display:none}.border-primary{border-width:2px;--tw-border-opacity: 1;border-color:var(--secondary-color)}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }], propDecorators: { display: [{
                type: Input
            }], column: [{
                type: Input
            }], alignment: [{
                type: Input
            }], isAsc: [{
                type: Input
            }], isAscChange: [{
                type: Output
            }], sortBy: [{
                type: Input
            }], sortByChange: [{
                type: Output
            }] } });

const Aligments = {
    left: 'text-left justify-start',
    center: 'text-center justify-center',
    right: 'text-right justify-end',
};
class ChrTableComponent {
    get data() {
        return this._data;
    }
    set data(value) {
        this._data = value || [];
        this.changeDetector.markForCheck();
        this.currentPage = 1;
    }
    constructor(_date, dataService, changeDetector) {
        this._date = _date;
        this.dataService = dataService;
        this.changeDetector = changeDetector;
        this._data = [];
        this.isAsc = true;
        this.isAscChange = new EventEmitter();
        this.sortByChange = new EventEmitter();
        this.pageSize = 50;
        this.pageSizeChange = new EventEmitter();
        this.currentPage = 1;
        this.currentPageChange = new EventEmitter();
        this.selectable = false;
        this.selection = [];
        this.selectionChange = new EventEmitter();
        this.id = 'chr_base-data-table';
        this.color = 'secondary';
        this.textColor = 'secondary-contrast';
        this._page = 1;
        this.currentProperty = null;
        this.currentText = null;
        this.getProperty = (entry, properties) => {
            this.currentProperty = null;
            this.currentText = null;
            if (!properties) {
                this.currentProperty = entry;
                return entry;
            }
            let value = entry;
            for (const i of properties) {
                value = value?.[i];
            }
            this.currentProperty = value;
            return value;
        };
        this.getText = (property, column) => {
            let text = null;
            if (column.callback)
                text = column.callback(property);
            if (text == null && column.date)
                text = this._date.transform(property, column.date);
            this.currentText = text || property;
            return text || property;
            // column.date
            //   ? column.callback
            // 	? column.callback(property)
            // 	: (property | date : column.date)
            //   : column.callback
            // 	? column.callback(property)
            // 	: property
        };
        this.select = (entry, event) => {
            const pointer = event;
            const target = pointer.target;
            if (target.checked) {
                this.selection.push(entry);
            }
            else {
                this.selection = this.selection.filter((x) => x !== entry);
            }
            this.selectionChange.emit(this.selection);
        };
        this.getSelection = () => {
            return this.selection;
        };
        this.setSelection = (data) => {
            this.selection = data;
            this.selectionChange.emit(this.selection);
            this.changeDetector.markForCheck();
        };
        this.contains = (entry) => {
            return this.selection.includes(entry);
        };
        this.getIsAsc = () => {
            return this.isAsc;
        };
        this.getSortBy = () => {
            return this.sortBy;
        };
        this.getTextColor = (color = 'none') => {
            return getTextColor(color);
        };
        this.getBackgroundColor = (color = 'none') => {
            return getBackgroundColor(color);
        };
        this.getContrastTextColor = (color = 'black') => {
            return getContrastTextColor(color);
        };
        this.getBorderColor = (color = 'none') => {
            return getBorderColor(color);
        };
        this.getAlignment = (alignment = 'center') => {
            return Aligments[alignment] || Aligments['left'];
        };
    }
    ngOnInit() {
        this.dataService.get(`${this.id}_sortBy`).subscribe((res) => {
            if (res)
                this.sortBy = res;
            this.changeDetector.markForCheck();
        });
        this.dataService.get(`${this.id}_isAsc`).subscribe((res) => {
            if (res)
                this.isAsc = res;
            this.changeDetector.markForCheck();
        });
    }
    ngAfterViewInit() { }
    emitIsAsc(isAsc) {
        this.dataService.set(`${this.id}_isAsc`, isAsc);
        this.isAscChange.emit(isAsc);
        this.changeDetector.markForCheck();
    }
    emitSortBy(sortBy) {
        this.dataService.set(`${this.id}_sortBy`, sortBy);
        this.sortByChange.emit(sortBy);
        this.changeDetector.markForCheck();
    }
    emitPageSize(pageSize) {
        this.pageSize = pageSize;
        this.pageSizeChange.emit(pageSize);
        this.changeDetector.markForCheck();
    }
    emitCurrentPage(currentPage) {
        this.currentPage = currentPage;
        this.currentPageChange.emit(currentPage);
        this.changeDetector.markForCheck();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrTableComponent, deps: [{ token: i2.DatePipe }, { token: DataService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrTableComponent, isStandalone: true, selector: "app-chr-table, [app-chr-table]", inputs: { computedRows: "computedRows", columns: "columns", data: "data", actions: "actions", isAsc: "isAsc", sortBy: "sortBy", pageSize: "pageSize", currentPage: "currentPage", selectable: "selectable", selection: "selection", id: "id", color: "color", textColor: "textColor" }, outputs: { isAscChange: "isAscChange", sortByChange: "sortByChange", pageSizeChange: "pageSizeChange", currentPageChange: "currentPageChange", selectionChange: "selectionChange" }, providers: [
            DatePipe,
            {
                provide: DATE_PIPE_DEFAULT_OPTIONS,
                useValue: { dateFormat: 'shortDate' },
            },
        ], ngImport: i0, template: "<div class=\"h-full no-scrollbar\">\n  <ng-content class=\"mt-5\"></ng-content>\n  <div class=\"flex flex-col flex-1 overflow-auto no-scrollbar\">\n    @if (data) {\n    <!-- max-w-[75%] -->\n    <table\n      class=\"table-auto max-w-full border dark:border-none relative flex flex-row flex-no-wrap w-full rounded-lg sm:shadow-lg bg-transparent no-scrollbar\">\n      <thead>\n        @if (data.length <= 0) { <tr class=\"flex flex-col flex-no wrap sm:table-row rounded-lg mb-2 sm:mb-0\"\n          [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(textColor)]\">\n          @for (column of columns; track column) {\n          <th app-chr-table-header-cell class=\"p-3 h-14\" display=\"{{ column.display }}\" [column]=\"column.properties\"\n            [(isAsc)]=\"isAsc\" (isAscChange)=\"emitIsAsc($event)\" [(sortBy)]=\"sortBy\" (sortByChange)=\"emitSortBy($event)\">\n          </th>\n          }\n          @if (actions) {\n          <th\n            class=\"h-14 p-3 text-left sm:text-center place-content-center place-items-center items-center align-middle sm:w-0\">\n            Actions\n          </th>\n          }\n          </tr>\n          }\n          @for (entry of data |\n          sort:isAsc:sortBy | paginate: {itemsPerPage: pageSize, currentPage: currentPage, id: this.id}; track entry)\n          {\n          <tr class=\"flex flex-col flex-no wrap sm:table-row rounded-lg mb-2 sm:mb-0 \"\n            [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(textColor)]\">\n            <th *ngIf=\"selectable\" class=\"p-3 h-14\"></th>\n            @for (column of columns; track column) {\n            <th app-chr-table-header-cell class=\"p-3 h-14\" display=\"{{ column.display }}\" [column]=\"column.properties\"\n              [(isAsc)]=\"isAsc\" alignment=\"{{column.alignment}}\" (isAscChange)=\"emitIsAsc($event)\" [(sortBy)]=\"sortBy\"\n              (sortByChange)=\"emitSortBy($event)\"></th>\n            }\n            @if (actions) {\n            <th\n              class=\"h-14 p-3 text-left sm:text-center place-content-center place-items-center items-center align-middle self-center sm:w-0\">\n              Actions\n            </th>\n            }\n          </tr>\n          }\n      </thead>\n      <tbody class=\"w-full\">\n        @if (data.length <= 0) { <tr class=\"flex flex-col flex-no-wrap sm:table-row rounded-lg mb-0 sm:mb-2 \">\n          <td class=\"p-3 h-14\">Pas de donn\u00E9e(s)</td>\n          @for (column of columns | slice: 1; track column) {\n          <td class=\"p-3 h-14\"></td>\n          }\n          @if (actions) {\n          <td class=\"p-3 h-14 grid gap-3 justify-center align-middle items-center\"\n            [ngClass]=\"actions.length > 1 ? 'grid-cols-2' : 'grid-cols-1'\"></td>\n          }\n          </tr>\n          }\n          @for (entry of data |\n          sort:isAsc:sortBy | paginate: {itemsPerPage: pageSize, currentPage: currentPage, id: this.id}; track\n          entry; let i = $index) {\n          <tr [attr.data-index]=\"i\"\n            class=\"flex flex-col flex-no-wrap sm:table-row mb-2 sm:mb-0 sm:border-t-2 sm:first:border-0\"\n            [ngClass]=\"[getBorderColor(color)]\">\n            <td *ngIf=\"selectable\"\n              class=\"p-3 h-14 text-ellipsis max-w-full border-t-2 first:border-0 sm:first:border-t-2\"\n              [ngClass]=\"getBorderColor(color)\"><input type=\"checkbox\" (click)=\"select(entry, $event)\"\n                [checked]=\"contains(entry)\" /></td>\n            @for (column of columns; track column;) {\n            <td [ngClass]=\"\n                column.chips\n                  ? ''\n                  : ''\n              \" class=\"p-3 h-14 text-ellipsis max-w-full border-t-2 first:border-0 sm:first:border-t-2\"\n              [ngClass]=\"getBorderColor(color)\">\n              <ng-container [ngTemplateOutlet]=\"default\"\n                [ngTemplateOutletContext]=\"{prop: getProperty(entry, column.properties), column: column}\">\n              </ng-container>\n            </td>\n            }\n            <ng-template #default let-column='column' let-property=\"prop\">\n              @if (column.isLink) {\n              <a target=\"_blank\" class=\"text-{{column.alignment}}\" href=\"{{column.linkStaticUrl}}{{\n              getText(property, column)\n              }}\">\n                {{\n                currentText\n                }}\n              </a>\n              }\n              @if (!column.isLink) {\n              <div class=\"flex flex-row\" [ngClass]=\"{\n                'justify-start': column.alignment == 'left',\n                'justify-center': column.alignment == 'center',\n                'justify-end': column.alignment == 'right',\n                'gap-2': column.chipsDisplay && getText(property, column)\n              }\">\n                @if (column.chips && column.chips.length > 0) {\n                <div>\n                  @for(chip of column.chips; track chip; let i = $index){\n                  <span *ngIf=\"chip.callback(entry) === true || chip.callback(entry) === chip.name\"\n                    class=\"w-24 flex text-center content-center align-middle items-center justify-center text-xs font-medium py-0.5 rounded-full\"\n                    [ngClass]=\"[getBackgroundColor(chip.backgroundColor), chip.backgroundColor != 'none' ? getContrastTextColor(chip.backgroundColor) : getTextColor(chip.textColor)]\">\n                    {{ chip.display }}\n                  </span>\n                  }\n                </div>\n                }@else {\n                <p class=\"inline-block overflow-hidden text-nowrap text-ellipsis max-w-full\">\n                  {{\n                  currentText || getText(property, column)\n                  }}\n                </p>\n                }\n              </div>\n              }\n            </ng-template>\n\n            @if (actions) {\n            <td class=\"p-3 h-14 flex gap-2 w-full sm:w-min justify-center\">\n              @for (action of actions; track action) {\n              <app-chr-button class=\"w-full\" [disabled]=\"\n                  action.disabledCallback\n                    ? action.disabledCallback(entry)\n                    : action.disabled || false\n                \" [display]=\"action.display\" [icon]=\"action.icon\" [click]=\"action.callback.bind(null, entry, i)\"\n                [color]=\"action.color\" type=\"responsive\">\n              </app-chr-button>\n              }\n            </td>\n            }\n          </tr>\n          }\n          @for (r of computedRows; track r) {\n          <tr class=\"flex flex-col flex-no-wrap sm:table-row mb-2 sm:mb-0 \">\n            @for (c of r.columns; track c) {\n            <td [ngClass]=\"c.alignment && 'text-'+(c.alignment||'left')\" class=\"p-3 h-14\">\n              {{c.label && c.label + ':'}} {{c.value || (c.callback && c.callback(data))}} {{c.after}}\n            </td>\n            }\n          </tr>\n          }\n      </tbody>\n    </table>\n    <app-chr-paginator [id]=\"this.id\" [(pageSize)]=\"pageSize\" [(page)]=\"currentPage\"\n      (pageSizeChange)=\"emitPageSize($event)\" (pageChange)=\"emitCurrentPage($event)\"></app-chr-paginator>\n    }\n  </div>\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}:root{--table-bg-color: \"chr-alert\"}@media (min-width: 640px){table{display:inline-table!important}thead tr:not(:first-child){display:none}}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}tbody>tr:nth-child(2n){background-color:var(--neutral-color)}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "component", type: ChrTableHeaderCellComponent, selector: "app-chr-table-header-cell, [app-chr-table-header-cell]", inputs: ["display", "column", "alignment", "isAsc", "sortBy"], outputs: ["isAscChange", "sortByChange"] }, { kind: "component", type: ChrButtonComponent, selector: "app-chr-button", inputs: ["display", "icon", "click", "clickWhileDisabled", "color", "textColor", "flat", "predicate", "type", "href", "target", "disabled", "tooltip", "tooltipPosition"] }, { kind: "component", type: ChrPaginatorComponent, selector: "app-chr-paginator", inputs: ["page", "pageSize", "id", "allowSizeChange"], outputs: ["pageChange", "pageSizeChange"] }, { kind: "pipe", type: SortPipe, name: "sort" }, { kind: "ngmodule", type: NgxPaginationModule }, { kind: "pipe", type: i1.PaginatePipe, name: "paginate" }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: i2.SlicePipe, name: "slice" }], changeDetection: i0.ChangeDetectionStrategy.Default }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrTableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-table, [app-chr-table]', imports: [
                        ChrTableHeaderCellComponent,
                        ChrButtonComponent,
                        ChrPaginatorComponent,
                        SortPipe,
                        NgxPaginationModule,
                        CommonModule,
                    ], changeDetection: ChangeDetectionStrategy.Default, providers: [
                        DatePipe,
                        {
                            provide: DATE_PIPE_DEFAULT_OPTIONS,
                            useValue: { dateFormat: 'shortDate' },
                        },
                    ], template: "<div class=\"h-full no-scrollbar\">\n  <ng-content class=\"mt-5\"></ng-content>\n  <div class=\"flex flex-col flex-1 overflow-auto no-scrollbar\">\n    @if (data) {\n    <!-- max-w-[75%] -->\n    <table\n      class=\"table-auto max-w-full border dark:border-none relative flex flex-row flex-no-wrap w-full rounded-lg sm:shadow-lg bg-transparent no-scrollbar\">\n      <thead>\n        @if (data.length <= 0) { <tr class=\"flex flex-col flex-no wrap sm:table-row rounded-lg mb-2 sm:mb-0\"\n          [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(textColor)]\">\n          @for (column of columns; track column) {\n          <th app-chr-table-header-cell class=\"p-3 h-14\" display=\"{{ column.display }}\" [column]=\"column.properties\"\n            [(isAsc)]=\"isAsc\" (isAscChange)=\"emitIsAsc($event)\" [(sortBy)]=\"sortBy\" (sortByChange)=\"emitSortBy($event)\">\n          </th>\n          }\n          @if (actions) {\n          <th\n            class=\"h-14 p-3 text-left sm:text-center place-content-center place-items-center items-center align-middle sm:w-0\">\n            Actions\n          </th>\n          }\n          </tr>\n          }\n          @for (entry of data |\n          sort:isAsc:sortBy | paginate: {itemsPerPage: pageSize, currentPage: currentPage, id: this.id}; track entry)\n          {\n          <tr class=\"flex flex-col flex-no wrap sm:table-row rounded-lg mb-2 sm:mb-0 \"\n            [ngClass]=\"[getBackgroundColor(color), getContrastTextColor(textColor)]\">\n            <th *ngIf=\"selectable\" class=\"p-3 h-14\"></th>\n            @for (column of columns; track column) {\n            <th app-chr-table-header-cell class=\"p-3 h-14\" display=\"{{ column.display }}\" [column]=\"column.properties\"\n              [(isAsc)]=\"isAsc\" alignment=\"{{column.alignment}}\" (isAscChange)=\"emitIsAsc($event)\" [(sortBy)]=\"sortBy\"\n              (sortByChange)=\"emitSortBy($event)\"></th>\n            }\n            @if (actions) {\n            <th\n              class=\"h-14 p-3 text-left sm:text-center place-content-center place-items-center items-center align-middle self-center sm:w-0\">\n              Actions\n            </th>\n            }\n          </tr>\n          }\n      </thead>\n      <tbody class=\"w-full\">\n        @if (data.length <= 0) { <tr class=\"flex flex-col flex-no-wrap sm:table-row rounded-lg mb-0 sm:mb-2 \">\n          <td class=\"p-3 h-14\">Pas de donn\u00E9e(s)</td>\n          @for (column of columns | slice: 1; track column) {\n          <td class=\"p-3 h-14\"></td>\n          }\n          @if (actions) {\n          <td class=\"p-3 h-14 grid gap-3 justify-center align-middle items-center\"\n            [ngClass]=\"actions.length > 1 ? 'grid-cols-2' : 'grid-cols-1'\"></td>\n          }\n          </tr>\n          }\n          @for (entry of data |\n          sort:isAsc:sortBy | paginate: {itemsPerPage: pageSize, currentPage: currentPage, id: this.id}; track\n          entry; let i = $index) {\n          <tr [attr.data-index]=\"i\"\n            class=\"flex flex-col flex-no-wrap sm:table-row mb-2 sm:mb-0 sm:border-t-2 sm:first:border-0\"\n            [ngClass]=\"[getBorderColor(color)]\">\n            <td *ngIf=\"selectable\"\n              class=\"p-3 h-14 text-ellipsis max-w-full border-t-2 first:border-0 sm:first:border-t-2\"\n              [ngClass]=\"getBorderColor(color)\"><input type=\"checkbox\" (click)=\"select(entry, $event)\"\n                [checked]=\"contains(entry)\" /></td>\n            @for (column of columns; track column;) {\n            <td [ngClass]=\"\n                column.chips\n                  ? ''\n                  : ''\n              \" class=\"p-3 h-14 text-ellipsis max-w-full border-t-2 first:border-0 sm:first:border-t-2\"\n              [ngClass]=\"getBorderColor(color)\">\n              <ng-container [ngTemplateOutlet]=\"default\"\n                [ngTemplateOutletContext]=\"{prop: getProperty(entry, column.properties), column: column}\">\n              </ng-container>\n            </td>\n            }\n            <ng-template #default let-column='column' let-property=\"prop\">\n              @if (column.isLink) {\n              <a target=\"_blank\" class=\"text-{{column.alignment}}\" href=\"{{column.linkStaticUrl}}{{\n              getText(property, column)\n              }}\">\n                {{\n                currentText\n                }}\n              </a>\n              }\n              @if (!column.isLink) {\n              <div class=\"flex flex-row\" [ngClass]=\"{\n                'justify-start': column.alignment == 'left',\n                'justify-center': column.alignment == 'center',\n                'justify-end': column.alignment == 'right',\n                'gap-2': column.chipsDisplay && getText(property, column)\n              }\">\n                @if (column.chips && column.chips.length > 0) {\n                <div>\n                  @for(chip of column.chips; track chip; let i = $index){\n                  <span *ngIf=\"chip.callback(entry) === true || chip.callback(entry) === chip.name\"\n                    class=\"w-24 flex text-center content-center align-middle items-center justify-center text-xs font-medium py-0.5 rounded-full\"\n                    [ngClass]=\"[getBackgroundColor(chip.backgroundColor), chip.backgroundColor != 'none' ? getContrastTextColor(chip.backgroundColor) : getTextColor(chip.textColor)]\">\n                    {{ chip.display }}\n                  </span>\n                  }\n                </div>\n                }@else {\n                <p class=\"inline-block overflow-hidden text-nowrap text-ellipsis max-w-full\">\n                  {{\n                  currentText || getText(property, column)\n                  }}\n                </p>\n                }\n              </div>\n              }\n            </ng-template>\n\n            @if (actions) {\n            <td class=\"p-3 h-14 flex gap-2 w-full sm:w-min justify-center\">\n              @for (action of actions; track action) {\n              <app-chr-button class=\"w-full\" [disabled]=\"\n                  action.disabledCallback\n                    ? action.disabledCallback(entry)\n                    : action.disabled || false\n                \" [display]=\"action.display\" [icon]=\"action.icon\" [click]=\"action.callback.bind(null, entry, i)\"\n                [color]=\"action.color\" type=\"responsive\">\n              </app-chr-button>\n              }\n            </td>\n            }\n          </tr>\n          }\n          @for (r of computedRows; track r) {\n          <tr class=\"flex flex-col flex-no-wrap sm:table-row mb-2 sm:mb-0 \">\n            @for (c of r.columns; track c) {\n            <td [ngClass]=\"c.alignment && 'text-'+(c.alignment||'left')\" class=\"p-3 h-14\">\n              {{c.label && c.label + ':'}} {{c.value || (c.callback && c.callback(data))}} {{c.after}}\n            </td>\n            }\n          </tr>\n          }\n      </tbody>\n    </table>\n    <app-chr-paginator [id]=\"this.id\" [(pageSize)]=\"pageSize\" [(page)]=\"currentPage\"\n      (pageSizeChange)=\"emitPageSize($event)\" (pageChange)=\"emitCurrentPage($event)\"></app-chr-paginator>\n    }\n  </div>\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}:root{--table-bg-color: \"chr-alert\"}@media (min-width: 640px){table{display:inline-table!important}thead tr:not(:first-child){display:none}}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}tbody>tr:nth-child(2n){background-color:var(--neutral-color)}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i2.DatePipe }, { type: DataService }, { type: i0.ChangeDetectorRef }], propDecorators: { computedRows: [{
                type: Input
            }], columns: [{
                type: Input
            }], data: [{
                type: Input
            }], actions: [{
                type: Input
            }], isAsc: [{
                type: Input
            }], isAscChange: [{
                type: Output
            }], sortBy: [{
                type: Input
            }], sortByChange: [{
                type: Output
            }], pageSize: [{
                type: Input
            }], pageSizeChange: [{
                type: Output
            }], currentPage: [{
                type: Input
            }], currentPageChange: [{
                type: Output
            }], selectable: [{
                type: Input
            }], selection: [{
                type: Input
            }], selectionChange: [{
                type: Output
            }], id: [{
                type: Input
            }], color: [{
                type: Input
            }], textColor: [{
                type: Input
            }] } });

class ChrCheckboxComponent {
    constructor() {
        this.checked = false;
        this.type = 'info';
        this.disabled = false;
        this.change = new EventEmitter();
    }
    check(end) {
        if (this.disabled)
            return;
        if (end) {
            this.checked = true;
            this.change.emit({ checked: true });
        }
        else {
            this.checked = false;
            this.change.emit({ checked: false });
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrCheckboxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrCheckboxComponent, isStandalone: true, selector: "app-chr-checkbox", inputs: { type: "type", disabled: "disabled" }, outputs: { change: "change" }, ngImport: i0, template: "<div>\n  @if (checked) {\n    <div (click)=\"check(false)\" [class.info]=\"type=='info'&&!disabled\"\n      [class.bg-green-100]=\"type=='success'&&!disabled\" [class.cursor-pointer]=\"!disabled\"\n      [class.bg-grey-400]=\"disabled\"\n      class=\"box-border rounded-lg p-3 h-12 text-center border-bottom-accent sm:border-none\">\n      <div class=\"flex justify-center items-center\"><mat-icon>check-circle</mat-icon></div>\n    </div>\n  }\n  @if (!checked) {\n    <div (click)=\"check(true)\" [class.cursor-pointer]=\"!disabled\" [class.disabled]=\"disabled\"\n      [class.bg-gray-200]=\"disabled\" [class.bg-red-100]=\"!disabled\"\n      class=\"box-border p-3 h-12 text-center rounded-lg border-bottom-accent sm:border-none\">\n      <div class=\"flex justify-center items-center\"><mat-icon>close</mat-icon></div>\n    </div>\n  }\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.bg-accent,.info{background-color:var(--secondary-color)}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "component", type: MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrCheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-checkbox', imports: [MatIcon], template: "<div>\n  @if (checked) {\n    <div (click)=\"check(false)\" [class.info]=\"type=='info'&&!disabled\"\n      [class.bg-green-100]=\"type=='success'&&!disabled\" [class.cursor-pointer]=\"!disabled\"\n      [class.bg-grey-400]=\"disabled\"\n      class=\"box-border rounded-lg p-3 h-12 text-center border-bottom-accent sm:border-none\">\n      <div class=\"flex justify-center items-center\"><mat-icon>check-circle</mat-icon></div>\n    </div>\n  }\n  @if (!checked) {\n    <div (click)=\"check(true)\" [class.cursor-pointer]=\"!disabled\" [class.disabled]=\"disabled\"\n      [class.bg-gray-200]=\"disabled\" [class.bg-red-100]=\"!disabled\"\n      class=\"box-border p-3 h-12 text-center rounded-lg border-bottom-accent sm:border-none\">\n      <div class=\"flex justify-center items-center\"><mat-icon>close</mat-icon></div>\n    </div>\n  }\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.bg-accent,.info{background-color:var(--secondary-color)}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], propDecorators: { type: [{
                type: Input
            }], disabled: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

class ChrSeparatorComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrSeparatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.5", type: ChrSeparatorComponent, isStandalone: true, selector: "app-chr-separator", ngImport: i0, template: "<div class=\"py-4\">\n  <hr class=\"\" />\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}table{width:100%}.mat-column-actions{text-align:right}::ng-deep .arrow-color .mat-sort-header-arrow{color:#000}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrSeparatorComponent, decorators: [{
            type: Component,
            args: [{ selector: "app-chr-separator", standalone: true, template: "<div class=\"py-4\">\n  <hr class=\"\" />\n</div>", styles: ["*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}table{width:100%}.mat-column-actions{text-align:right}::ng-deep .arrow-color .mat-sort-header-arrow{color:#000}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }] });

var LiveUpdateStatus;
(function (LiveUpdateStatus) {
    LiveUpdateStatus[LiveUpdateStatus["Info"] = 0] = "Info";
    LiveUpdateStatus[LiveUpdateStatus["Warning"] = 1] = "Warning";
    LiveUpdateStatus[LiveUpdateStatus["Error"] = 2] = "Error";
    LiveUpdateStatus[LiveUpdateStatus["End"] = 3] = "End";
})(LiveUpdateStatus || (LiveUpdateStatus = {}));
const DEFAULTLIVEUPDATEMESSAGE = {
    status: LiveUpdateStatus.Info,
    message: "Chargement...",
};
const DefaultLiveUpdateMessage = DEFAULTLIVEUPDATEMESSAGE;

class LoaderService {
    constructor() {
        this.is_loading = false;
        this.is_loading$ = new BehaviorSubject(this.is_loading);
        this.requestStatckSize = 0;
        this.setLoading = (is) => {
            this.is_loading = is;
            this.is_loading$.next(this.is_loading);
        };
        this.isLoading = () => {
            return this.is_loading;
        };
        this.isLoadingAsync = () => {
            return this.is_loading$.asObservable();
        };
        this.getStackSize = () => this.requestStatckSize;
        this.incrementStackSize = () => this.requestStatckSize++;
        this.decrementStackSize = () => this.requestStatckSize--;
        this.setStackSize = (value) => (this.requestStatckSize = value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: LoaderService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: LoaderService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: LoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [] });

const SpinnerInterceptor = (req, next) => {
    const loader = inject(LoaderService);
    if (req.headers.get('skip') == 'true') {
        req = req.clone({ headers: req.headers.delete('skip') });
        return next(req);
    }
    req = req.clone({ headers: req.headers.delete('skip') });
    loader.incrementStackSize();
    loader.setLoading(true);
    return next(req).pipe(tap((data) => {
        if (data instanceof HttpResponse) {
            //Do something
        }
    }), finalize(() => {
        loader.decrementStackSize();
        if (loader.getStackSize() == 0) {
            loader.setLoading(false);
        }
    }));
};

const XsrfInterceptor = (req, next) => {
    const headerName = inject(XSRFHEADERNAME);
    const hubUrl = inject(HUBURL);
    const liveUpdateService = hubUrl != null && hubUrl != undefined ? inject(LiveUpdateService) : null;
    const dataService = inject(DataService);
    const csrfToken = dataService.getSync(headerName);
    const hasCsrfToken = csrfToken !== null && csrfToken !== undefined;
    const shouldIntercept = ["PUT", "POST", "DELETE"].includes(req.method);
    const isWebSocket = liveUpdateService
        ? req.url.includes(liveUpdateService.getHubUrl())
        : false;
    if (hasCsrfToken && shouldIntercept && !isWebSocket) {
        const cloned = req.clone({
            headers: req.headers.set(headerName, csrfToken),
        });
        liveUpdateService?.initConnection().subscribe();
        return next(cloned).pipe(WaitAndStoreXsrfToken(headerName, dataService), finalize$1(() => liveUpdateService?.closeConnection().subscribe()));
    }
    else {
        return next(req).pipe(WaitAndStoreXsrfToken(headerName, dataService));
    }
};
const WaitAndStoreXsrfToken = (headername, dataService) => {
    return (source) => {
        return source.pipe(tap((event) => {
            if (event instanceof HttpResponse) {
                const xsrfToken = event.headers.get(headername);
                if (xsrfToken) {
                    dataService.set(headername, xsrfToken);
                }
            }
            return event;
        }));
    };
};

const provideXsrfHttpClient = (params) => {
    return [
        { provide: XSRFHEADERNAME, useValue: params.xsrfHeader },
        {
            provide: XSRFCOOKIENAME,
            useValue: params.xsrfCookie || params.xsrfHeader,
        },
        { provide: HUBURL, useValue: params.hubUrl },
        provideHttpClient(withInterceptors([
            SpinnerInterceptor,
            XsrfInterceptor,
            ...(params?.interceptors || []),
        ]), withXsrfConfiguration({
            headerName: params.xsrfHeader,
            cookieName: params.xsrfCookie || params.xsrfHeader,
        }), ...(params?.features || [])),
    ];
};
const XSRFHEADERNAME = new InjectionToken("xsrfHeader");
const XSRFCOOKIENAME = new InjectionToken("xsrfCookie");
const HUBURL = new InjectionToken("hubUrl");

class LiveUpdateService {
    constructor(hubUrl, xsrfHeader, dataService) {
        this.dataService = dataService;
        this._connection = null;
        //private _client: HttpClient;
        this._message = new BehaviorSubject(DEFAULTLIVEUPDATEMESSAGE);
        this._update = new BehaviorSubject(DEFAULTLIVEUPDATEMESSAGE?.message || "");
        this.initConnection = () => {
            if (this._xsrfHeader == null)
                throw new Error("xsrfHeader is not set");
            if (this._hubUrl == null)
                throw new Error("hubUrl is not set");
            this._xsrf = this.dataService.getSync(this._xsrfHeader);
            if (this._connection == null)
                this._connection = new HubConnectionBuilder()
                    .withUrl(this._hubUrl, {
                    transport: HttpTransportType.ServerSentEvents,
                    headers: { [this._xsrfHeader]: this._xsrf },
                })
                    .configureLogging(LogLevel.None)
                    .withAutomaticReconnect()
                    .build();
            return new Observable((observer) => {
                if (this._connection?.state == HubConnectionState.Connected)
                    this._connection;
                else
                    this._connection
                        ?.start()
                        .then(() => {
                        observer.next();
                        observer.complete();
                    })
                        .catch((error) => {
                        observer.error(error);
                    });
                this._connection?.on("UPDATE", (message) => {
                    this.pushMessage(message);
                });
            });
        };
        this.getHubUrl = () => this._hubUrl;
        this._hubUrl = hubUrl;
        this._xsrfHeader = xsrfHeader;
        this._xsrf = dataService.getSync(this._xsrfHeader);
    }
    onUpdate() {
        return this._update
            .asObservable()
            .pipe(skipWhile((message) => message == null));
    }
    closeConnection() {
        return from(this._connection.stop()).pipe(tap(() => {
            this._connection = null;
            //We push a null to flush the observable
            this._message.next(DEFAULTLIVEUPDATEMESSAGE);
            this._update.next(DEFAULTLIVEUPDATEMESSAGE?.message || "");
        }));
    }
    getMessage() {
        return this._message
            .asObservable()
            .pipe(skipWhile((message) => message == null));
    }
    pushMessage(message) {
        this._message.next(message);
        this._update.next(message?.message || DEFAULTLIVEUPDATEMESSAGE?.message || "");
        if (message.status === LiveUpdateStatus.End) {
            this._connection?.stop();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: LiveUpdateService, deps: [{ token: HUBURL, optional: true }, { token: XSRFHEADERNAME, optional: true }, { token: DataService }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: LiveUpdateService, providedIn: "root" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: LiveUpdateService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: "root",
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [HUBURL]
                }, {
                    type: Optional
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [XSRFHEADERNAME]
                }, {
                    type: Optional
                }] }, { type: DataService, decorators: [{
                    type: Inject,
                    args: [DataService]
                }] }] });

class ChrSpinnerComponent {
    constructor(loader, liveUpdate, changeDetector) {
        this.loader = loader;
        this.liveUpdate = liveUpdate;
        this.changeDetector = changeDetector;
        this.message = DefaultLiveUpdateMessage;
        this.display = (message) => {
            return message?.message;
            //return `${message?.status} \n\n ${message?.message}`;
        };
    }
    ngOnInit() {
        this.liveUpdate
            .getMessage()
            .pipe(finalize$1(() => {
            this.message = DefaultLiveUpdateMessage;
            console.error("Observable closed. This should not happen as further live update messages won't be received.");
        }))
            .subscribe((res) => {
            this.message = res;
            this.changeDetector.detectChanges();
        });
        this.loader.isLoadingAsync().subscribe((res) => {
            this.changeDetector.detectChanges();
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrSpinnerComponent, deps: [{ token: LoaderService }, { token: LiveUpdateService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrSpinnerComponent, isStandalone: true, selector: "app-chr-spinner", ngImport: i0, template: "@if (this.loader.isLoading()) {\r\n<div\r\n  class=\"cssload-container flex flex-col justify-center content-center items-center bg-gray-200 dark:bg-slate-600 opacity-85\">\r\n  <div class=\"wheel-wrapper\">\r\n    <div class=\"cssload-speeding-wheel\">\r\n    </div>\r\n  </div>\r\n  <div class=\"w-96 inset-full h-0 text-ellipsis text-wrap text-center\">\r\n    {{display((message))}}\r\n  </div>\r\n</div>\r\n}", styles: ["@charset \"UTF-8\";*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.cssload-container{position:fixed;top:0;left:0;width:100%;height:100%;z-index:999999;display:flex;justify-content:center;align-items:center}.wheel-wrapper{width:63px;height:63px;position:relative}.cssload-speeding-wheel{content:\"\";display:block;inset:1;width:100%;height:100%;margin:0;border:4px solid var(--primary-color);border-radius:50%;border-left-color:transparent;border-right-color:transparent;animation:cssload-spin .5s infinite linear;-o-animation:cssload-spin .5s infinite linear;-ms-animation:cssload-spin .5s infinite linear;-webkit-animation:cssload-spin .5s infinite linear;-moz-animation:cssload-spin .5s infinite linear}@keyframes cssload-spin{to{transform:rotate(360deg)}}@-o-keyframes cssload-spin{to{-o-transform:rotate(360deg);transform:rotate(360deg)}}@-ms-keyframes cssload-spin{to{-ms-transform:rotate(360deg);transform:rotate(360deg)}}@-webkit-keyframes cssload-spin{to{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@-moz-keyframes cssload-spin{to{-moz-transform:rotate(360deg);transform:rotate(360deg)}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrSpinnerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-spinner', imports: [CommonModule], changeDetection: ChangeDetectionStrategy.OnPush, template: "@if (this.loader.isLoading()) {\r\n<div\r\n  class=\"cssload-container flex flex-col justify-center content-center items-center bg-gray-200 dark:bg-slate-600 opacity-85\">\r\n  <div class=\"wheel-wrapper\">\r\n    <div class=\"cssload-speeding-wheel\">\r\n    </div>\r\n  </div>\r\n  <div class=\"w-96 inset-full h-0 text-ellipsis text-wrap text-center\">\r\n    {{display((message))}}\r\n  </div>\r\n</div>\r\n}", styles: ["@charset \"UTF-8\";*,:before,:after{box-sizing:border-box;border-width:0;border-style:solid;border-color:#e5e7eb}:before,:after{--tw-content: \"\"}html,:host{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",Segoe UI Symbol,\"Noto Color Emoji\";font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,samp,pre{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:transparent;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:baseline}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dl,dd,h1,h2,h3,h4,h5,h6,hr,figure,p,pre{margin:0}fieldset{margin:0;padding:0}legend{padding:0}ol,ul,menu{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}button,[role=button]{cursor:pointer}:disabled{cursor:default}img,svg,video,canvas,audio,iframe,embed,object{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,:before,:after{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }::backdrop{--tw-border-spacing-x: 0;--tw-border-spacing-y: 0;--tw-translate-x: 0;--tw-translate-y: 0;--tw-rotate: 0;--tw-skew-x: 0;--tw-skew-y: 0;--tw-scale-x: 1;--tw-scale-y: 1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness: proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width: 0px;--tw-ring-offset-color: #fff;--tw-ring-color: rgb(59 130 246 / .5);--tw-ring-offset-shadow: 0 0 #0000;--tw-ring-shadow: 0 0 #0000;--tw-shadow: 0 0 #0000;--tw-shadow-colored: 0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.border-chrdblue{--tw-border-opacity: 1;border-color:rgb(10 70 147 / var(--tw-border-opacity))}.border-chrdblue\\/0{border-color:#0a469300}.border-chrdblue\\/10{border-color:#0a46931a}.border-chrdblue\\/100{border-color:#0a4693}.border-chrdblue\\/15{border-color:#0a469326}.border-chrdblue\\/20{border-color:#0a469333}.border-chrdblue\\/25{border-color:#0a469340}.border-chrdblue\\/30{border-color:#0a46934d}.border-chrdblue\\/35{border-color:#0a469359}.border-chrdblue\\/40{border-color:#0a469366}.border-chrdblue\\/45{border-color:#0a469373}.border-chrdblue\\/5{border-color:#0a46930d}.border-chrdblue\\/50{border-color:#0a469380}.border-chrdblue\\/55{border-color:#0a46938c}.border-chrdblue\\/60{border-color:#0a469399}.border-chrdblue\\/65{border-color:#0a4693a6}.border-chrdblue\\/70{border-color:#0a4693b3}.border-chrdblue\\/75{border-color:#0a4693bf}.border-chrdblue\\/80{border-color:#0a4693cc}.border-chrdblue\\/85{border-color:#0a4693d9}.border-chrdblue\\/90{border-color:#0a4693e6}.border-chrdblue\\/95{border-color:#0a4693f2}.border-chrlblue{--tw-border-opacity: 1;border-color:rgb(186 218 255 / var(--tw-border-opacity))}.border-chrlblue\\/0{border-color:#badaff00}.border-chrlblue\\/10{border-color:#badaff1a}.border-chrlblue\\/100{border-color:#badaff}.border-chrlblue\\/15{border-color:#badaff26}.border-chrlblue\\/20{border-color:#badaff33}.border-chrlblue\\/25{border-color:#badaff40}.border-chrlblue\\/30{border-color:#badaff4d}.border-chrlblue\\/35{border-color:#badaff59}.border-chrlblue\\/40{border-color:#badaff66}.border-chrlblue\\/45{border-color:#badaff73}.border-chrlblue\\/5{border-color:#badaff0d}.border-chrlblue\\/50{border-color:#badaff80}.border-chrlblue\\/55{border-color:#badaff8c}.border-chrlblue\\/60{border-color:#badaff99}.border-chrlblue\\/65{border-color:#badaffa6}.border-chrlblue\\/70{border-color:#badaffb3}.border-chrlblue\\/75{border-color:#badaffbf}.border-chrlblue\\/80{border-color:#badaffcc}.border-chrlblue\\/85{border-color:#badaffd9}.border-chrlblue\\/90{border-color:#badaffe6}.border-chrlblue\\/95{border-color:#badafff2}.border-chrmblue{--tw-border-opacity: 1;border-color:rgb(0 134 203 / var(--tw-border-opacity))}.border-chrmblue\\/0{border-color:#0086cb00}.border-chrmblue\\/10{border-color:#0086cb1a}.border-chrmblue\\/100{border-color:#0086cb}.border-chrmblue\\/15{border-color:#0086cb26}.border-chrmblue\\/20{border-color:#0086cb33}.border-chrmblue\\/25{border-color:#0086cb40}.border-chrmblue\\/30{border-color:#0086cb4d}.border-chrmblue\\/35{border-color:#0086cb59}.border-chrmblue\\/40{border-color:#0086cb66}.border-chrmblue\\/45{border-color:#0086cb73}.border-chrmblue\\/5{border-color:#0086cb0d}.border-chrmblue\\/50{border-color:#0086cb80}.border-chrmblue\\/55{border-color:#0086cb8c}.border-chrmblue\\/60{border-color:#0086cb99}.border-chrmblue\\/65{border-color:#0086cba6}.border-chrmblue\\/70{border-color:#0086cbb3}.border-chrmblue\\/75{border-color:#0086cbbf}.border-chrmblue\\/80{border-color:#0086cbcc}.border-chrmblue\\/85{border-color:#0086cbd9}.border-chrmblue\\/90{border-color:#0086cbe6}.border-chrmblue\\/95{border-color:#0086cbf2}.border-chrorange{--tw-border-opacity: 1;border-color:rgb(248 155 34 / var(--tw-border-opacity))}.border-chrorange\\/0{border-color:#f89b2200}.border-chrorange\\/10{border-color:#f89b221a}.border-chrorange\\/100{border-color:#f89b22}.border-chrorange\\/15{border-color:#f89b2226}.border-chrorange\\/20{border-color:#f89b2233}.border-chrorange\\/25{border-color:#f89b2240}.border-chrorange\\/30{border-color:#f89b224d}.border-chrorange\\/35{border-color:#f89b2259}.border-chrorange\\/40{border-color:#f89b2266}.border-chrorange\\/45{border-color:#f89b2273}.border-chrorange\\/5{border-color:#f89b220d}.border-chrorange\\/50{border-color:#f89b2280}.border-chrorange\\/55{border-color:#f89b228c}.border-chrorange\\/60{border-color:#f89b2299}.border-chrorange\\/65{border-color:#f89b22a6}.border-chrorange\\/70{border-color:#f89b22b3}.border-chrorange\\/75{border-color:#f89b22bf}.border-chrorange\\/80{border-color:#f89b22cc}.border-chrorange\\/85{border-color:#f89b22d9}.border-chrorange\\/90{border-color:#f89b22e6}.border-chrorange\\/95{border-color:#f89b22f2}.border-chrwarning{--tw-border-opacity: 1;border-color:rgb(244 74 62 / var(--tw-border-opacity))}.border-chrwarning\\/0{border-color:#f44a3e00}.border-chrwarning\\/10{border-color:#f44a3e1a}.border-chrwarning\\/100{border-color:#f44a3e}.border-chrwarning\\/15{border-color:#f44a3e26}.border-chrwarning\\/20{border-color:#f44a3e33}.border-chrwarning\\/25{border-color:#f44a3e40}.border-chrwarning\\/30{border-color:#f44a3e4d}.border-chrwarning\\/35{border-color:#f44a3e59}.border-chrwarning\\/40{border-color:#f44a3e66}.border-chrwarning\\/45{border-color:#f44a3e73}.border-chrwarning\\/5{border-color:#f44a3e0d}.border-chrwarning\\/50{border-color:#f44a3e80}.border-chrwarning\\/55{border-color:#f44a3e8c}.border-chrwarning\\/60{border-color:#f44a3e99}.border-chrwarning\\/65{border-color:#f44a3ea6}.border-chrwarning\\/70{border-color:#f44a3eb3}.border-chrwarning\\/75{border-color:#f44a3ebf}.border-chrwarning\\/80{border-color:#f44a3ecc}.border-chrwarning\\/85{border-color:#f44a3ed9}.border-chrwarning\\/90{border-color:#f44a3ee6}.border-chrwarning\\/95{border-color:#f44a3ef2}.bg-chrdblue{--tw-bg-opacity: 1;background-color:rgb(10 70 147 / var(--tw-bg-opacity))}.bg-chrdblue\\/0{background-color:#0a469300}.bg-chrdblue\\/10{background-color:#0a46931a}.bg-chrdblue\\/100{background-color:#0a4693}.bg-chrdblue\\/15{background-color:#0a469326}.bg-chrdblue\\/20{background-color:#0a469333}.bg-chrdblue\\/25{background-color:#0a469340}.bg-chrdblue\\/30{background-color:#0a46934d}.bg-chrdblue\\/35{background-color:#0a469359}.bg-chrdblue\\/40{background-color:#0a469366}.bg-chrdblue\\/45{background-color:#0a469373}.bg-chrdblue\\/5{background-color:#0a46930d}.bg-chrdblue\\/50{background-color:#0a469380}.bg-chrdblue\\/55{background-color:#0a46938c}.bg-chrdblue\\/60{background-color:#0a469399}.bg-chrdblue\\/65{background-color:#0a4693a6}.bg-chrdblue\\/70{background-color:#0a4693b3}.bg-chrdblue\\/75{background-color:#0a4693bf}.bg-chrdblue\\/80{background-color:#0a4693cc}.bg-chrdblue\\/85{background-color:#0a4693d9}.bg-chrdblue\\/90{background-color:#0a4693e6}.bg-chrdblue\\/95{background-color:#0a4693f2}.bg-chrlblue{--tw-bg-opacity: 1;background-color:rgb(186 218 255 / var(--tw-bg-opacity))}.bg-chrlblue\\/0{background-color:#badaff00}.bg-chrlblue\\/10{background-color:#badaff1a}.bg-chrlblue\\/100{background-color:#badaff}.bg-chrlblue\\/15{background-color:#badaff26}.bg-chrlblue\\/20{background-color:#badaff33}.bg-chrlblue\\/25{background-color:#badaff40}.bg-chrlblue\\/30{background-color:#badaff4d}.bg-chrlblue\\/35{background-color:#badaff59}.bg-chrlblue\\/40{background-color:#badaff66}.bg-chrlblue\\/45{background-color:#badaff73}.bg-chrlblue\\/5{background-color:#badaff0d}.bg-chrlblue\\/50{background-color:#badaff80}.bg-chrlblue\\/55{background-color:#badaff8c}.bg-chrlblue\\/60{background-color:#badaff99}.bg-chrlblue\\/65{background-color:#badaffa6}.bg-chrlblue\\/70{background-color:#badaffb3}.bg-chrlblue\\/75{background-color:#badaffbf}.bg-chrlblue\\/80{background-color:#badaffcc}.bg-chrlblue\\/85{background-color:#badaffd9}.bg-chrlblue\\/90{background-color:#badaffe6}.bg-chrlblue\\/95{background-color:#badafff2}.bg-chrmblue{--tw-bg-opacity: 1;background-color:rgb(0 134 203 / var(--tw-bg-opacity))}.bg-chrmblue\\/0{background-color:#0086cb00}.bg-chrmblue\\/10{background-color:#0086cb1a}.bg-chrmblue\\/100{background-color:#0086cb}.bg-chrmblue\\/15{background-color:#0086cb26}.bg-chrmblue\\/20{background-color:#0086cb33}.bg-chrmblue\\/25{background-color:#0086cb40}.bg-chrmblue\\/30{background-color:#0086cb4d}.bg-chrmblue\\/35{background-color:#0086cb59}.bg-chrmblue\\/40{background-color:#0086cb66}.bg-chrmblue\\/45{background-color:#0086cb73}.bg-chrmblue\\/5{background-color:#0086cb0d}.bg-chrmblue\\/50{background-color:#0086cb80}.bg-chrmblue\\/55{background-color:#0086cb8c}.bg-chrmblue\\/60{background-color:#0086cb99}.bg-chrmblue\\/65{background-color:#0086cba6}.bg-chrmblue\\/70{background-color:#0086cbb3}.bg-chrmblue\\/75{background-color:#0086cbbf}.bg-chrmblue\\/80{background-color:#0086cbcc}.bg-chrmblue\\/85{background-color:#0086cbd9}.bg-chrmblue\\/90{background-color:#0086cbe6}.bg-chrmblue\\/95{background-color:#0086cbf2}.bg-chrorange{--tw-bg-opacity: 1;background-color:rgb(248 155 34 / var(--tw-bg-opacity))}.bg-chrorange\\/0{background-color:#f89b2200}.bg-chrorange\\/10{background-color:#f89b221a}.bg-chrorange\\/100{background-color:#f89b22}.bg-chrorange\\/15{background-color:#f89b2226}.bg-chrorange\\/20{background-color:#f89b2233}.bg-chrorange\\/25{background-color:#f89b2240}.bg-chrorange\\/30{background-color:#f89b224d}.bg-chrorange\\/35{background-color:#f89b2259}.bg-chrorange\\/40{background-color:#f89b2266}.bg-chrorange\\/45{background-color:#f89b2273}.bg-chrorange\\/5{background-color:#f89b220d}.bg-chrorange\\/50{background-color:#f89b2280}.bg-chrorange\\/55{background-color:#f89b228c}.bg-chrorange\\/60{background-color:#f89b2299}.bg-chrorange\\/65{background-color:#f89b22a6}.bg-chrorange\\/70{background-color:#f89b22b3}.bg-chrorange\\/75{background-color:#f89b22bf}.bg-chrorange\\/80{background-color:#f89b22cc}.bg-chrorange\\/85{background-color:#f89b22d9}.bg-chrorange\\/90{background-color:#f89b22e6}.bg-chrorange\\/95{background-color:#f89b22f2}.bg-chrwarning{--tw-bg-opacity: 1;background-color:rgb(244 74 62 / var(--tw-bg-opacity))}.bg-chrwarning\\/0{background-color:#f44a3e00}.bg-chrwarning\\/10{background-color:#f44a3e1a}.bg-chrwarning\\/100{background-color:#f44a3e}.bg-chrwarning\\/15{background-color:#f44a3e26}.bg-chrwarning\\/20{background-color:#f44a3e33}.bg-chrwarning\\/25{background-color:#f44a3e40}.bg-chrwarning\\/30{background-color:#f44a3e4d}.bg-chrwarning\\/35{background-color:#f44a3e59}.bg-chrwarning\\/40{background-color:#f44a3e66}.bg-chrwarning\\/45{background-color:#f44a3e73}.bg-chrwarning\\/5{background-color:#f44a3e0d}.bg-chrwarning\\/50{background-color:#f44a3e80}.bg-chrwarning\\/55{background-color:#f44a3e8c}.bg-chrwarning\\/60{background-color:#f44a3e99}.bg-chrwarning\\/65{background-color:#f44a3ea6}.bg-chrwarning\\/70{background-color:#f44a3eb3}.bg-chrwarning\\/75{background-color:#f44a3ebf}.bg-chrwarning\\/80{background-color:#f44a3ecc}.bg-chrwarning\\/85{background-color:#f44a3ed9}.bg-chrwarning\\/90{background-color:#f44a3ee6}.bg-chrwarning\\/95{background-color:#f44a3ef2}.text-chrdblue{--tw-text-opacity: 1;color:rgb(10 70 147 / var(--tw-text-opacity))}.text-chrdblue\\/0{color:#0a469300}.text-chrdblue\\/10{color:#0a46931a}.text-chrdblue\\/100{color:#0a4693}.text-chrdblue\\/15{color:#0a469326}.text-chrdblue\\/20{color:#0a469333}.text-chrdblue\\/25{color:#0a469340}.text-chrdblue\\/30{color:#0a46934d}.text-chrdblue\\/35{color:#0a469359}.text-chrdblue\\/40{color:#0a469366}.text-chrdblue\\/45{color:#0a469373}.text-chrdblue\\/5{color:#0a46930d}.text-chrdblue\\/50{color:#0a469380}.text-chrdblue\\/55{color:#0a46938c}.text-chrdblue\\/60{color:#0a469399}.text-chrdblue\\/65{color:#0a4693a6}.text-chrdblue\\/70{color:#0a4693b3}.text-chrdblue\\/75{color:#0a4693bf}.text-chrdblue\\/80{color:#0a4693cc}.text-chrdblue\\/85{color:#0a4693d9}.text-chrdblue\\/90{color:#0a4693e6}.text-chrdblue\\/95{color:#0a4693f2}.text-chrlblue{--tw-text-opacity: 1;color:rgb(186 218 255 / var(--tw-text-opacity))}.text-chrlblue\\/0{color:#badaff00}.text-chrlblue\\/10{color:#badaff1a}.text-chrlblue\\/100{color:#badaff}.text-chrlblue\\/15{color:#badaff26}.text-chrlblue\\/20{color:#badaff33}.text-chrlblue\\/25{color:#badaff40}.text-chrlblue\\/30{color:#badaff4d}.text-chrlblue\\/35{color:#badaff59}.text-chrlblue\\/40{color:#badaff66}.text-chrlblue\\/45{color:#badaff73}.text-chrlblue\\/5{color:#badaff0d}.text-chrlblue\\/50{color:#badaff80}.text-chrlblue\\/55{color:#badaff8c}.text-chrlblue\\/60{color:#badaff99}.text-chrlblue\\/65{color:#badaffa6}.text-chrlblue\\/70{color:#badaffb3}.text-chrlblue\\/75{color:#badaffbf}.text-chrlblue\\/80{color:#badaffcc}.text-chrlblue\\/85{color:#badaffd9}.text-chrlblue\\/90{color:#badaffe6}.text-chrlblue\\/95{color:#badafff2}.text-chrmblue{--tw-text-opacity: 1;color:rgb(0 134 203 / var(--tw-text-opacity))}.text-chrmblue\\/0{color:#0086cb00}.text-chrmblue\\/10{color:#0086cb1a}.text-chrmblue\\/100{color:#0086cb}.text-chrmblue\\/15{color:#0086cb26}.text-chrmblue\\/20{color:#0086cb33}.text-chrmblue\\/25{color:#0086cb40}.text-chrmblue\\/30{color:#0086cb4d}.text-chrmblue\\/35{color:#0086cb59}.text-chrmblue\\/40{color:#0086cb66}.text-chrmblue\\/45{color:#0086cb73}.text-chrmblue\\/5{color:#0086cb0d}.text-chrmblue\\/50{color:#0086cb80}.text-chrmblue\\/55{color:#0086cb8c}.text-chrmblue\\/60{color:#0086cb99}.text-chrmblue\\/65{color:#0086cba6}.text-chrmblue\\/70{color:#0086cbb3}.text-chrmblue\\/75{color:#0086cbbf}.text-chrmblue\\/80{color:#0086cbcc}.text-chrmblue\\/85{color:#0086cbd9}.text-chrmblue\\/90{color:#0086cbe6}.text-chrmblue\\/95{color:#0086cbf2}.text-chrorange{--tw-text-opacity: 1;color:rgb(248 155 34 / var(--tw-text-opacity))}.text-chrorange\\/0{color:#f89b2200}.text-chrorange\\/10{color:#f89b221a}.text-chrorange\\/100{color:#f89b22}.text-chrorange\\/15{color:#f89b2226}.text-chrorange\\/20{color:#f89b2233}.text-chrorange\\/25{color:#f89b2240}.text-chrorange\\/30{color:#f89b224d}.text-chrorange\\/35{color:#f89b2259}.text-chrorange\\/40{color:#f89b2266}.text-chrorange\\/45{color:#f89b2273}.text-chrorange\\/5{color:#f89b220d}.text-chrorange\\/50{color:#f89b2280}.text-chrorange\\/55{color:#f89b228c}.text-chrorange\\/60{color:#f89b2299}.text-chrorange\\/65{color:#f89b22a6}.text-chrorange\\/70{color:#f89b22b3}.text-chrorange\\/75{color:#f89b22bf}.text-chrorange\\/80{color:#f89b22cc}.text-chrorange\\/85{color:#f89b22d9}.text-chrorange\\/90{color:#f89b22e6}.text-chrorange\\/95{color:#f89b22f2}.text-chrwarning{--tw-text-opacity: 1;color:rgb(244 74 62 / var(--tw-text-opacity))}.text-chrwarning\\/0{color:#f44a3e00}.text-chrwarning\\/10{color:#f44a3e1a}.text-chrwarning\\/100{color:#f44a3e}.text-chrwarning\\/15{color:#f44a3e26}.text-chrwarning\\/20{color:#f44a3e33}.text-chrwarning\\/25{color:#f44a3e40}.text-chrwarning\\/30{color:#f44a3e4d}.text-chrwarning\\/35{color:#f44a3e59}.text-chrwarning\\/40{color:#f44a3e66}.text-chrwarning\\/45{color:#f44a3e73}.text-chrwarning\\/5{color:#f44a3e0d}.text-chrwarning\\/50{color:#f44a3e80}.text-chrwarning\\/55{color:#f44a3e8c}.text-chrwarning\\/60{color:#f44a3e99}.text-chrwarning\\/65{color:#f44a3ea6}.text-chrwarning\\/70{color:#f44a3eb3}.text-chrwarning\\/75{color:#f44a3ebf}.text-chrwarning\\/80{color:#f44a3ecc}.text-chrwarning\\/85{color:#f44a3ed9}.text-chrwarning\\/90{color:#f44a3ee6}.text-chrwarning\\/95{color:#f44a3ef2}.dark-theme{background-color:#000}.light-theme{background-color:#f5f5f5}html,body{height:100%}body{margin:0;font-family:Roboto,Helvetica Neue,serif}.no-scrollbar::-webkit-scrollbar{display:none}.no-scrollbar{-ms-overflow-style:none;scrollbar-width:none}:root{font-family:Roboto,Helvetica Neue,sans-serif;--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--secondary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--tertiary-contrast-color: rgb(255, 255, 255);--warn-color: rgb(238, 149, 33);--warn-contrast-color: rgb(0, 0, 0);--error-color: rgb(244, 74, 62);--error-contrast-color: rgb(255, 255, 255);--background-color: #eeeeee;--neutral-color: #d1d5db;--text-neutral-color: #6b7280;--text-color: black}*{color:var(--text-color)}label{color:var(--text-neutral-color)}@media (prefers-color-scheme: dark){:root{--primary-color: hsl(120, 100%, 50%);--primary-contrast-color: rgb(0, 0, 0);--secondary-color: rgb(0, 0, 0);--secondary-contrast-color: hsl(120, 100%, 50%);--tertiary-color: rgb(255, 255, 255);--tertiary-contrast-color: rgb(0, 0, 0);--background-color: rgb(0, 0, 0);--neutral-color: #2c2c2c;--text-color: hsl(120, 100%, 50%)}*,label{color:var(--text-color)}cursor{color:var(--primary-color)}cursor:after{content:\"aaaa\";height:1px;width:100%}cursor:before{content:\"ttt\";width:1px;height:100%}}body{background-color:var(--background-color)}.light-theme{--primary-color: rgb(10, 70, 147);--primary-contrast-color: rgb(255, 255, 255);--secondary-color: rgb(186, 218, 255);--primary-contrast-color: rgb(0, 0, 0);--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #d1d5db;--text-color: #333}.dark-theme{--tertiary-color: rgb(0, 129, 195);--warn-color: rgb(238, 149, 33);--error-color: rgb(244, 74, 62);--background-color: #393e52;--text-color: white}.bg-primary{background-color:var(--primary-color)}.bg-primary-contrast{background-color:var(--primary-contrast-color)}.bg-secondary{background-color:var(--secondary-color)}.bg-secondary-contrast{background-color:var(--secondary-contrast-color)}.bg-tertiary{background-color:var(--tertiary-color)}.bg-tertiary-contrast{background-color:var(--tertiary-contrast-color)}.bg-warn{background-color:var(--warn-color)}.bg-warn-contrast{background-color:var(--warn-contrast-color)}.bg-error{background-color:var(--error-color)}.bg-error-contrast{background-color:var(--error-contrast-color)}.text-primary{color:var(--primary-color)!important}.text-primary-contrast{color:var(--primary-contrast-color)}.text-secondary{color:var(--secondary-color)}.text-secondary-contrast{color:var(--secondary-contrast-color)}.text-tertiary{color:var(--tertiary-color)}.text-tertiary-contrast{color:var(--tertiary-contrast-color)}.text-warn{color:var(--warn-color)}.text-warn-contrast{color:var(--warn-contrast-color)}.text-error{color:var(--error-color)}.text-error-contrast{color:var(--error-contrast-color)}.border-primary{border-color:var(--primary-color)}.border-primary-contrast{border-color:var(--primary-contrast-color)}.border-secondary{border-color:var(--secondary-color)}.border-secondary-contrast{border-color:var(--secondary-contrast-color)}.border-tertiary{border-color:var(--tertiary-color)}.border-tertiary-contrast{border-color:var(--tertiary-contrast-color)}.border-warn{border-color:var(--warn-color)}.border-warn-contrast{border-color:var(--warn-contrast-color)}.border-error{border-color:var(--error-color)}.border-error-contrast{border-color:var(--error-contrast-color)}.cssload-container{position:fixed;top:0;left:0;width:100%;height:100%;z-index:999999;display:flex;justify-content:center;align-items:center}.wheel-wrapper{width:63px;height:63px;position:relative}.cssload-speeding-wheel{content:\"\";display:block;inset:1;width:100%;height:100%;margin:0;border:4px solid var(--primary-color);border-radius:50%;border-left-color:transparent;border-right-color:transparent;animation:cssload-spin .5s infinite linear;-o-animation:cssload-spin .5s infinite linear;-ms-animation:cssload-spin .5s infinite linear;-webkit-animation:cssload-spin .5s infinite linear;-moz-animation:cssload-spin .5s infinite linear}@keyframes cssload-spin{to{transform:rotate(360deg)}}@-o-keyframes cssload-spin{to{-o-transform:rotate(360deg);transform:rotate(360deg)}}@-ms-keyframes cssload-spin{to{-ms-transform:rotate(360deg);transform:rotate(360deg)}}@-webkit-keyframes cssload-spin{to{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@-moz-keyframes cssload-spin{to{-moz-transform:rotate(360deg);transform:rotate(360deg)}}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: LoaderService }, { type: LiveUpdateService }, { type: i0.ChangeDetectorRef }] });

class ChrToastComponent {
    constructor(toastService) {
        this.toastService = toastService;
        this.topmargin = '0px';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrToastComponent, deps: [{ token: ToastService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.5", type: ChrToastComponent, isStandalone: true, selector: "app-chr-toast", inputs: { topmargin: "topmargin" }, ngImport: i0, template: "<div *ngIf=\"(toastService.current() | async); let toast;\" class=\"toast flex h-0\" style=\"--margin-top: {{topmargin}};\">\r\n    <div class=\"toast-sticky-wrapper\">\r\n        <div class=\"toast-content p-2\" style=\"cursor: default;\">\r\n            <mat-icon class=\"toast-status-icon\">icon</mat-icon>\r\n            <p class=\"toast-message\" [ngClass]=\"{\r\n                        'text-primary':toast?.type == 'success',\r\n                        'text-warn':toast?.type == 'warning',\r\n                        'text-error':toast?.type == 'error',\r\n                    }\">{{toast?.message}}</p>\r\n            <mat-icon class=\"toast-close-icon\" style=\"cursor: pointer;\" (click)=\"toastService.next()\">close</mat-icon>\r\n        </div>\r\n    </div>\r\n</div>", styles: [".toast{position:relative;z-index:15;height:0;border-top-left-radius:5rem}.toast-sticky-wrapper{position:absolute;right:0;left:0;margin-top:var(--margin-top)}.toast-content{position:fixed;display:flex;justify-content:space-between;align-items:center;align-content:center;justify-items:center;padding-left:2rem;padding-right:2rem;border-radius:inherit;left:0;right:0;background-color:var(--background-color);box-shadow:0 0 15px 0 var(--neutral-color)}.toast-close-icon{color:#3e525f}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2$1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrToastComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-toast', imports: [CommonModule, MatIconModule], template: "<div *ngIf=\"(toastService.current() | async); let toast;\" class=\"toast flex h-0\" style=\"--margin-top: {{topmargin}};\">\r\n    <div class=\"toast-sticky-wrapper\">\r\n        <div class=\"toast-content p-2\" style=\"cursor: default;\">\r\n            <mat-icon class=\"toast-status-icon\">icon</mat-icon>\r\n            <p class=\"toast-message\" [ngClass]=\"{\r\n                        'text-primary':toast?.type == 'success',\r\n                        'text-warn':toast?.type == 'warning',\r\n                        'text-error':toast?.type == 'error',\r\n                    }\">{{toast?.message}}</p>\r\n            <mat-icon class=\"toast-close-icon\" style=\"cursor: pointer;\" (click)=\"toastService.next()\">close</mat-icon>\r\n        </div>\r\n    </div>\r\n</div>", styles: [".toast{position:relative;z-index:15;height:0;border-top-left-radius:5rem}.toast-sticky-wrapper{position:absolute;right:0;left:0;margin-top:var(--margin-top)}.toast-content{position:fixed;display:flex;justify-content:space-between;align-items:center;align-content:center;justify-items:center;padding-left:2rem;padding-right:2rem;border-radius:inherit;left:0;right:0;background-color:var(--background-color);box-shadow:0 0 15px 0 var(--neutral-color)}.toast-close-icon{color:#3e525f}\n", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: ToastService }], propDecorators: { topmargin: [{
                type: Input
            }] } });

class ChrDefaultModalComponent {
    constructor(dialogRef, config, sanitizer) {
        this.dialogRef = dialogRef;
        this.config = config;
        this.sanitizer = sanitizer;
        this.valid = false;
        this.html = null;
        this.closeModal = (callback) => {
            const value = callback?.();
            this.dialogRef.close(value || true);
        };
        if (!this.title)
            this.title = config?._config.title || 'Attention: ';
        this.title = this.title.replace(/(\r\n|\r|\n)/g, '<br>');
        if (!this.text)
            this.text = config?._config.text || '';
        this.text = this.text.replace(/(\r\n|\r|\n)/g, '<br>');
        this.html = sanitizer.bypassSecurityTrustHtml(this.text);
        if (!this.close)
            this.close = config?._config.close || 'Fermer';
        if (!this.actions)
            this.actions = config?._config.actions || [];
    }
    ngOnInit() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDefaultModalComponent, deps: [{ token: i1$1.MatDialogRef }, { token: MAT_DIALOG_DATA }, { token: i2$3.DomSanitizer }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: ChrDefaultModalComponent, isStandalone: true, selector: "app-chr-default-modal", inputs: { title: "title", text: "text", actions: "actions", close: "close" }, ngImport: i0, template: "<div class=\"w-full overflow-auto overflow-x-hidden\"\n    style=\"background-color: var(--background-color); color:var(--text-color)\">\n    <h2 mat-dialog-title class=\"0\">{{title}}</h2>\n    <mat-dialog-content [innerHTML]=\"html\">\n    </mat-dialog-content>\n    <mat-dialog-actions>\n        <div class=\"w-full flex flex-row justify-between\">\n            <app-chr-button class=\"w-36\" [display]=\"close\" color=\"secondary\" [click]=\"closeModal\"></app-chr-button>\n            @if (actions) {\n            @for (action of actions; track action) {\n            <app-chr-button class=\"w-36\" [disabled]=\"\n                      action.disabledCallback\n                        ? action.disabledCallback()\n                        : action.disabled || false\n                    \" [display]=\"action.display\" [icon]=\"action.icon\"\n                [click]=\"closeModal.bind(null, action.callback.bind(null))\" [color]=\"action.color\">\n            </app-chr-button>\n            }\n            }\n        </div>\n    </mat-dialog-actions>\n</div>", styles: ["", "*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"], dependencies: [{ kind: "directive", type: MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "component", type: ChrButtonComponent, selector: "app-chr-button", inputs: ["display", "icon", "click", "clickWhileDisabled", "color", "textColor", "flat", "predicate", "type", "href", "target", "disabled", "tooltip", "tooltipPosition"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: ChrDefaultModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chr-default-modal', imports: [
                        MatDialogTitle,
                        MatDialogContent,
                        MatDialogActions,
                        ChrButtonComponent,
                    ], template: "<div class=\"w-full overflow-auto overflow-x-hidden\"\n    style=\"background-color: var(--background-color); color:var(--text-color)\">\n    <h2 mat-dialog-title class=\"0\">{{title}}</h2>\n    <mat-dialog-content [innerHTML]=\"html\">\n    </mat-dialog-content>\n    <mat-dialog-actions>\n        <div class=\"w-full flex flex-row justify-between\">\n            <app-chr-button class=\"w-36\" [display]=\"close\" color=\"secondary\" [click]=\"closeModal\"></app-chr-button>\n            @if (actions) {\n            @for (action of actions; track action) {\n            <app-chr-button class=\"w-36\" [disabled]=\"\n                      action.disabledCallback\n                        ? action.disabledCallback()\n                        : action.disabled || false\n                    \" [display]=\"action.display\" [icon]=\"action.icon\"\n                [click]=\"closeModal.bind(null, action.callback.bind(null))\" [color]=\"action.color\">\n            </app-chr-button>\n            }\n            }\n        </div>\n    </mat-dialog-actions>\n</div>", styles: ["*,:after,:before{box-sizing:border-box;border:0 solid #e5e7eb}:after,:before{--tw-content:\"\"}:host,html{line-height:1.5;-webkit-text-size-adjust:100%;-moz-tab-size:4;-o-tab-size:4;tab-size:4;font-family:ui-sans-serif,system-ui,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol,Noto Color Emoji;font-feature-settings:normal;font-variation-settings:normal;-webkit-tap-highlight-color:transparent}body{margin:0;line-height:inherit}hr{height:0;color:inherit;border-top-width:1px}abbr:where([title]){-webkit-text-decoration:underline dotted;text-decoration:underline dotted}h1,h2,h3,h4,h5,h6{font-size:inherit;font-weight:inherit}a{color:inherit;text-decoration:inherit}b,strong{font-weight:bolder}code,kbd,pre,samp{font-family:ui-monospace,SFMono-Regular,Menlo,Monaco,Consolas,Liberation Mono,Courier New,monospace;font-feature-settings:normal;font-variation-settings:normal;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:initial}sub{bottom:-.25em}sup{top:-.5em}table{text-indent:0;border-color:inherit;border-collapse:collapse}button,input,optgroup,select,textarea{font-family:inherit;font-feature-settings:inherit;font-variation-settings:inherit;font-size:100%;font-weight:inherit;line-height:inherit;letter-spacing:inherit;color:inherit;margin:0;padding:0}button,select{text-transform:none}button,input:where([type=button]),input:where([type=reset]),input:where([type=submit]){-webkit-appearance:button;background-color:initial;background-image:none}:-moz-focusring{outline:auto}:-moz-ui-invalid{box-shadow:none}progress{vertical-align:initial}::-webkit-inner-spin-button,::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}summary{display:list-item}blockquote,dd,dl,figure,h1,h2,h3,h4,h5,h6,hr,p,pre{margin:0}fieldset{margin:0}fieldset,legend{padding:0}menu,ol,ul{list-style:none;margin:0;padding:0}dialog{padding:0}textarea{resize:vertical}input::-moz-placeholder,textarea::-moz-placeholder{opacity:1;color:#9ca3af}input::placeholder,textarea::placeholder{opacity:1;color:#9ca3af}[role=button],button{cursor:pointer}:disabled{cursor:default}audio,canvas,embed,iframe,img,object,svg,video{display:block;vertical-align:middle}img,video{max-width:100%;height:auto}[hidden]{display:none}*,::backdrop,:after,:before{--tw-border-spacing-x:0;--tw-border-spacing-y:0;--tw-translate-x:0;--tw-translate-y:0;--tw-rotate:0;--tw-skew-x:0;--tw-skew-y:0;--tw-scale-x:1;--tw-scale-y:1;--tw-pan-x: ;--tw-pan-y: ;--tw-pinch-zoom: ;--tw-scroll-snap-strictness:proximity;--tw-gradient-from-position: ;--tw-gradient-via-position: ;--tw-gradient-to-position: ;--tw-ordinal: ;--tw-slashed-zero: ;--tw-numeric-figure: ;--tw-numeric-spacing: ;--tw-numeric-fraction: ;--tw-ring-inset: ;--tw-ring-offset-width:0px;--tw-ring-offset-color:#fff;--tw-ring-color:#3b82f680;--tw-ring-offset-shadow:0 0 #0000;--tw-ring-shadow:0 0 #0000;--tw-shadow:0 0 #0000;--tw-shadow-colored:0 0 #0000;--tw-blur: ;--tw-brightness: ;--tw-contrast: ;--tw-grayscale: ;--tw-hue-rotate: ;--tw-invert: ;--tw-saturate: ;--tw-sepia: ;--tw-drop-shadow: ;--tw-backdrop-blur: ;--tw-backdrop-brightness: ;--tw-backdrop-contrast: ;--tw-backdrop-grayscale: ;--tw-backdrop-hue-rotate: ;--tw-backdrop-invert: ;--tw-backdrop-opacity: ;--tw-backdrop-saturate: ;--tw-backdrop-sepia: ;--tw-contain-size: ;--tw-contain-layout: ;--tw-contain-paint: ;--tw-contain-style: }.pointer-events-none{pointer-events:none}.fixed{position:fixed}.absolute{position:absolute}.relative{position:relative}.inset-full{inset:100%}.bottom-0{bottom:0}.left-0{left:0}.right-0{right:0}.right-3{right:.75rem}.top-0{top:0}.top-0\\.5{top:.125rem}.top-1{top:.25rem}.top-1\\.5{top:.375rem}.top-3{top:.75rem}.-z-10{z-index:-10}.z-0{z-index:0}.z-10{z-index:10}.z-50{z-index:50}.col-span-2{grid-column:span 2/span 2}.col-span-4{grid-column:span 4/span 4}.row-span-2{grid-row:span 2/span 2}.\\!m-0{margin:0!important}.m-0{margin:0}.mx-2{margin-left:.5rem;margin-right:.5rem}.mb-0{margin-bottom:0}.mb-16{margin-bottom:4rem}.mb-2{margin-bottom:.5rem}.mb-4{margin-bottom:1rem}.ml-\\[10\\%\\]{margin-left:10%}.mr-4{margin-right:1rem}.mr-\\[10\\%\\]{margin-right:10%}.mt-16{margin-top:4rem}.mt-2{margin-top:.5rem}.mt-3{margin-top:.75rem}.mt-4{margin-top:1rem}.mt-5{margin-top:1.25rem}.mt-6{margin-top:1.5rem}.box-border{box-sizing:border-box}.block{display:block}.inline-block{display:inline-block}.flex{display:flex}.table{display:table}.grid{display:grid}.hidden{display:none}.h-0{height:0}.h-12{height:3rem}.h-14{height:3.5rem}.h-64{height:16rem}.h-8{height:2rem}.h-9{height:2.25rem}.h-\\[calc\\(100\\%_-_2px\\)\\]{height:calc(100% - 2px)}.h-full{height:100%}.h-min{height:-moz-min-content;height:min-content}.min-h-screen{min-height:100vh}.w-0{width:0}.w-20{width:5rem}.w-24{width:6rem}.w-36{width:9rem}.w-40{width:10rem}.w-8{width:2rem}.w-80{width:20rem}.w-9{width:2.25rem}.w-96{width:24rem}.w-fit{width:-moz-fit-content;width:fit-content}.w-full{width:100%}.w-min{width:-moz-min-content;width:min-content}.min-w-fit{min-width:-moz-fit-content;min-width:fit-content}.max-w-\\[75\\%\\]{max-width:75%}.max-w-full{max-width:100%}.flex-1{flex:1 1 0%}.table-auto{table-layout:auto}.origin-\\[0\\]{transform-origin:0}.-translate-y-6{--tw-translate-y:-1.5rem}.-translate-y-6,.scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.transform{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.cursor-not-allowed{cursor:not-allowed}.cursor-pointer{cursor:pointer}.\\!resize-none{resize:none!important}.resize{resize:both}.appearance-none{-webkit-appearance:none;-moz-appearance:none;appearance:none}.grid-cols-1{grid-template-columns:repeat(1,minmax(0,1fr))}.grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.flex-row{flex-direction:row}.flex-col{flex-direction:column}.flex-wrap{flex-wrap:wrap}.place-content-center{place-content:center}.place-items-center{place-items:center}.content-center{align-content:center}.items-center{align-items:center}.justify-start{justify-content:flex-start}.justify-end{justify-content:flex-end}.justify-center{justify-content:center}.justify-between{justify-content:space-between}.gap-2{gap:.5rem}.gap-3{gap:.75rem}.gap-x-6{-moz-column-gap:1.5rem;column-gap:1.5rem}.gap-y-2{row-gap:.5rem}.self-center{align-self:center}.overflow-auto{overflow:auto}.overflow-hidden{overflow:hidden}.overflow-x-hidden{overflow-x:hidden}.text-ellipsis{text-overflow:ellipsis}.text-wrap{text-wrap:wrap}.text-nowrap{text-wrap:nowrap}.rounded-full{border-radius:9999px}.rounded-lg{border-radius:.5rem}.rounded-md{border-radius:.375rem}.border{border-width:1px}.border-0{border-width:0}.border-2{border-width:2px}.border-x-2{border-left-width:2px;border-right-width:2px}.border-b-0{border-bottom-width:0}.border-b-2{border-bottom-width:2px}.border-l-2{border-left-width:2px}.border-r-0{border-right-width:0}.border-t-0{border-top-width:0}.border-t-2{border-top-width:2px}.border-dashed{border-style:dashed}.border-gray-300{--tw-border-opacity:1;border-color:rgb(209 213 219/var(--tw-border-opacity))}.bg-gray-200{--tw-bg-opacity:1;background-color:rgb(229 231 235/var(--tw-bg-opacity))}.bg-green-100{--tw-bg-opacity:1;background-color:rgb(220 252 231/var(--tw-bg-opacity))}.bg-purple-600{--tw-bg-opacity:1;background-color:rgb(147 51 234/var(--tw-bg-opacity))}.bg-red-100{--tw-bg-opacity:1;background-color:rgb(254 226 226/var(--tw-bg-opacity))}.bg-transparent{background-color:initial}.bg-opacity-100{--tw-bg-opacity:1}.bg-opacity-50{--tw-bg-opacity:.5}.bg-opacity-90{--tw-bg-opacity:.9}.p-2{padding:.5rem}.p-2\\.5{padding:.625rem}.p-3{padding:.75rem}.p-4{padding:1rem}.px-0{padding-left:0;padding-right:0}.px-1{padding-left:.25rem;padding-right:.25rem}.py-0{padding-top:0;padding-bottom:0}.py-0\\.5{padding-top:.125rem;padding-bottom:.125rem}.py-1{padding-top:.25rem;padding-bottom:.25rem}.py-1\\.5{padding-top:.375rem;padding-bottom:.375rem}.py-2{padding-top:.5rem;padding-bottom:.5rem}.py-2\\.5{padding-top:.625rem;padding-bottom:.625rem}.py-4{padding-top:1rem;padding-bottom:1rem}.pb-0{padding-bottom:0}.pb-0\\.5{padding-bottom:.125rem}.pb-2{padding-bottom:.5rem}.pt-1{padding-top:.25rem}.pt-1\\.5{padding-top:.375rem}.pt-2{padding-top:.5rem}.pt-5{padding-top:1.25rem}.text-left{text-align:left}.text-center{text-align:center}.text-right{text-align:right}.align-middle{vertical-align:middle}.text-lg{font-size:1.125rem;line-height:1.75rem}.text-sm{font-size:.875rem;line-height:1.25rem}.text-xl{font-size:1.25rem;line-height:1.75rem}.text-xs{font-size:.75rem;line-height:1rem}.font-bold{font-weight:700}.font-medium{font-weight:500}.font-semibold{font-weight:600}.\\!text-red-500{--tw-text-opacity:1!important;color:rgb(239 68 68/var(--tw-text-opacity))!important}.text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.text-gray-600{--tw-text-opacity:1;color:rgb(75 85 99/var(--tw-text-opacity))}.text-gray-900{--tw-text-opacity:1;color:rgb(17 24 39/var(--tw-text-opacity))}.text-red-500{--tw-text-opacity:1;color:rgb(239 68 68/var(--tw-text-opacity))}.opacity-100{opacity:1}.opacity-85{opacity:.85}.shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.blur{--tw-blur:blur(8px)}.blur,.drop-shadow-lg{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.drop-shadow-lg{--tw-drop-shadow:drop-shadow(0 10px 8px #0000000a) drop-shadow(0 4px 3px #0000001a)}.\\!filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)!important}.filter{filter:var(--tw-blur) var(--tw-brightness) var(--tw-contrast) var(--tw-grayscale) var(--tw-hue-rotate) var(--tw-invert) var(--tw-saturate) var(--tw-sepia) var(--tw-drop-shadow)}.transition{transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,-webkit-backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter;transition-property:color,background-color,border-color,text-decoration-color,fill,stroke,opacity,box-shadow,transform,filter,backdrop-filter,-webkit-backdrop-filter;transition-timing-function:cubic-bezier(.4,0,.2,1);transition-duration:.15s}.duration-300{transition-duration:.3s}.ease-in{transition-timing-function:cubic-bezier(.4,0,1,1)}.ease-out{transition-timing-function:cubic-bezier(0,0,.2,1)}.file\\:hidden::file-selector-button{display:none}.first\\:border-0:first-child{border-width:0}.focus\\:border-chrdblue:focus{--tw-border-opacity:1;border-color:rgb(10 70 147/var(--tw-border-opacity))}.focus\\:outline-none:focus{outline:2px solid #0000;outline-offset:2px}.focus\\:ring-0:focus{--tw-ring-offset-shadow:var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color);--tw-ring-shadow:var(--tw-ring-inset) 0 0 0 calc(var(--tw-ring-offset-width)) var(--tw-ring-color);box-shadow:var(--tw-ring-offset-shadow),var(--tw-ring-shadow),var(--tw-shadow,0 0 #0000)}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:translate-y-0{--tw-translate-y:0px;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:-moz-placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:placeholder-shown~.peer-placeholder-shown\\/inputs\\:scale-100{--tw-scale-x:1;--tw-scale-y:1;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:start-0{inset-inline-start:0}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6{--tw-translate-y:-1.5rem}.peer\\/inputs:focus~.peer-focus\\/inputs\\:-translate-y-6,.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:scale-75{--tw-scale-x:.75;--tw-scale-y:.75}.peer\\/inputs:focus~.peer-focus\\/inputs\\:text-chrdblue{--tw-text-opacity:1;color:rgb(10 70 147/var(--tw-text-opacity))}@media (min-width:640px){.sm\\:col-span-2{grid-column:span 2/span 2}.sm\\:col-span-4{grid-column:span 4/span 4}.sm\\:row-span-2{grid-row:span 2/span 2}.sm\\:mb-0{margin-bottom:0}.sm\\:mb-2{margin-bottom:.5rem}.sm\\:table-row{display:table-row}.sm\\:w-0{width:0}.sm\\:w-min{width:-moz-min-content;width:min-content}.sm\\:grid-cols-2{grid-template-columns:repeat(2,minmax(0,1fr))}.sm\\:grid-cols-4{grid-template-columns:repeat(4,minmax(0,1fr))}.sm\\:border-t-2{border-top-width:2px}.sm\\:border-none{border-style:none}.sm\\:text-center{text-align:center}.sm\\:shadow-lg{--tw-shadow:0 10px 15px -3px #0000001a,0 4px 6px -4px #0000001a;--tw-shadow-colored:0 10px 15px -3px var(--tw-shadow-color),0 4px 6px -4px var(--tw-shadow-color);box-shadow:var(--tw-ring-offset-shadow,0 0 #0000),var(--tw-ring-shadow,0 0 #0000),var(--tw-shadow)}.sm\\:first\\:border-0:first-child{border-width:0}.sm\\:first\\:border-t-2:first-child{border-top-width:2px}}@media (min-width:768px){.md\\:\\!table{display:table!important}.md\\:\\!hidden{display:none!important}.md\\:max-w-36{max-width:9rem}}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:left-auto:where([dir=rtl],[dir=rtl] *){left:auto}.peer\\/inputs:focus~.rtl\\:peer-focus\\/inputs\\:translate-x-1\\/4:where([dir=rtl],[dir=rtl] *){--tw-translate-x:25%;transform:translate(var(--tw-translate-x),var(--tw-translate-y)) rotate(var(--tw-rotate)) skew(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))}@media (prefers-color-scheme:dark){.dark\\:border-none{border-style:none}.dark\\:border-gray-600{--tw-border-opacity:1;border-color:rgb(75 85 99/var(--tw-border-opacity))}.dark\\:bg-slate-600{--tw-bg-opacity:1;background-color:rgb(71 85 105/var(--tw-bg-opacity))}.dark\\:\\!text-gray-400{--tw-text-opacity:1!important;color:rgb(156 163 175/var(--tw-text-opacity))!important}.dark\\:\\!text-red-800{--tw-text-opacity:1!important;color:rgb(153 27 27/var(--tw-text-opacity))!important}.dark\\:text-gray-300{--tw-text-opacity:1;color:rgb(209 213 219/var(--tw-text-opacity))}.dark\\:text-gray-400{--tw-text-opacity:1;color:rgb(156 163 175/var(--tw-text-opacity))}.dark\\:text-gray-500{--tw-text-opacity:1;color:rgb(107 114 128/var(--tw-text-opacity))}.dark\\:text-red-800{--tw-text-opacity:1;color:rgb(153 27 27/var(--tw-text-opacity))}.dark\\:text-white{--tw-text-opacity:1;color:rgb(255 255 255/var(--tw-text-opacity))}.dark\\:focus\\:border-chrlblue:focus{--tw-border-opacity:1;border-color:rgb(186 218 255/var(--tw-border-opacity))}.peer\\/inputs:focus~.peer-focus\\/inputs\\:dark\\:text-chrlblue{--tw-text-opacity:1;color:rgb(186 218 255/var(--tw-text-opacity))}}\n/*! tailwindcss v3.4.3 | MIT License | https://tailwindcss.com*/\n"] }]
        }], ctorParameters: () => [{ type: i1$1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }, { type: i2$3.DomSanitizer }], propDecorators: { title: [{
                type: Input
            }], text: [{
                type: Input
            }], actions: [{
                type: Input
            }], close: [{
                type: Input
            }] } });

class TabToEnterHandlerDirective {
    constructor(el) {
        this.el = el;
    }
    handleTab(event) {
        if (event.key === 'Tab') {
            const enter = new KeyboardEvent('keyup', {
                ...event,
                key: 'Enter',
                code: 'Enter',
                bubbles: true,
                keyCode: 13,
            });
            event.target?.dispatchEvent(enter);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TabToEnterHandlerDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.5", type: TabToEnterHandlerDirective, isStandalone: true, selector: "[tab-enter]", host: { listeners: { "keydown": "handleTab($event)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TabToEnterHandlerDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tab-enter]',
                    standalone: true,
                }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { handleTab: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }] } });

const inOutAnimation = (duration = 500) => trigger('inOutAnimation', [
    transition(':enter', [
        style({ opacity: 0 }),
        animate(`${duration}ms ease-out`, style({ opacity: 1 })),
    ]),
    transition(':leave', [
        style({ opacity: 1 }),
        animate(`${duration}ms ease-in`, style({ opacity: 0 })),
    ]),
]);

class DialogService {
    constructor(dialog) {
        this.dialog = dialog;
        this.openDelete = (callback, ...elements) => {
            const dialogRef = this.open(ChrDeleteModalComponent);
            dialogRef.afterClosed().subscribe((result) => {
                if (result == true)
                    callback?.(...elements);
            });
        };
        this.openDefault = (config) => {
            const cfg = {
                ...config?.config,
                data: {
                    ...config?.config?.data,
                    _config: {
                        title: config?.title,
                        text: config?.text,
                        close: config?.close,
                        actions: config?.actions,
                    },
                },
            };
            const dialogRef = this.open(ChrDefaultModalComponent, cfg);
        };
        this.open = (component, options) => {
            return this.dialog.open(component, options);
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: DialogService, deps: [{ token: i1$1.MatDialog }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: DialogService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: DialogService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: () => [{ type: i1$1.MatDialog }] });

/*
 * Public API Surface of chr-components
 */
//COMPONENTS

/**
 * Generated bundle index. Do not edit.
 */

export { Aligments, AutofocusDirective, BreadcrumbComponent, ChrBaseInputComponent, ChrButtonComponent, ChrCheckboxComponent, ChrColorInputComponent, ChrDataTable, ChrDateInputComponent, ChrDatetimeInputComponent, ChrDefaultModalComponent, ChrDeleteModalComponent, ChrFileInputComponent, ChrFormComponent, ChrNiceFileInputComponent, ChrPaginatorComponent, ChrSearchSelectComponent, ChrSearchbarComponent, ChrSeparatorComponent, ChrSpinnerComponent, ChrTableComponent, ChrTableHeaderCellComponent, ChrTagSelectComponent, ChrTextareaInputComponent, ChrToastComponent, ChrToggleInputComponent, Colors, CookiesService, DEFAULTLIVEUPDATEMESSAGE, DataService, DecimalValidatorDirective, DefaultLiveUpdateMessage, DialogService, FileService, HUBURL, LiveUpdateService, LiveUpdateStatus, LoaderService, MaxDateValidatorDirective, SpinnerInterceptor, SyncValidatorToAsync, TabToEnterHandlerDirective, TabToInputHandlerDirective, ToastService, TypeValidatorDirective, WaitAndStoreXsrfToken, XSRFCOOKIENAME, XSRFHEADERNAME, XsrfInterceptor, decimal, getAsyncValidators, getBackgroundColor, getBorderColor, getContrastBackgroundColor, getContrastBorderColor, getContrastTextColor, getSyncValidators, getTextColor, getValidators, inOutAnimation, maxDate, provideXsrfHttpClient, rotationAnimation, type };
//# sourceMappingURL=chrv-components.mjs.map
